/**
 * Yonius 0.7.3.
 *
 * Copyright (c) 2008-2021 Hive Solutions Lda.
 *
 * This source code is licensed under the Apache 2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.yonius = {}));
}(this, (function (exports) { 'use strict';

    var name = "yonius";
    var version$1 = "0.7.3";

    function _typeof(obj) {
      "@babel/helpers - typeof";

      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function (obj) {
          return typeof obj;
        };
      } else {
        _typeof = function (obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }

      return _typeof(obj);
    }

    function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
      try {
        var info = gen[key](arg);
        var value = info.value;
      } catch (error) {
        reject(error);
        return;
      }

      if (info.done) {
        resolve(value);
      } else {
        Promise.resolve(value).then(_next, _throw);
      }
    }

    function _asyncToGenerator(fn) {
      return function () {
        var self = this,
            args = arguments;
        return new Promise(function (resolve, reject) {
          var gen = fn.apply(self, args);

          function _next(value) {
            asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
          }

          function _throw(err) {
            asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
          }

          _next(undefined);
        });
      };
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);
      if (staticProps) _defineProperties(Constructor, staticProps);
      return Constructor;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, {
          value: value,
          enumerable: true,
          configurable: true,
          writable: true
        });
      } else {
        obj[key] = value;
      }

      return obj;
    }

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);

      if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });
        keys.push.apply(keys, symbols);
      }

      return keys;
    }

    function _objectSpread2(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};

        if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }

      return target;
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }

      subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
          value: subClass,
          writable: true,
          configurable: true
        }
      });
      if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };
      return _getPrototypeOf(o);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
      };

      return _setPrototypeOf(o, p);
    }

    function _isNativeReflectConstruct() {
      if (typeof Reflect === "undefined" || !Reflect.construct) return false;
      if (Reflect.construct.sham) return false;
      if (typeof Proxy === "function") return true;

      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
        return true;
      } catch (e) {
        return false;
      }
    }

    function _construct(Parent, args, Class) {
      if (_isNativeReflectConstruct()) {
        _construct = Reflect.construct;
      } else {
        _construct = function _construct(Parent, args, Class) {
          var a = [null];
          a.push.apply(a, args);
          var Constructor = Function.bind.apply(Parent, a);
          var instance = new Constructor();
          if (Class) _setPrototypeOf(instance, Class.prototype);
          return instance;
        };
      }

      return _construct.apply(null, arguments);
    }

    function _isNativeFunction(fn) {
      return Function.toString.call(fn).indexOf("[native code]") !== -1;
    }

    function _wrapNativeSuper(Class) {
      var _cache = typeof Map === "function" ? new Map() : undefined;

      _wrapNativeSuper = function _wrapNativeSuper(Class) {
        if (Class === null || !_isNativeFunction(Class)) return Class;

        if (typeof Class !== "function") {
          throw new TypeError("Super expression must either be null or a function");
        }

        if (typeof _cache !== "undefined") {
          if (_cache.has(Class)) return _cache.get(Class);

          _cache.set(Class, Wrapper);
        }

        function Wrapper() {
          return _construct(Class, arguments, _getPrototypeOf(this).constructor);
        }

        Wrapper.prototype = Object.create(Class.prototype, {
          constructor: {
            value: Wrapper,
            enumerable: false,
            writable: true,
            configurable: true
          }
        });
        return _setPrototypeOf(Wrapper, Class);
      };

      return _wrapNativeSuper(Class);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }

      return self;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (typeof call === "object" || typeof call === "function")) {
        return call;
      }

      return _assertThisInitialized(self);
    }

    function _createSuper(Derived) {
      var hasNativeReflectConstruct = _isNativeReflectConstruct();

      return function _createSuperInternal() {
        var Super = _getPrototypeOf(Derived),
            result;

        if (hasNativeReflectConstruct) {
          var NewTarget = _getPrototypeOf(this).constructor;

          result = Reflect.construct(Super, arguments, NewTarget);
        } else {
          result = Super.apply(this, arguments);
        }

        return _possibleConstructorReturn(this, result);
      };
    }

    function _superPropBase(object, property) {
      while (!Object.prototype.hasOwnProperty.call(object, property)) {
        object = _getPrototypeOf(object);
        if (object === null) break;
      }

      return object;
    }

    function _get(target, property, receiver) {
      if (typeof Reflect !== "undefined" && Reflect.get) {
        _get = Reflect.get;
      } else {
        _get = function _get(target, property, receiver) {
          var base = _superPropBase(target, property);

          if (!base) return;
          var desc = Object.getOwnPropertyDescriptor(base, property);

          if (desc.get) {
            return desc.get.call(receiver);
          }

          return desc.value;
        };
      }

      return _get(target, property, receiver || target);
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
    }

    function _toArray(arr) {
      return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest();
    }

    function _toConsumableArray(arr) {
      return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
    }

    function _arrayWithoutHoles(arr) {
      if (Array.isArray(arr)) return _arrayLikeToArray(arr);
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function _iterableToArray(iter) {
      if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
    }

    function _iterableToArrayLimit(arr, i) {
      if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
      var _arr = [];
      var _n = true;
      var _d = false;
      var _e = undefined;

      try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);

          if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;
        _e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }

      return _arr;
    }

    function _unsupportedIterableToArray(o, minLen) {
      if (!o) return;
      if (typeof o === "string") return _arrayLikeToArray(o, minLen);
      var n = Object.prototype.toString.call(o).slice(8, -1);
      if (n === "Object" && o.constructor) n = o.constructor.name;
      if (n === "Map" || n === "Set") return Array.from(o);
      if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
    }

    function _arrayLikeToArray(arr, len) {
      if (len == null || len > arr.length) len = arr.length;

      for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

      return arr2;
    }

    function _nonIterableSpread() {
      throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }

    function _createForOfIteratorHelper(o, allowArrayLike) {
      var it;

      if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
        if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
          if (it) o = it;
          var i = 0;

          var F = function () {};

          return {
            s: F,
            n: function () {
              if (i >= o.length) return {
                done: true
              };
              return {
                done: false,
                value: o[i++]
              };
            },
            e: function (e) {
              throw e;
            },
            f: F
          };
        }

        throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
      }

      var normalCompletion = true,
          didErr = false,
          err;
      return {
        s: function () {
          it = o[Symbol.iterator]();
        },
        n: function () {
          var step = it.next();
          normalCompletion = step.done;
          return step;
        },
        e: function (e) {
          didErr = true;
          err = e;
        },
        f: function () {
          try {
            if (!normalCompletion && it.return != null) it.return();
          } finally {
            if (didErr) throw err;
          }
        }
      };
    }

    var Observable = /*#__PURE__*/function () {
      function Observable() {
        _classCallCheck(this, Observable);

        this.callbacks = {};
      }

      _createClass(Observable, [{
        key: "bind",
        value: function bind(event, callback) {
          var callbacks = this.callbacks[event] || [];
          callbacks.push(callback);
          this.callbacks[event] = callbacks;
          return callback;
        }
      }, {
        key: "unbind",
        value: function unbind(event, callback) {
          var callbacks = this.callbacks[event] || [];

          if (!callback) {
            delete this.callbacks[event];
            return;
          }

          var index = callbacks.indexOf(callback);

          if (index === -1) {
            return;
          }

          callbacks.splice(index, 1);
          this.callbacks[event] = callbacks;
        }
      }, {
        key: "trigger",
        value: function trigger(event) {
          var callbacks = this.callbacks[event] || [];
          var results = [];

          var _iterator = _createForOfIteratorHelper(callbacks),
              _step;

          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var callback = _step.value;
              var result = callback.apply(this, Array.prototype.slice.call(arguments, 1));
              result !== undefined && result !== null && results.push(result);
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }

          return Promise.all(results);
        }
      }]);

      return Observable;
    }();

    var verify = function verify(condition) {
      var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var code = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var exception = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var kwargs = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
      if (condition) return;
      message = message || "Verification failed";
      var Exception = exception || Error;
      kwargs = Object.assign({}, kwargs);
      if (message !== null && message !== undefined) kwargs.message = message;
      if (code !== null && message !== undefined) kwargs.code = code;
      var throwable = new Exception(kwargs.message || undefined);
      throwable.kwargs = kwargs;

      for (var _i = 0, _Object$entries = Object.entries(kwargs); _i < _Object$entries.length; _i++) {
        var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2),
            key = _Object$entries$_i[0],
            value = _Object$entries$_i[1];

        if (throwable[key] !== undefined) continue;
        throwable[key] = value;
      }

      throw throwable;
    };
    var verifyEqual = function verifyEqual(first, second) {
      var message = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var code = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var exception = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
      var kwargs = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
      message = message || "Expected ".concat(first, " got ").concat(second);
      return this.verify(first === second, message, code, exception, kwargs);
    };
    var verifyNotEqual = function verifyNotEqual(first, second) {
      var message = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var code = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var exception = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
      var kwargs = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
      message = message || "Expected ".concat(first, " not equal to ").concat(second);
      return this.verify(first !== second, message, code, exception, kwargs);
    };
    var verifyMany = function verifyMany(sequence) {
      var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var code = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var exception = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var kwargs = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
      sequence.forEach(function (element) {
        verify(element, message, code, exception, kwargs);
      });
    };

    const promises = {};

    // Copyright Joyent, Inc. and other Node contributors.
    //
    // Permission is hereby granted, free of charge, to any person obtaining a
    // copy of this software and associated documentation files (the
    // "Software"), to deal in the Software without restriction, including
    // without limitation the rights to use, copy, modify, merge, publish,
    // distribute, sublicense, and/or sell copies of the Software, and to permit
    // persons to whom the Software is furnished to do so, subject to the
    // following conditions:
    //
    // The above copyright notice and this permission notice shall be included
    // in all copies or substantial portions of the Software.
    //
    // THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
    // OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    // MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
    // NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
    // DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
    // OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
    // USE OR OTHER DEALINGS IN THE SOFTWARE.
    // resolves . and .. elements in a path array with directory names there
    // must be no slashes, empty elements, or device names (c:\) in the array
    // (so also no leading and trailing slashes - it does not distinguish
    // relative and absolute paths)
    function normalizeArray(parts, allowAboveRoot) {
      // if the path tries to go above the root, `up` ends up > 0
      var up = 0;

      for (var i = parts.length - 1; i >= 0; i--) {
        var last = parts[i];

        if (last === '.') {
          parts.splice(i, 1);
        } else if (last === '..') {
          parts.splice(i, 1);
          up++;
        } else if (up) {
          parts.splice(i, 1);
          up--;
        }
      } // if the path is allowed to go above the root, restore leading ..s


      if (allowAboveRoot) {
        for (; up--; up) {
          parts.unshift('..');
        }
      }

      return parts;
    } // Split a filename into [root, dir, basename, ext], unix version
    // 'root' is just a slash, or nothing.


    var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;

    var splitPath = function splitPath(filename) {
      return splitPathRe.exec(filename).slice(1);
    }; // path.resolve([from ...], to)
    // posix version


    function resolve() {
      var resolvedPath = '',
          resolvedAbsolute = false;

      for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
        var path = i >= 0 ? arguments[i] : '/'; // Skip empty and invalid entries

        if (typeof path !== 'string') {
          throw new TypeError('Arguments to path.resolve must be strings');
        } else if (!path) {
          continue;
        }

        resolvedPath = path + '/' + resolvedPath;
        resolvedAbsolute = path.charAt(0) === '/';
      } // At this point the path should be resolved to a full absolute path, but
      // handle relative paths to be safe (might happen when process.cwd() fails)
      // Normalize the path


      resolvedPath = normalizeArray(filter(resolvedPath.split('/'), function (p) {
        return !!p;
      }), !resolvedAbsolute).join('/');
      return (resolvedAbsolute ? '/' : '') + resolvedPath || '.';
    }
    // posix version

    function normalize(path) {
      var isPathAbsolute = isAbsolute(path),
          trailingSlash = substr(path, -1) === '/'; // Normalize the path

      path = normalizeArray(filter(path.split('/'), function (p) {
        return !!p;
      }), !isPathAbsolute).join('/');

      if (!path && !isPathAbsolute) {
        path = '.';
      }

      if (path && trailingSlash) {
        path += '/';
      }

      return (isPathAbsolute ? '/' : '') + path;
    }

    function isAbsolute(path) {
      return path.charAt(0) === '/';
    } // posix version

    function join() {
      var paths = Array.prototype.slice.call(arguments, 0);
      return normalize(filter(paths, function (p, index) {
        if (typeof p !== 'string') {
          throw new TypeError('Arguments to path.join must be strings');
        }

        return p;
      }).join('/'));
    } // path.relative(from, to)
    function dirname(path) {
      var result = splitPath(path),
          root = result[0],
          dir = result[1];

      if (!root && !dir) {
        // No dirname whatsoever
        return '.';
      }

      if (dir) {
        // It has a dirname, strip trailing slash
        dir = dir.substr(0, dir.length - 1);
      }

      return root + dir;
    }

    function filter(xs, f) {
      if (xs.filter) return xs.filter(f);
      var res = [];

      for (var i = 0; i < xs.length; i++) {
        if (f(xs[i], i, xs)) res.push(xs[i]);
      }

      return res;
    } // String.prototype.substr - negative index don't work in IE8


    var substr = 'ab'.substr(-1) === 'b' ? function (str, start, len) {
      return str.substr(start, len);
    } : function (str, start, len) {
      if (start < 0) start = str.length + start;
      return str.substr(start, len);
    };

    var global$1 = typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {};

    // based off https://github.com/defunctzombie/node-process/blob/master/browser.js

    function defaultSetTimout() {
      throw new Error('setTimeout has not been defined');
    }

    function defaultClearTimeout() {
      throw new Error('clearTimeout has not been defined');
    }

    var cachedSetTimeout = defaultSetTimout;
    var cachedClearTimeout = defaultClearTimeout;

    if (typeof global$1.setTimeout === 'function') {
      cachedSetTimeout = setTimeout;
    }

    if (typeof global$1.clearTimeout === 'function') {
      cachedClearTimeout = clearTimeout;
    }

    function runTimeout(fun) {
      if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
      } // if setTimeout wasn't available but was latter defined


      if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
      }

      try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
      } catch (e) {
        try {
          // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
          return cachedSetTimeout.call(null, fun, 0);
        } catch (e) {
          // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
          return cachedSetTimeout.call(this, fun, 0);
        }
      }
    }

    function runClearTimeout(marker) {
      if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
      } // if clearTimeout wasn't available but was latter defined


      if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
      }

      try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
      } catch (e) {
        try {
          // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
          return cachedClearTimeout.call(null, marker);
        } catch (e) {
          // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
          // Some versions of I.E. have different rules for clearTimeout vs setTimeout
          return cachedClearTimeout.call(this, marker);
        }
      }
    }

    var queue = [];
    var draining = false;
    var currentQueue;
    var queueIndex = -1;

    function cleanUpNextTick() {
      if (!draining || !currentQueue) {
        return;
      }

      draining = false;

      if (currentQueue.length) {
        queue = currentQueue.concat(queue);
      } else {
        queueIndex = -1;
      }

      if (queue.length) {
        drainQueue();
      }
    }

    function drainQueue() {
      if (draining) {
        return;
      }

      var timeout = runTimeout(cleanUpNextTick);
      draining = true;
      var len = queue.length;

      while (len) {
        currentQueue = queue;
        queue = [];

        while (++queueIndex < len) {
          if (currentQueue) {
            currentQueue[queueIndex].run();
          }
        }

        queueIndex = -1;
        len = queue.length;
      }

      currentQueue = null;
      draining = false;
      runClearTimeout(timeout);
    }

    function nextTick(fun) {
      var args = new Array(arguments.length - 1);

      if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
          args[i - 1] = arguments[i];
        }
      }

      queue.push(new Item(fun, args));

      if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
      }
    } // v8 likes predictible objects


    function Item(fun, array) {
      this.fun = fun;
      this.array = array;
    }

    Item.prototype.run = function () {
      this.fun.apply(null, this.array);
    };

    var title = 'browser';
    var platform = 'browser';
    var browser = true;
    var env = {};
    var argv = [];
    var version = ''; // empty string to avoid regexp issues

    var versions = {};
    var release = {};
    var config = {};

    function noop() {}

    var on = noop;
    var addListener = noop;
    var once = noop;
    var off = noop;
    var removeListener = noop;
    var removeAllListeners = noop;
    var emit = noop;

    function binding(name) {
      throw new Error('process.binding is not supported');
    }

    function cwd() {
      return '/';
    }

    function chdir(dir) {
      throw new Error('process.chdir is not supported');
    }

    function umask() {
      return 0;
    } // from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js


    var performance = global$1.performance || {};

    var performanceNow = performance.now || performance.mozNow || performance.msNow || performance.oNow || performance.webkitNow || function () {
      return new Date().getTime();
    }; // generate timestamp or delta
    // see http://nodejs.org/api/process.html#process_process_hrtime


    function hrtime(previousTimestamp) {
      var clocktime = performanceNow.call(performance) * 1e-3;
      var seconds = Math.floor(clocktime);
      var nanoseconds = Math.floor(clocktime % 1 * 1e9);

      if (previousTimestamp) {
        seconds = seconds - previousTimestamp[0];
        nanoseconds = nanoseconds - previousTimestamp[1];

        if (nanoseconds < 0) {
          seconds--;
          nanoseconds += 1e9;
        }
      }

      return [seconds, nanoseconds];
    }

    var startTime = new Date();

    function uptime() {
      var currentTime = new Date();
      var dif = currentTime - startTime;
      return dif / 1000;
    }

    var browser$1 = {
      nextTick: nextTick,
      title: title,
      browser: browser,
      env: env,
      argv: argv,
      version: version,
      versions: versions,
      on: on,
      addListener: addListener,
      once: once,
      off: off,
      removeListener: removeListener,
      removeAllListeners: removeAllListeners,
      emit: emit,
      binding: binding,
      cwd: cwd,
      chdir: chdir,
      umask: umask,
      hrtime: hrtime,
      platform: platform,
      release: release,
      config: config,
      uptime: uptime
    };

    var HOME_DIR = null;
    var pathExists = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(path) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                _context.next = 3;
                return promises.access(path);

              case 3:
                _context.next = 8;
                break;

              case 5:
                _context.prev = 5;
                _context.t0 = _context["catch"](0);
                return _context.abrupt("return", false);

              case 8:
                return _context.abrupt("return", true);

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[0, 5]]);
      }));

      return function pathExists(_x) {
        return _ref.apply(this, arguments);
      };
    }();
    var expandUser = function expandUser(path) {
      if (!path) return path;
      if (path === "~") return _homeDir();
      if (path.slice(0, 2) !== "~/") return path;
      return join(HOME_DIR, path.slice(2));
    };
    var getEnv = function getEnv(name) {
      // eslint-disable-next-line no-undef
      if (typeof Deno !== "undefined") return Deno.env.get(name);
      return env[name];
    };
    var getEnvObject = function getEnvObject() {
      // eslint-disable-next-line no-undef
      if (typeof Deno !== "undefined") return Deno.env.toObject();
      return env;
    };

    var _homeDir = function _homeDir() {
      if (HOME_DIR !== null) return HOME_DIR;
      var isWindows = Boolean(typeof process !== "undefined" && process.platform === "win32");
      HOME_DIR = getEnv(isWindows ? "USERPROFILE" : "HOME") || "/";
      return HOME_DIR;
    };

    var FILE_NAME = "yonius.json";
    var HOME_FILE = "~/.home";
    var IMPORT_NAMES = ["$import", "$include", "$IMPORT", "$INCLUDE"];
    var CASTS = {
      "int": function int(v) {
        return typeof v === "number" ? v : parseInt(v);
      },
      "float": function float(v) {
        return typeof v === "number" ? v : parseFloat(v);
      },
      bool: function bool(v) {
        return typeof v === "boolean" ? v : ["1", "true", "True"].includes(v);
      },
      list: function list(v) {
        return Array.isArray(v) ? v : v.split(";");
      },
      tuple: function tuple(v) {
        return Array.isArray(v) ? v : v.split(";");
      }
    };
    var globals = typeof global === "undefined" ? typeof window === "undefined" ? typeof self === "undefined" ? {} : self : window : global;
    globals.CONFIGS = globals.CONFIGS === undefined ? {} : globals.CONFIGS;
    globals.CONFIG_F = globals.CONFIG_F === undefined ? [] : globals.CONFIG_F;
    globals.HOMES = globals.HOMES === undefined ? [] : globals.HOMES;
    globals.LOADED = globals.LOADED === undefined ? false : globals.LOADED;
    var conf = function conf(name) {
      var fallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;
      var cast = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var ctx = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var configs = ctx ? ctx.configs : globals.CONFIGS;
      cast = _castR(cast);
      var value = configs[name] === undefined ? fallback : configs[name];
      if (cast && value !== undefined && value !== null) value = cast(value);
      return value;
    };
    var confP = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(name) {
        var fallback,
            cast,
            ctx,
            _args = arguments;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                fallback = _args.length > 1 && _args[1] !== undefined ? _args[1] : undefined;
                cast = _args.length > 2 && _args[2] !== undefined ? _args[2] : null;
                ctx = _args.length > 3 && _args[3] !== undefined ? _args[3] : null;
                _context.next = 5;
                return load$1();

              case 5:
                return _context.abrupt("return", conf(name, fallback, cast, ctx));

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function confP(_x) {
        return _ref.apply(this, arguments);
      };
    }();
    var confS = function confS(name, value) {
      var ctx = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var configs = ctx ? ctx.configs : globals.CONFIGS;
      configs[name] = value;
    };
    var load$1 = /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var names,
            path,
            encoding,
            force,
            ctx,
            paths,
            homes,
            _iterator,
            _step,
            home,
            _iterator2,
            _step2,
            _path,
            _iterator3,
            _step3,
            name,
            _args2 = arguments;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                names = _args2.length > 0 && _args2[0] !== undefined ? _args2[0] : [FILE_NAME];
                path = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : null;
                encoding = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : "utf-8";
                force = _args2.length > 3 && _args2[3] !== undefined ? _args2[3] : false;
                ctx = _args2.length > 4 && _args2[4] !== undefined ? _args2[4] : null;

                if (!(globals.LOADED && !force)) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt("return");

              case 7:
                paths = [];
                _context2.next = 10;
                return getHomes();

              case 10:
                homes = _context2.sent;
                _iterator = _createForOfIteratorHelper(homes);

                try {
                  for (_iterator.s(); !(_step = _iterator.n()).done;) {
                    home = _step.value;
                    paths = paths.concat([join(home), join(home, ".config")]);
                  }
                } catch (err) {
                  _iterator.e(err);
                } finally {
                  _iterator.f();
                }

                paths.push(path);
                _iterator2 = _createForOfIteratorHelper(paths);
                _context2.prev = 15;

                _iterator2.s();

              case 17:
                if ((_step2 = _iterator2.n()).done) {
                  _context2.next = 38;
                  break;
                }

                _path = _step2.value;
                _iterator3 = _createForOfIteratorHelper(names);
                _context2.prev = 20;

                _iterator3.s();

              case 22:
                if ((_step3 = _iterator3.n()).done) {
                  _context2.next = 28;
                  break;
                }

                name = _step3.value;
                _context2.next = 26;
                return loadFile(name, _path, encoding, ctx);

              case 26:
                _context2.next = 22;
                break;

              case 28:
                _context2.next = 33;
                break;

              case 30:
                _context2.prev = 30;
                _context2.t0 = _context2["catch"](20);

                _iterator3.e(_context2.t0);

              case 33:
                _context2.prev = 33;

                _iterator3.f();

                return _context2.finish(33);

              case 36:
                _context2.next = 17;
                break;

              case 38:
                _context2.next = 43;
                break;

              case 40:
                _context2.prev = 40;
                _context2.t1 = _context2["catch"](15);

                _iterator2.e(_context2.t1);

              case 43:
                _context2.prev = 43;

                _iterator2.f();

                return _context2.finish(43);

              case 46:
                _context2.next = 48;
                return loadEnv(ctx);

              case 48:
                globals.LOADED = true;

              case 49:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, null, [[15, 40, 43, 46], [20, 30, 33, 36]]);
      }));

      return function load() {
        return _ref2.apply(this, arguments);
      };
    }();
    var loadFile = /*#__PURE__*/function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var name,
            path,
            encoding,
            ctx,
            configs,
            configF,
            key,
            value,
            exists,
            filePath,
            basePath,
            data,
            dataJ,
            _i,
            _Object$entries,
            _Object$entries$_i,
            _args3 = arguments;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                name = _args3.length > 0 && _args3[0] !== undefined ? _args3[0] : FILE_NAME;
                path = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : null;
                encoding = _args3.length > 2 && _args3[2] !== undefined ? _args3[2] : "utf-8";
                ctx = _args3.length > 3 && _args3[3] !== undefined ? _args3[3] : null;
                configs = ctx ? ctx.configs : globals.CONFIGS;
                configF = ctx ? ctx.configF : globals.CONFIG_F;
                if (path) path = normalize(path);
                if (path) filePath = join(path, name);else filePath = name;
                filePath = resolve(filePath);
                filePath = normalize(filePath);
                basePath = dirname(filePath);
                _context3.next = 13;
                return pathExists(filePath);

              case 13:
                exists = _context3.sent;

                if (exists) {
                  _context3.next = 16;
                  break;
                }

                return _context3.abrupt("return");

              case 16:
                exists = configF.includes(filePath);
                if (exists) configF.splice(configF.indexOf(filePath), 1);
                configF.push(filePath);
                _context3.next = 21;
                return promises.readFile(filePath, {
                  encoding: encoding
                });

              case 21:
                data = _context3.sent;
                dataJ = JSON.parse(data);
                _context3.next = 25;
                return _loadIncludes(basePath, dataJ, encoding);

              case 25:
                _i = 0, _Object$entries = Object.entries(dataJ);

              case 26:
                if (!(_i < _Object$entries.length)) {
                  _context3.next = 36;
                  break;
                }

                _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2);
                key = _Object$entries$_i[0];
                value = _Object$entries$_i[1];

                if (_isValid(key)) {
                  _context3.next = 32;
                  break;
                }

                return _context3.abrupt("continue", 33);

              case 32:
                configs[key] = value;

              case 33:
                _i++;
                _context3.next = 26;
                break;

              case 36:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      return function loadFile() {
        return _ref3.apply(this, arguments);
      };
    }();
    var loadEnv = /*#__PURE__*/function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var ctx,
            env,
            configs,
            _args4 = arguments;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                ctx = _args4.length > 0 && _args4[0] !== undefined ? _args4[0] : null;
                env = getEnvObject();
                configs = ctx ? ctx.configs : globals.CONFIGS;

                if (!(env === undefined || env === null)) {
                  _context4.next = 5;
                  break;
                }

                return _context4.abrupt("return");

              case 5:
                Object.entries(env).forEach(function (_ref5) {
                  var _ref6 = _slicedToArray(_ref5, 2),
                      key = _ref6[0],
                      value = _ref6[1];

                  configs[key] = value;
                });

              case 6:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      return function loadEnv() {
        return _ref4.apply(this, arguments);
      };
    }();
    var getHomes = /*#__PURE__*/function () {
      var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
        var filePath,
            fallback,
            encoding,
            forceDefault,
            env,
            exists,
            data,
            paths,
            _iterator4,
            _step4,
            path,
            _args5 = arguments;

        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                filePath = _args5.length > 0 && _args5[0] !== undefined ? _args5[0] : HOME_FILE;
                fallback = _args5.length > 1 && _args5[1] !== undefined ? _args5[1] : "~";
                encoding = _args5.length > 2 && _args5[2] !== undefined ? _args5[2] : "utf-8";
                forceDefault = _args5.length > 3 && _args5[3] !== undefined ? _args5[3] : false;

                if (!(globals.HOMES.length > 0)) {
                  _context5.next = 6;
                  break;
                }

                return _context5.abrupt("return", globals.HOMES);

              case 6:
                env = getEnvObject();
                globals.HOMES = env.HOMES === undefined ? null : env.HOMES;
                globals.HOMES = globals.HOMES ? globals.HOMES.split(";") : globals.HOMES;

                if (!(globals.HOMES !== null)) {
                  _context5.next = 11;
                  break;
                }

                return _context5.abrupt("return", globals.HOMES);

              case 11:
                fallback = expandUser(fallback);
                fallback = normalize(fallback);
                globals.HOMES = [fallback];
                filePath = expandUser(filePath);
                filePath = normalize(filePath);
                _context5.next = 18;
                return pathExists(filePath);

              case 18:
                exists = _context5.sent;

                if (exists) {
                  _context5.next = 21;
                  break;
                }

                return _context5.abrupt("return", globals.HOMES);

              case 21:
                if (!forceDefault) globals.HOMES.splice(0, globals.HOMES.length);
                _context5.next = 24;
                return promises.readFile(filePath, {
                  encoding: encoding
                });

              case 24:
                data = _context5.sent;
                data = data.trim();
                paths = data.split(/\r?\n/);
                paths = paths.map(function (v) {
                  return v.trim();
                });
                _iterator4 = _createForOfIteratorHelper(paths);
                _context5.prev = 29;

                _iterator4.s();

              case 31:
                if ((_step4 = _iterator4.n()).done) {
                  _context5.next = 41;
                  break;
                }

                path = _step4.value;
                path = path.trim();

                if (path) {
                  _context5.next = 36;
                  break;
                }

                return _context5.abrupt("continue", 39);

              case 36:
                path = expandUser(path);
                path = normalize(path);
                globals.HOMES.push(path);

              case 39:
                _context5.next = 31;
                break;

              case 41:
                _context5.next = 46;
                break;

              case 43:
                _context5.prev = 43;
                _context5.t0 = _context5["catch"](29);

                _iterator4.e(_context5.t0);

              case 46:
                _context5.prev = 46;

                _iterator4.f();

                return _context5.finish(46);

              case 49:
                return _context5.abrupt("return", globals.HOMES);

              case 50:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, null, [[29, 43, 46, 49]]);
      }));

      return function getHomes() {
        return _ref7.apply(this, arguments);
      };
    }();
    var _castR = function _castR(cast) {
      return CASTS[cast] === undefined ? cast : CASTS[cast];
    };
    var _loadIncludes = /*#__PURE__*/function () {
      var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(basePath, config) {
        var encoding,
            includes,
            _iterator5,
            _step5,
            alias,
            _iterator6,
            _step6,
            include,
            _args6 = arguments;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                encoding = _args6.length > 2 && _args6[2] !== undefined ? _args6[2] : "utf-8";
                includes = [];
                _iterator5 = _createForOfIteratorHelper(IMPORT_NAMES);

                try {
                  for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
                    alias = _step5.value;
                    includes = config[alias] === undefined ? includes : config[alias];
                  }
                } catch (err) {
                  _iterator5.e(err);
                } finally {
                  _iterator5.f();
                }

                if (typeof includes === "string") {
                  includes = includes.split(";");
                }

                _iterator6 = _createForOfIteratorHelper(includes);
                _context6.prev = 6;

                _iterator6.s();

              case 8:
                if ((_step6 = _iterator6.n()).done) {
                  _context6.next = 14;
                  break;
                }

                include = _step6.value;
                _context6.next = 12;
                return loadFile(include, basePath, encoding);

              case 12:
                _context6.next = 8;
                break;

              case 14:
                _context6.next = 19;
                break;

              case 16:
                _context6.prev = 16;
                _context6.t0 = _context6["catch"](6);

                _iterator6.e(_context6.t0);

              case 19:
                _context6.prev = 19;

                _iterator6.f();

                return _context6.finish(19);

              case 22:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, null, [[6, 16, 19, 22]]);
      }));

      return function _loadIncludes(_x2, _x3) {
        return _ref8.apply(this, arguments);
      };
    }();
    var _isValid = function _isValid(key) {
      if (IMPORT_NAMES.includes(key)) return false;
      return true;
    };
    var _isDevel = function _isDevel() {
      return ["DEBUG"].includes(conf("LEVEL", "INFO"));
    };
    var _isSecure = function _isSecure() {
      return conf("SECURE", true, "bool");
    };

    /**
     * The map containing the various attribute alias between the normalized
     * manned and the Yonius manner.
     */
    var ALIAS = {
      context: "find_d",
      filters: "find_d",
      "filters[]": "find_d",
      filter_def: "find_d",
      filter_string: "find_s",
      filter_name: "find_n",
      filter_operator: "find_o",
      insensitive: "find_i",
      order: "sort",
      offset: "skip",
      start_record: "skip",
      number_records: "limit"
    };
    /**
     * The map associating the various find fields with their respective
     * types, note that in case a special conversion operation is required
     * the associated value may represent a conversion function instead.
     */

    var FIND_TYPES = {
      skip: function skip(v) {
        return parseInt(v);
      },
      limit: function limit(v) {
        return Math.max(0, parseInt(v));
      },
      find_s: function find_s(v) {
        return v;
      },
      find_d: function find_d(v) {
        return Array.isArray(v) ? v : [v];
      },
      find_i: function find_i(v) {
        return Boolean(v);
      },
      find_t: function find_t(v) {
        return v;
      },
      find_n: function find_n(v) {
        return v;
      },
      find_o: function find_o(v) {
        return v;
      },
      sort: function sort(v) {
        return _toSort(v);
      },
      meta: function meta(v) {
        return Boolean(v);
      },
      fields: function fields(v) {
        return v;
      }
    };
    /**
     * The map that defines the various default values for a series of
     * find related attributes.
     */

    var FIND_DEFAULTS = {
      limit: 10
    };
    /**
     * The map associating the normalized (text) way of representing sorting
     * with the current infra-structure number way of representing the same
     * information.
     */

    var SORT_MAP = {
      1: 1,
      "-1": -1,
      ascending: 1,
      descending: -1
    };
    var getObject = function getObject() {
      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var _options$alias = options.alias,
          alias = _options$alias === void 0 ? false : _options$alias,
          _options$page = options.page,
          page = _options$page === void 0 ? false : _options$page,
          _options$find = options.find,
          find = _options$find === void 0 ? false : _options$find,
          _options$norm = options.norm,
          norm = _options$norm === void 0 ? true : _options$norm;
      var result = params; // in case the alias flag is set tries to resolve the attribute alias and
      // in case the find types are set converts the find based attributes using
      // the currently defined mapping map

      if (alias) result = _resolveAlias(result);
      if (page) result = _pageTypes(result);

      if (find) {
        result = _findTypes(result);
        result = _findDefaults(result, options);
      } // in case the normalization flag is set runs the normalization of the
      // provided object so that sequences are properly handled as defined in
      // the specification (this allows multiple references)


      if (norm) result = _normParams(result); // returns the constructed object to the caller method this object
      // should be a structured representation of the data in the request

      return result;
    };

    var _resolveAlias = function _resolveAlias(params) {
      var result = {};
      Object.entries(params).forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            key = _ref2[0],
            value = _ref2[1];

        result[ALIAS[key] || key] = value;
      });
      return result;
    };

    var _pageTypes = function _pageTypes(params) {
      var defaultSize = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 50;
      var result = Object.assign({}, params);
      var page = parseInt(params.page || 1);
      var size = parseInt(params.size || defaultSize);
      var offset = page - 1;
      result.skip = offset * size;
      result.limit = size;
      var sorter = params.sorter;
      var direction = params.direction || "descending";
      if (sorter) result.sort = "".concat(sorter, ":").concat(direction);
      return result;
    };

    var _toSort = function _toSort(value) {
      var values = value.split(":", 2);
      if (values.length === 1) values.push("descending");

      var _values = _slicedToArray(values, 2),
          name = _values[0],
          direction = _values[1];

      if (name === "default") return null;
      values[1] = SORT_MAP[direction] || 1;
      return [values];
    };

    var _findTypes = function _findTypes(params) {
      var result = {};
      Object.entries(params).forEach(function (_ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            key = _ref4[0],
            value = _ref4[1];

        var converter = FIND_TYPES[key];
        var converted = converter ? converter(value) : value;
        result[key] = converted;
      });
      return result;
    };

    var _findDefaults = function _findDefaults(params) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var result = Object.assign({}, params);
      Object.entries(options).filter(function (_ref5) {
        var _ref6 = _slicedToArray(_ref5, 1),
            key = _ref6[0];

        return FIND_TYPES[key];
      }).forEach(function (_ref7) {
        var _ref8 = _slicedToArray(_ref7, 2),
            key = _ref8[0],
            value = _ref8[1];

        result[key] = params[key] || value;
      });
      Object.entries(FIND_DEFAULTS).forEach(function (_ref9) {
        var _ref10 = _slicedToArray(_ref9, 2),
            key = _ref10[0],
            value = _ref10[1];

        result[key] = params[key] || value;
      });
      return result;
    };

    var _normParams = function _normParams(params) {
      var result = Object.assign({}, params); // iterates over all the key value association in the object,
      // trying to find the ones that refer sequences so that they
      // may be normalized

      for (var _i = 0, _Object$entries = Object.entries(params); _i < _Object$entries.length; _i++) {
        var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2),
            key = _Object$entries$_i[0],
            value = _Object$entries$_i[1];

        // verifies if the current name references a sequence and
        // if that's not the case continues the loop trying to find
        // any other sequence based value
        if (!key.endsWith("[]")) {
          result[key] = value;
          continue;
        } // removes the extra sequence indication value


        var name = key.substring(0, key.length - 2); // in case the current value is not valid (empty) the object
        // is set with an empty list for the current iteration as this
        // is considered to be the default value

        if (!value) {
          result[name] = [];
          continue;
        } // retrieves the normalized and linearized list of leafs
        // for the current value and ten verifies the size of each
        // of its values and uses it to measure the number of
        // dictionary elements that are going to be contained in
        // the sequence to be "generated", then uses this (size)
        // value to pre-generate the complete set of dictionaries


        var leafs = _leafs(value);

        var _ref11 = leafs[0] || [null, []],
            _ref12 = _slicedToArray(_ref11, 2),
            values = _ref12[1];

        var list = values.map(function (_) {
          return {};
        }); // sets the list of generates dictionaries in the object for
        // the newly normalized name of structure

        result[name] = list; // iterates over the complete set of key value pairs in the
        // leafs list to gather the value into the various objects that
        // are contained in the sequence (normalization process)

        var _iterator = _createForOfIteratorHelper(leafs),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var _step$value = _slicedToArray(_step.value, 2),
                _name = _step$value[0],
                _value = _step$value[1];

            for (var index; index < list.length; index++) {
              var object = list[index];

              var nameList = _name.split(".");

              _setObject(object, nameList, _value[index]);
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }

      return result;
    };
    /**
     * Retrieves a list containing a series of tuples that each represent a
     * leaf of the current object structure. A leaf is the last element of an
     * object that is not a map, the other intermediary maps are considered to
     * be trunks and should be percolated recursively.
     * This is a recursive function that takes some memory for the construction
     * of the list, and so should be used with the proper care to avoid bottlenecks.
     *
     * @param {Object} params The object for which the leafs list structure is
     * meant to be retrieved.
     * @returns {Array} The list of leaf node tuples for the provided object,
     * as requested for each of the sequences.
     */


    var _leafs = function _leafs(params) {
      // the list that will hold the various leaf nodes "gathered" by
      // the current recursion function
      var result = []; // iterates over all the key and value relations in the object trying
      // to find the leaf nodes (no map nodes) creating a tuple of fqn
      // (fully qualified name) and value

      var _loop = function _loop() {
        var _Object$entries2$_i = _slicedToArray(_Object$entries2[_i2], 2),
            key = _Object$entries2$_i[0],
            value = _Object$entries2$_i[1];

        // retrieves the data type for the current value and validation
        // if it is a object or any other type in case it's an object a
        // new iteration step must be performed retrieving the leafs of
        // the value and then incrementing the name with the current prefix
        if (_typeof(value) === "object") {
          var leafs = _leafs(value).map(function (_ref13) {
            var _ref14 = _slicedToArray(_ref13, 2),
                name = _ref14[0],
                value = _ref14[1];

            return ["".concat(key, ".").concat(name), value];
          });

          result = Array.concat(result, leafs);
        } else {
          // otherwise this is a leaf node and so the leaf tuple node
          // must be constructed with the current value (properly validated
          // for sequence presence)
          result.push([key, Array.isArray(value) ? value : [value]]);
        }
      };

      for (var _i2 = 0, _Object$entries2 = Object.entries(params); _i2 < _Object$entries2.length; _i2++) {
        _loop();
      }

      return result;
    };
    /**
     * Sets a composite value in an object, allowing for dynamic setting of
     * random size key values.
     * This method is useful for situations where one wants to set a value
     * at a randomly defined depth inside an object without having to much
     * work with the creation of the inner dictionaries.
     *
     * @param {Object} object The target object that is going to be
     * changed and set with the target value.
     * @param {Array} nameList The list of names that defined the fully
     * qualified name to be used in the setting of the value
     * for example path.to.end will be a three size list containing each
     * of the partial names.
     * @param {Object} value The value that is going to be set in the
     * defined target of the object.
     */


    var _setObject = function _setObject(object, nameList, value) {
      // retrieves the first name in the names list this is the
      // value that is going to be used for the current iteration
      var _nameList$ = _toArray(nameList[0]),
          name = _nameList$[0],
          tail = _nameList$.slice(1); // in case the length of the current names list has reached
      // one this is the final iteration and so the value is set
      // at the current naming point


      if (nameList.length === 1) {
        object[name] = value;
      } else {
        // otherwise this is a "normal" step and so a new map must
        // be created/retrieved and the iteration step should be
        // performed on this new map as it's set on the current naming
        // place (recursion step)
        var map = object[name] || {};
        object[name] = map;

        _setObject(map, tail, value);
      }
    };

    var MixinBuilder = /*#__PURE__*/function () {
      function MixinBuilder(superclass) {
        _classCallCheck(this, MixinBuilder);

        this.superclass = superclass;
      }

      _createClass(MixinBuilder, [{
        key: "with",
        value: function _with() {
          for (var _len = arguments.length, mixins = new Array(_len), _key = 0; _key < _len; _key++) {
            mixins[_key] = arguments[_key];
          }

          return mixins.reduce(function (c, mixin) {
            return mixin(c);
          }, this.superclass);
        }
      }]);

      return MixinBuilder;
    }();
    var mix = function mix(superclass) {
      return new MixinBuilder(superclass);
    };

    var initMongo = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(mongoose, uri) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                mongoose.set("useNewUrlParser", true);
                mongoose.set("useFindAndModify", false);
                mongoose.set("useCreateIndex", true);
                mongoose.set("useUnifiedTopology", true);
                _context.next = 6;
                return mongoose.connect(uri, {
                  useNewUrlParser: true,
                  useUnifiedTopology: true
                });

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function initMongo(_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }();
    var destroyMongo = function destroyMongo(mongoose) {
      mongoose.disconnect();
    };

    var equal = function equal(first, second) {
      if (first === second) {
        return true;
      }

      if (typeof_(first) !== typeof_(second)) {
        return false;
      }

      if (isPrimitive(first) && isPrimitive(second)) {
        return first === second;
      }

      if (Object.keys(first).length !== Object.keys(second).length) {
        return false;
      }

      for (var key in first) {
        if (!(key in second)) return false;
        if (!equal(first[key], second[key])) return false;
      }

      return true;
    };
    var isPrimitive = function isPrimitive(object) {
      return object !== Object(object);
    };
    var typeof_ = function typeof_(object) {
      if (object === null) return "null";
      if (Array.isArray(object)) return "array";
      return _typeof(object);
    };

    var matchOperatorsRegex = /[|\\{}()[\]^$+*?.-]/g;
    var escapeStringRegexp = function escapeStringRegexp(string) {
      if (typeof string !== "string") {
        throw new TypeError("Expected a string");
      }

      return string.replace(matchOperatorsRegex, "\\$&");
    };

    /* The default minimum value meaning that this is the
    maximum value that one integer value may have for the
    size rounding operation to be performed */
    var DEFAULT_MINIMUM = 1024;
    /* The default number of places (digits) that are going
    to be used for the string representation in the round
    based conversion of size units to be performed */

    var DEFAULT_PLACES = 3;
    /* The size unit coefficient as an integer value, this is
    going to be used in each of the size steps as divisor */

    var SIZE_UNIT_COEFFICIENT = 1024;
    /* The simplified size units list that contains the complete set of
    units indexed by the depth they represent */

    var SIZE_UNITS_LIST_S = ["B", "K", "M", "G", "T", "P", "E", "Z", "Y"];
    /* The size units list that contains the complete set of
    units indexed by the depth they represent */

    var SIZE_UNITS_LIST = ["B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"];
    var sizeRoundUnit = function sizeRoundUnit(sizeValue) {
      var minimum = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_MINIMUM;
      var places = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : DEFAULT_PLACES;
      var reduce = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
      var space = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
      var justify = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;
      var simplified = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : false;
      var depth = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : 0;

      // in case the current size value is acceptable (less than
      // the minimum) this is the final iteration and the final
      // string representation is going to be created
      if (sizeValue < minimum) {
        // calculates the maximum size of the string that is going
        // to represent the base size value as the number of places
        // plus one (representing the decimal separator character)
        var sizeS = places + 1; // calculates the target number of decimal places taking
        // into account the size (in digits) of the current size
        // value, this may never be a negative number

        var logValue = sizeValue && Math.log10(sizeValue);
        var digits = Math.trunc(logValue) + 1;
        places = places - digits;
        places = places > 0 ? places : 0; // rounds the size value, then converts the rounded
        // size value into a string based representation

        var sizeValueS = sizeValue.toFixed(places); // forces the reduce flag when the depth is zero, meaning
        // that an integer value will never be decimal, this is
        // required to avoid strange results for depth zero

        reduce = reduce || depth === 0; // in case the dot value is not present in the size value
        // string adds it to the end otherwise an issue may occur
        // while removing extra padding characters for reduce

        if (reduce && !sizeValueS.includes(".")) sizeValueS += "."; // strips the value from zero appended to the right and
        // then strips the value also from a possible decimal
        // point value that may be included in it, this is only
        // performed in case the reduce flag is enabled

        if (reduce) sizeValueS = sizeValueS.replace(/0+$/, "");
        if (reduce) sizeValueS = sizeValueS.replace(/\.$/, ""); // in case the justify flag is set runs the justification
        // process on the size value taking into account the maximum
        // size of the associated size string

        if (justify) sizeValueS = _rjust(sizeValueS, sizeS); // retrieves the size unit (string mode) for the current
        // depth according to the provided map

        var sizeUnit;
        if (simplified) sizeUnit = SIZE_UNITS_LIST_S[depth];else sizeUnit = SIZE_UNITS_LIST[depth]; // retrieves the appropriate separator based
        // on the value of the space flag

        var separator = space && " " || ""; // creates the size value string appending the rounded
        // size value string and the size unit and returns it
        // to the caller method as the size value string

        var sizeValueString = sizeValueS + separator + sizeUnit;
        return sizeValueString;
      } // otherwise the value is not acceptable and a new iteration
      // must be ran with one less depth of size value
      else {
          // re-calculates the new size value, increments the depth
          // and runs the size round unit again with the new values
          var newSizeValue = parseFloat(sizeValue) / SIZE_UNIT_COEFFICIENT;
          var newDepth = depth + 1;
          return sizeRoundUnit(newSizeValue, minimum, places, reduce, space, justify, simplified, newDepth);
        }
    };

    var _rjust = function _rjust(str, length) {
      var lengthToFill = length - str.length;
      return lengthToFill <= 0 ? str : " ".repeat(lengthToFill) + str;
    };

    var camelToUnderscore = function camelToUnderscore(value) {
      var separator = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "_";
      if (!value) return value;
      return value.replace(/\.?([A-Z])/g, function (x, y) {
        return separator + y.toLowerCase();
      }).replace(RegExp("^" + separator), "");
    };

    /**
     * Encodes the multiple values as and encoded URI component, the
     * values can be wither defined as an array (order is preserved)
     * or as an object (where sequence order is not preserved).
     *
     * The value of each item can be either a primitive type or a sequence
     * in case it's of sequence the values are going to be encoded as
     * multiple parameters separated by the '&' character.
     *
     * @param {(Array|Object[])} values The values to be encoded as an
     * URI component (like GET params).
     * @returns {String} A string with the query encoded values.
     */

    var urlEncode = function urlEncode(values) {
      // constructs the parts array that is going to
      // store the multiple and values
      var parts = []; // in case the provided value is not an array
      // then assumes it's an object and retrieve entries

      if (!Array.isArray(values)) {
        values = Object.entries(values);
      } // iterates over the complete set of pairs available
      // from the key value pairs to be able to encode them
      // properly, notice that the values themselves can be
      // sequences allowing multiple repetition of key


      values.forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            key = _ref2[0],
            value = _ref2[1];

        if (!Array.isArray(value)) {
          value = [value];
        }

        var keyEncoded = encodeURIComponent(key);
        value.forEach(function (_value) {
          if (_value === undefined || _value === null) {
            return;
          }

          var valueEncoded = encodeURIComponent(_value);
          parts.push("".concat(keyEncoded, "=").concat(valueEncoded));
        });
      }); // joins the complete set of parts with the and
      // separator and then returns the final string value

      return parts.join("&");
    };
    var absoluteUrl = function absoluteUrl(path) {
      var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "BASE_URL";
      var fallback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : undefined;
      var baseUrl = conf(name, fallback);
      if (!baseUrl) return null;
      return "".concat(baseUrl).concat(path);
    };

    var YoniusError = /*#__PURE__*/function (_Error) {
      _inherits(YoniusError, _Error);

      var _super = _createSuper(YoniusError);

      function YoniusError(message) {
        var _this;

        var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 500;

        _classCallCheck(this, YoniusError);

        _this = _super.call(this, message);
        _this.name = _this.constructor.name;
        _this.code = code;
        return _this;
      }

      _createClass(YoniusError, [{
        key: "isClient",
        get: function get() {
          return Math.floor(this.code / 100) === 4;
        }
      }, {
        key: "isServer",
        get: function get() {
          return Math.floor(this.code / 100) === 5;
        }
      }]);

      return YoniusError;
    }( /*#__PURE__*/_wrapNativeSuper(Error));
    var OperationalError = /*#__PURE__*/function (_YoniusError) {
      _inherits(OperationalError, _YoniusError);

      var _super2 = _createSuper(OperationalError);

      function OperationalError() {
        var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Operational error";
        var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 500;

        _classCallCheck(this, OperationalError);

        return _super2.call(this, message, code);
      }

      return OperationalError;
    }(YoniusError);
    var NotFoundError = /*#__PURE__*/function (_OperationalError) {
      _inherits(NotFoundError, _OperationalError);

      var _super3 = _createSuper(NotFoundError);

      function NotFoundError() {
        var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Not found";
        var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 404;

        _classCallCheck(this, NotFoundError);

        return _super3.call(this, message, code);
      }

      return NotFoundError;
    }(OperationalError);
    var NotImplementedError = /*#__PURE__*/function (_OperationalError2) {
      _inherits(NotImplementedError, _OperationalError2);

      var _super4 = _createSuper(NotImplementedError);

      function NotImplementedError() {
        var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Not implemented";
        var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 501;

        _classCallCheck(this, NotImplementedError);

        return _super4.call(this, message, code);
      }

      return NotImplementedError;
    }(OperationalError);
    var ValidationError = /*#__PURE__*/function (_OperationalError3) {
      _inherits(ValidationError, _OperationalError3);

      var _super5 = _createSuper(ValidationError);

      function ValidationError() {
        var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Validation of submitted data failed";
        var code = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 400;

        _classCallCheck(this, ValidationError);

        return _super5.call(this, message, code);
      }

      return ValidationError;
    }(OperationalError);

    /**
     * The simple regex used to validate
     * if the provided value is a "simple" one meaning
     * that it may be used safely for URL parts
     */

    var SIMPLE_REGEX = /^[\:\.\s\w-]+$/;
    /**
     * The email regex used to validate
     * if the provided value is in fact an email
     */

    var EMAIL_REGEX = /^[\w\d\._%+-]+@[\w\d\.\-]+$/;
    /**
     * The URL regex used to validate
     * if the provided value is in fact an URL/URI
     */

    var URL_REGEX = /^\w+\:\/\/([^@]+\:[^@]+@)?[^\:\/\?#]+(\:\d+)?(\/[^\?#]+)*\/?(\?[^#]*)?(#.*)?$/;
    var eq = function eq(valueC) {
      var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "Must be equal to %{1}";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value === valueC) return true;
        throw new ValidationError(message.replace("%{1}", String(valueC)));
      };

      return validation;
    };
    var gt = function gt(valueC) {
      var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "Must be greater than %{1}";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value > valueC) return true;
        throw new ValidationError(message.replace("%{1}", String(valueC)));
      };

      return validation;
    };
    var gte = function gte(valueC) {
      var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "Must be greater than or equal to %{1}";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value >= valueC) return true;
        throw new ValidationError(message.replace("%{1}", String(valueC)));
      };

      return validation;
    };
    var notEmpty = function notEmpty() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Value is empty";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value.length) return true;
        throw new ValidationError(message);
      };

      return validation;
    };
    var isIn = function isIn(valueC) {
      var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "Value must be one of: %{1}";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (valueC.includes(value)) return true;
        throw new ValidationError(message.replace("%{1}", valueC.join(", ")));
      };

      return validation;
    };
    var isUpper = function isUpper() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Value contains lower cased characters";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value === "") return true;
        if (value === value.toUpperCase()) return true;
        throw new ValidationError(message);
      };

      return validation;
    };
    var isLower = function isLower() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Value contains upper cased characters";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value === "") return true;
        if (value === value.toLowerCase()) return true;
        throw new ValidationError(message);
      };

      return validation;
    };
    var isSimple = function isSimple() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Value contains invalid characters";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value === "") return true;
        if (value.match(SIMPLE_REGEX)) return true;
        throw new ValidationError(message);
      };

      return validation;
    };
    var isEmail = function isEmail() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Value is not a valid email";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value === "") return true;
        if (value.match(EMAIL_REGEX)) return true;
        throw new ValidationError(message);
      };

      return validation;
    };
    var isUrl = function isUrl() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "Value is not a valid URL";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value === "") return true;
        if (value.match(URL_REGEX)) return true;
        throw new ValidationError(message);
      };

      return validation;
    };
    var isRegex = function isRegex(regex) {
      var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "Value has incorrect format";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value === "") return true;
        if (value.match(new RegExp(regex))) return true;
        throw new ValidationError(message);
      };

      return validation;
    };
    var stringGt = function stringGt(valueC) {
      var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "Must be larger than %{1} characters";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value.length > valueC) return true;
        throw new ValidationError(message.replace("%{1}", String(valueC)));
      };

      return validation;
    };
    var stringLt = function stringLt(valueC) {
      var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "Must be smaller than %{1} characters";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value.length < valueC) return true;
        throw new ValidationError(message.replace("%{1}", String(valueC)));
      };

      return validation;
    };
    var stringEq = function stringEq(valueC) {
      var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "Must be exactly %{1} characters";

      var validation = function validation(value, ctx) {
        if (value === null) return true;
        if (value.length === valueC) return true;
        throw new ValidationError(message.replace("%{1}", String(valueC)));
      };

      return validation;
    };

    var lookup = [];
    var revLookup = [];
    var Arr = typeof Uint8Array !== 'undefined' ? Uint8Array : Array;
    var inited = false;

    function init() {
      inited = true;
      var code = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';

      for (var i = 0, len = code.length; i < len; ++i) {
        lookup[i] = code[i];
        revLookup[code.charCodeAt(i)] = i;
      }

      revLookup['-'.charCodeAt(0)] = 62;
      revLookup['_'.charCodeAt(0)] = 63;
    }

    function toByteArray(b64) {
      if (!inited) {
        init();
      }

      var i, j, l, tmp, placeHolders, arr;
      var len = b64.length;

      if (len % 4 > 0) {
        throw new Error('Invalid string. Length must be a multiple of 4');
      } // the number of equal signs (place holders)
      // if there are two placeholders, than the two characters before it
      // represent one byte
      // if there is only one, then the three characters before it represent 2 bytes
      // this is just a cheap hack to not do indexOf twice


      placeHolders = b64[len - 2] === '=' ? 2 : b64[len - 1] === '=' ? 1 : 0; // base64 is 4/3 + up to two characters of the original data

      arr = new Arr(len * 3 / 4 - placeHolders); // if there are placeholders, only get up to the last complete 4 chars

      l = placeHolders > 0 ? len - 4 : len;
      var L = 0;

      for (i = 0, j = 0; i < l; i += 4, j += 3) {
        tmp = revLookup[b64.charCodeAt(i)] << 18 | revLookup[b64.charCodeAt(i + 1)] << 12 | revLookup[b64.charCodeAt(i + 2)] << 6 | revLookup[b64.charCodeAt(i + 3)];
        arr[L++] = tmp >> 16 & 0xFF;
        arr[L++] = tmp >> 8 & 0xFF;
        arr[L++] = tmp & 0xFF;
      }

      if (placeHolders === 2) {
        tmp = revLookup[b64.charCodeAt(i)] << 2 | revLookup[b64.charCodeAt(i + 1)] >> 4;
        arr[L++] = tmp & 0xFF;
      } else if (placeHolders === 1) {
        tmp = revLookup[b64.charCodeAt(i)] << 10 | revLookup[b64.charCodeAt(i + 1)] << 4 | revLookup[b64.charCodeAt(i + 2)] >> 2;
        arr[L++] = tmp >> 8 & 0xFF;
        arr[L++] = tmp & 0xFF;
      }

      return arr;
    }

    function tripletToBase64(num) {
      return lookup[num >> 18 & 0x3F] + lookup[num >> 12 & 0x3F] + lookup[num >> 6 & 0x3F] + lookup[num & 0x3F];
    }

    function encodeChunk(uint8, start, end) {
      var tmp;
      var output = [];

      for (var i = start; i < end; i += 3) {
        tmp = (uint8[i] << 16) + (uint8[i + 1] << 8) + uint8[i + 2];
        output.push(tripletToBase64(tmp));
      }

      return output.join('');
    }

    function fromByteArray(uint8) {
      if (!inited) {
        init();
      }

      var tmp;
      var len = uint8.length;
      var extraBytes = len % 3; // if we have 1 byte left, pad 2 bytes

      var output = '';
      var parts = [];
      var maxChunkLength = 16383; // must be multiple of 3
      // go through the array every three bytes, we'll deal with trailing stuff later

      for (var i = 0, len2 = len - extraBytes; i < len2; i += maxChunkLength) {
        parts.push(encodeChunk(uint8, i, i + maxChunkLength > len2 ? len2 : i + maxChunkLength));
      } // pad the end with zeros, but make sure to not forget the extra bytes


      if (extraBytes === 1) {
        tmp = uint8[len - 1];
        output += lookup[tmp >> 2];
        output += lookup[tmp << 4 & 0x3F];
        output += '==';
      } else if (extraBytes === 2) {
        tmp = (uint8[len - 2] << 8) + uint8[len - 1];
        output += lookup[tmp >> 10];
        output += lookup[tmp >> 4 & 0x3F];
        output += lookup[tmp << 2 & 0x3F];
        output += '=';
      }

      parts.push(output);
      return parts.join('');
    }

    function read(buffer, offset, isLE, mLen, nBytes) {
      var e, m;
      var eLen = nBytes * 8 - mLen - 1;
      var eMax = (1 << eLen) - 1;
      var eBias = eMax >> 1;
      var nBits = -7;
      var i = isLE ? nBytes - 1 : 0;
      var d = isLE ? -1 : 1;
      var s = buffer[offset + i];
      i += d;
      e = s & (1 << -nBits) - 1;
      s >>= -nBits;
      nBits += eLen;

      for (; nBits > 0; e = e * 256 + buffer[offset + i], i += d, nBits -= 8) {}

      m = e & (1 << -nBits) - 1;
      e >>= -nBits;
      nBits += mLen;

      for (; nBits > 0; m = m * 256 + buffer[offset + i], i += d, nBits -= 8) {}

      if (e === 0) {
        e = 1 - eBias;
      } else if (e === eMax) {
        return m ? NaN : (s ? -1 : 1) * Infinity;
      } else {
        m = m + Math.pow(2, mLen);
        e = e - eBias;
      }

      return (s ? -1 : 1) * m * Math.pow(2, e - mLen);
    }

    function write(buffer, value, offset, isLE, mLen, nBytes) {
      var e, m, c;
      var eLen = nBytes * 8 - mLen - 1;
      var eMax = (1 << eLen) - 1;
      var eBias = eMax >> 1;
      var rt = mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0;
      var i = isLE ? 0 : nBytes - 1;
      var d = isLE ? 1 : -1;
      var s = value < 0 || value === 0 && 1 / value < 0 ? 1 : 0;
      value = Math.abs(value);

      if (isNaN(value) || value === Infinity) {
        m = isNaN(value) ? 1 : 0;
        e = eMax;
      } else {
        e = Math.floor(Math.log(value) / Math.LN2);

        if (value * (c = Math.pow(2, -e)) < 1) {
          e--;
          c *= 2;
        }

        if (e + eBias >= 1) {
          value += rt / c;
        } else {
          value += rt * Math.pow(2, 1 - eBias);
        }

        if (value * c >= 2) {
          e++;
          c /= 2;
        }

        if (e + eBias >= eMax) {
          m = 0;
          e = eMax;
        } else if (e + eBias >= 1) {
          m = (value * c - 1) * Math.pow(2, mLen);
          e = e + eBias;
        } else {
          m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
          e = 0;
        }
      }

      for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

      e = e << mLen | m;
      eLen += mLen;

      for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

      buffer[offset + i - d] |= s * 128;
    }

    var toString = {}.toString;

    var isArray$1 = Array.isArray || function (arr) {
      return toString.call(arr) == '[object Array]';
    };
    /*!
     * The buffer module from node.js, for the browser.
     *
     * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
     * @license  MIT
     */


    var INSPECT_MAX_BYTES = 50;
    /**
     * If `Buffer.TYPED_ARRAY_SUPPORT`:
     *   === true    Use Uint8Array implementation (fastest)
     *   === false   Use Object implementation (most compatible, even IE6)
     *
     * Browsers that support typed arrays are IE 10+, Firefox 4+, Chrome 7+, Safari 5.1+,
     * Opera 11.6+, iOS 4.2+.
     *
     * Due to various browser bugs, sometimes the Object implementation will be used even
     * when the browser supports typed arrays.
     *
     * Note:
     *
     *   - Firefox 4-29 lacks support for adding new properties to `Uint8Array` instances,
     *     See: https://bugzilla.mozilla.org/show_bug.cgi?id=695438.
     *
     *   - Chrome 9-10 is missing the `TypedArray.prototype.subarray` function.
     *
     *   - IE10 has a broken `TypedArray.prototype.subarray` function which returns arrays of
     *     incorrect length in some situations.

     * We detect these buggy browsers and set `Buffer.TYPED_ARRAY_SUPPORT` to `false` so they
     * get the Object implementation, which is slower but behaves correctly.
     */

    Buffer.TYPED_ARRAY_SUPPORT = global$1.TYPED_ARRAY_SUPPORT !== undefined ? global$1.TYPED_ARRAY_SUPPORT : true;

    function kMaxLength() {
      return Buffer.TYPED_ARRAY_SUPPORT ? 0x7fffffff : 0x3fffffff;
    }

    function createBuffer(that, length) {
      if (kMaxLength() < length) {
        throw new RangeError('Invalid typed array length');
      }

      if (Buffer.TYPED_ARRAY_SUPPORT) {
        // Return an augmented `Uint8Array` instance, for best performance
        that = new Uint8Array(length);
        that.__proto__ = Buffer.prototype;
      } else {
        // Fallback: Return an object instance of the Buffer class
        if (that === null) {
          that = new Buffer(length);
        }

        that.length = length;
      }

      return that;
    }
    /**
     * The Buffer constructor returns instances of `Uint8Array` that have their
     * prototype changed to `Buffer.prototype`. Furthermore, `Buffer` is a subclass of
     * `Uint8Array`, so the returned instances will have all the node `Buffer` methods
     * and the `Uint8Array` methods. Square bracket notation works as expected -- it
     * returns a single octet.
     *
     * The `Uint8Array` prototype remains unmodified.
     */


    function Buffer(arg, encodingOrOffset, length) {
      if (!Buffer.TYPED_ARRAY_SUPPORT && !(this instanceof Buffer)) {
        return new Buffer(arg, encodingOrOffset, length);
      } // Common case.


      if (typeof arg === 'number') {
        if (typeof encodingOrOffset === 'string') {
          throw new Error('If encoding is specified then the first argument must be a string');
        }

        return allocUnsafe(this, arg);
      }

      return from(this, arg, encodingOrOffset, length);
    }

    Buffer.poolSize = 8192; // not used by this implementation
    // TODO: Legacy, not needed anymore. Remove in next major version.

    Buffer._augment = function (arr) {
      arr.__proto__ = Buffer.prototype;
      return arr;
    };

    function from(that, value, encodingOrOffset, length) {
      if (typeof value === 'number') {
        throw new TypeError('"value" argument must not be a number');
      }

      if (typeof ArrayBuffer !== 'undefined' && value instanceof ArrayBuffer) {
        return fromArrayBuffer(that, value, encodingOrOffset, length);
      }

      if (typeof value === 'string') {
        return fromString(that, value, encodingOrOffset);
      }

      return fromObject(that, value);
    }
    /**
     * Functionally equivalent to Buffer(arg, encoding) but throws a TypeError
     * if value is a number.
     * Buffer.from(str[, encoding])
     * Buffer.from(array)
     * Buffer.from(buffer)
     * Buffer.from(arrayBuffer[, byteOffset[, length]])
     **/


    Buffer.from = function (value, encodingOrOffset, length) {
      return from(null, value, encodingOrOffset, length);
    };

    if (Buffer.TYPED_ARRAY_SUPPORT) {
      Buffer.prototype.__proto__ = Uint8Array.prototype;
      Buffer.__proto__ = Uint8Array;
    }

    function assertSize(size) {
      if (typeof size !== 'number') {
        throw new TypeError('"size" argument must be a number');
      } else if (size < 0) {
        throw new RangeError('"size" argument must not be negative');
      }
    }

    function alloc(that, size, fill, encoding) {
      assertSize(size);

      if (size <= 0) {
        return createBuffer(that, size);
      }

      if (fill !== undefined) {
        // Only pay attention to encoding if it's a string. This
        // prevents accidentally sending in a number that would
        // be interpretted as a start offset.
        return typeof encoding === 'string' ? createBuffer(that, size).fill(fill, encoding) : createBuffer(that, size).fill(fill);
      }

      return createBuffer(that, size);
    }
    /**
     * Creates a new filled Buffer instance.
     * alloc(size[, fill[, encoding]])
     **/


    Buffer.alloc = function (size, fill, encoding) {
      return alloc(null, size, fill, encoding);
    };

    function allocUnsafe(that, size) {
      assertSize(size);
      that = createBuffer(that, size < 0 ? 0 : checked(size) | 0);

      if (!Buffer.TYPED_ARRAY_SUPPORT) {
        for (var i = 0; i < size; ++i) {
          that[i] = 0;
        }
      }

      return that;
    }
    /**
     * Equivalent to Buffer(num), by default creates a non-zero-filled Buffer instance.
     * */


    Buffer.allocUnsafe = function (size) {
      return allocUnsafe(null, size);
    };
    /**
     * Equivalent to SlowBuffer(num), by default creates a non-zero-filled Buffer instance.
     */


    Buffer.allocUnsafeSlow = function (size) {
      return allocUnsafe(null, size);
    };

    function fromString(that, string, encoding) {
      if (typeof encoding !== 'string' || encoding === '') {
        encoding = 'utf8';
      }

      if (!Buffer.isEncoding(encoding)) {
        throw new TypeError('"encoding" must be a valid string encoding');
      }

      var length = byteLength(string, encoding) | 0;
      that = createBuffer(that, length);
      var actual = that.write(string, encoding);

      if (actual !== length) {
        // Writing a hex string, for example, that contains invalid characters will
        // cause everything after the first invalid character to be ignored. (e.g.
        // 'abxxcd' will be treated as 'ab')
        that = that.slice(0, actual);
      }

      return that;
    }

    function fromArrayLike(that, array) {
      var length = array.length < 0 ? 0 : checked(array.length) | 0;
      that = createBuffer(that, length);

      for (var i = 0; i < length; i += 1) {
        that[i] = array[i] & 255;
      }

      return that;
    }

    function fromArrayBuffer(that, array, byteOffset, length) {
      array.byteLength; // this throws if `array` is not a valid ArrayBuffer

      if (byteOffset < 0 || array.byteLength < byteOffset) {
        throw new RangeError('\'offset\' is out of bounds');
      }

      if (array.byteLength < byteOffset + (length || 0)) {
        throw new RangeError('\'length\' is out of bounds');
      }

      if (byteOffset === undefined && length === undefined) {
        array = new Uint8Array(array);
      } else if (length === undefined) {
        array = new Uint8Array(array, byteOffset);
      } else {
        array = new Uint8Array(array, byteOffset, length);
      }

      if (Buffer.TYPED_ARRAY_SUPPORT) {
        // Return an augmented `Uint8Array` instance, for best performance
        that = array;
        that.__proto__ = Buffer.prototype;
      } else {
        // Fallback: Return an object instance of the Buffer class
        that = fromArrayLike(that, array);
      }

      return that;
    }

    function fromObject(that, obj) {
      if (internalIsBuffer(obj)) {
        var len = checked(obj.length) | 0;
        that = createBuffer(that, len);

        if (that.length === 0) {
          return that;
        }

        obj.copy(that, 0, 0, len);
        return that;
      }

      if (obj) {
        if (typeof ArrayBuffer !== 'undefined' && obj.buffer instanceof ArrayBuffer || 'length' in obj) {
          if (typeof obj.length !== 'number' || isnan(obj.length)) {
            return createBuffer(that, 0);
          }

          return fromArrayLike(that, obj);
        }

        if (obj.type === 'Buffer' && isArray$1(obj.data)) {
          return fromArrayLike(that, obj.data);
        }
      }

      throw new TypeError('First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.');
    }

    function checked(length) {
      // Note: cannot use `length < kMaxLength()` here because that fails when
      // length is NaN (which is otherwise coerced to zero.)
      if (length >= kMaxLength()) {
        throw new RangeError('Attempt to allocate Buffer larger than maximum ' + 'size: 0x' + kMaxLength().toString(16) + ' bytes');
      }

      return length | 0;
    }

    Buffer.isBuffer = isBuffer;

    function internalIsBuffer(b) {
      return !!(b != null && b._isBuffer);
    }

    Buffer.compare = function compare(a, b) {
      if (!internalIsBuffer(a) || !internalIsBuffer(b)) {
        throw new TypeError('Arguments must be Buffers');
      }

      if (a === b) return 0;
      var x = a.length;
      var y = b.length;

      for (var i = 0, len = Math.min(x, y); i < len; ++i) {
        if (a[i] !== b[i]) {
          x = a[i];
          y = b[i];
          break;
        }
      }

      if (x < y) return -1;
      if (y < x) return 1;
      return 0;
    };

    Buffer.isEncoding = function isEncoding(encoding) {
      switch (String(encoding).toLowerCase()) {
        case 'hex':
        case 'utf8':
        case 'utf-8':
        case 'ascii':
        case 'latin1':
        case 'binary':
        case 'base64':
        case 'ucs2':
        case 'ucs-2':
        case 'utf16le':
        case 'utf-16le':
          return true;

        default:
          return false;
      }
    };

    Buffer.concat = function concat(list, length) {
      if (!isArray$1(list)) {
        throw new TypeError('"list" argument must be an Array of Buffers');
      }

      if (list.length === 0) {
        return Buffer.alloc(0);
      }

      var i;

      if (length === undefined) {
        length = 0;

        for (i = 0; i < list.length; ++i) {
          length += list[i].length;
        }
      }

      var buffer = Buffer.allocUnsafe(length);
      var pos = 0;

      for (i = 0; i < list.length; ++i) {
        var buf = list[i];

        if (!internalIsBuffer(buf)) {
          throw new TypeError('"list" argument must be an Array of Buffers');
        }

        buf.copy(buffer, pos);
        pos += buf.length;
      }

      return buffer;
    };

    function byteLength(string, encoding) {
      if (internalIsBuffer(string)) {
        return string.length;
      }

      if (typeof ArrayBuffer !== 'undefined' && typeof ArrayBuffer.isView === 'function' && (ArrayBuffer.isView(string) || string instanceof ArrayBuffer)) {
        return string.byteLength;
      }

      if (typeof string !== 'string') {
        string = '' + string;
      }

      var len = string.length;
      if (len === 0) return 0; // Use a for loop to avoid recursion

      var loweredCase = false;

      for (;;) {
        switch (encoding) {
          case 'ascii':
          case 'latin1':
          case 'binary':
            return len;

          case 'utf8':
          case 'utf-8':
          case undefined:
            return utf8ToBytes(string).length;

          case 'ucs2':
          case 'ucs-2':
          case 'utf16le':
          case 'utf-16le':
            return len * 2;

          case 'hex':
            return len >>> 1;

          case 'base64':
            return base64ToBytes(string).length;

          default:
            if (loweredCase) return utf8ToBytes(string).length; // assume utf8

            encoding = ('' + encoding).toLowerCase();
            loweredCase = true;
        }
      }
    }

    Buffer.byteLength = byteLength;

    function slowToString(encoding, start, end) {
      var loweredCase = false; // No need to verify that "this.length <= MAX_UINT32" since it's a read-only
      // property of a typed array.
      // This behaves neither like String nor Uint8Array in that we set start/end
      // to their upper/lower bounds if the value passed is out of range.
      // undefined is handled specially as per ECMA-262 6th Edition,
      // Section 13.3.3.7 Runtime Semantics: KeyedBindingInitialization.

      if (start === undefined || start < 0) {
        start = 0;
      } // Return early if start > this.length. Done here to prevent potential uint32
      // coercion fail below.


      if (start > this.length) {
        return '';
      }

      if (end === undefined || end > this.length) {
        end = this.length;
      }

      if (end <= 0) {
        return '';
      } // Force coersion to uint32. This will also coerce falsey/NaN values to 0.


      end >>>= 0;
      start >>>= 0;

      if (end <= start) {
        return '';
      }

      if (!encoding) encoding = 'utf8';

      while (true) {
        switch (encoding) {
          case 'hex':
            return hexSlice(this, start, end);

          case 'utf8':
          case 'utf-8':
            return utf8Slice(this, start, end);

          case 'ascii':
            return asciiSlice(this, start, end);

          case 'latin1':
          case 'binary':
            return latin1Slice(this, start, end);

          case 'base64':
            return base64Slice(this, start, end);

          case 'ucs2':
          case 'ucs-2':
          case 'utf16le':
          case 'utf-16le':
            return utf16leSlice(this, start, end);

          default:
            if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding);
            encoding = (encoding + '').toLowerCase();
            loweredCase = true;
        }
      }
    } // The property is used by `Buffer.isBuffer` and `is-buffer` (in Safari 5-7) to detect
    // Buffer instances.


    Buffer.prototype._isBuffer = true;

    function swap(b, n, m) {
      var i = b[n];
      b[n] = b[m];
      b[m] = i;
    }

    Buffer.prototype.swap16 = function swap16() {
      var len = this.length;

      if (len % 2 !== 0) {
        throw new RangeError('Buffer size must be a multiple of 16-bits');
      }

      for (var i = 0; i < len; i += 2) {
        swap(this, i, i + 1);
      }

      return this;
    };

    Buffer.prototype.swap32 = function swap32() {
      var len = this.length;

      if (len % 4 !== 0) {
        throw new RangeError('Buffer size must be a multiple of 32-bits');
      }

      for (var i = 0; i < len; i += 4) {
        swap(this, i, i + 3);
        swap(this, i + 1, i + 2);
      }

      return this;
    };

    Buffer.prototype.swap64 = function swap64() {
      var len = this.length;

      if (len % 8 !== 0) {
        throw new RangeError('Buffer size must be a multiple of 64-bits');
      }

      for (var i = 0; i < len; i += 8) {
        swap(this, i, i + 7);
        swap(this, i + 1, i + 6);
        swap(this, i + 2, i + 5);
        swap(this, i + 3, i + 4);
      }

      return this;
    };

    Buffer.prototype.toString = function toString() {
      var length = this.length | 0;
      if (length === 0) return '';
      if (arguments.length === 0) return utf8Slice(this, 0, length);
      return slowToString.apply(this, arguments);
    };

    Buffer.prototype.equals = function equals(b) {
      if (!internalIsBuffer(b)) throw new TypeError('Argument must be a Buffer');
      if (this === b) return true;
      return Buffer.compare(this, b) === 0;
    };

    Buffer.prototype.inspect = function inspect() {
      var str = '';
      var max = INSPECT_MAX_BYTES;

      if (this.length > 0) {
        str = this.toString('hex', 0, max).match(/.{2}/g).join(' ');
        if (this.length > max) str += ' ... ';
      }

      return '<Buffer ' + str + '>';
    };

    Buffer.prototype.compare = function compare(target, start, end, thisStart, thisEnd) {
      if (!internalIsBuffer(target)) {
        throw new TypeError('Argument must be a Buffer');
      }

      if (start === undefined) {
        start = 0;
      }

      if (end === undefined) {
        end = target ? target.length : 0;
      }

      if (thisStart === undefined) {
        thisStart = 0;
      }

      if (thisEnd === undefined) {
        thisEnd = this.length;
      }

      if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
        throw new RangeError('out of range index');
      }

      if (thisStart >= thisEnd && start >= end) {
        return 0;
      }

      if (thisStart >= thisEnd) {
        return -1;
      }

      if (start >= end) {
        return 1;
      }

      start >>>= 0;
      end >>>= 0;
      thisStart >>>= 0;
      thisEnd >>>= 0;
      if (this === target) return 0;
      var x = thisEnd - thisStart;
      var y = end - start;
      var len = Math.min(x, y);
      var thisCopy = this.slice(thisStart, thisEnd);
      var targetCopy = target.slice(start, end);

      for (var i = 0; i < len; ++i) {
        if (thisCopy[i] !== targetCopy[i]) {
          x = thisCopy[i];
          y = targetCopy[i];
          break;
        }
      }

      if (x < y) return -1;
      if (y < x) return 1;
      return 0;
    }; // Finds either the first index of `val` in `buffer` at offset >= `byteOffset`,
    // OR the last index of `val` in `buffer` at offset <= `byteOffset`.
    //
    // Arguments:
    // - buffer - a Buffer to search
    // - val - a string, Buffer, or number
    // - byteOffset - an index into `buffer`; will be clamped to an int32
    // - encoding - an optional encoding, relevant is val is a string
    // - dir - true for indexOf, false for lastIndexOf


    function bidirectionalIndexOf(buffer, val, byteOffset, encoding, dir) {
      // Empty buffer means no match
      if (buffer.length === 0) return -1; // Normalize byteOffset

      if (typeof byteOffset === 'string') {
        encoding = byteOffset;
        byteOffset = 0;
      } else if (byteOffset > 0x7fffffff) {
        byteOffset = 0x7fffffff;
      } else if (byteOffset < -0x80000000) {
        byteOffset = -0x80000000;
      }

      byteOffset = +byteOffset; // Coerce to Number.

      if (isNaN(byteOffset)) {
        // byteOffset: it it's undefined, null, NaN, "foo", etc, search whole buffer
        byteOffset = dir ? 0 : buffer.length - 1;
      } // Normalize byteOffset: negative offsets start from the end of the buffer


      if (byteOffset < 0) byteOffset = buffer.length + byteOffset;

      if (byteOffset >= buffer.length) {
        if (dir) return -1;else byteOffset = buffer.length - 1;
      } else if (byteOffset < 0) {
        if (dir) byteOffset = 0;else return -1;
      } // Normalize val


      if (typeof val === 'string') {
        val = Buffer.from(val, encoding);
      } // Finally, search either indexOf (if dir is true) or lastIndexOf


      if (internalIsBuffer(val)) {
        // Special case: looking for empty string/buffer always fails
        if (val.length === 0) {
          return -1;
        }

        return arrayIndexOf(buffer, val, byteOffset, encoding, dir);
      } else if (typeof val === 'number') {
        val = val & 0xFF; // Search for a byte value [0-255]

        if (Buffer.TYPED_ARRAY_SUPPORT && typeof Uint8Array.prototype.indexOf === 'function') {
          if (dir) {
            return Uint8Array.prototype.indexOf.call(buffer, val, byteOffset);
          } else {
            return Uint8Array.prototype.lastIndexOf.call(buffer, val, byteOffset);
          }
        }

        return arrayIndexOf(buffer, [val], byteOffset, encoding, dir);
      }

      throw new TypeError('val must be string, number or Buffer');
    }

    function arrayIndexOf(arr, val, byteOffset, encoding, dir) {
      var indexSize = 1;
      var arrLength = arr.length;
      var valLength = val.length;

      if (encoding !== undefined) {
        encoding = String(encoding).toLowerCase();

        if (encoding === 'ucs2' || encoding === 'ucs-2' || encoding === 'utf16le' || encoding === 'utf-16le') {
          if (arr.length < 2 || val.length < 2) {
            return -1;
          }

          indexSize = 2;
          arrLength /= 2;
          valLength /= 2;
          byteOffset /= 2;
        }
      }

      function read(buf, i) {
        if (indexSize === 1) {
          return buf[i];
        } else {
          return buf.readUInt16BE(i * indexSize);
        }
      }

      var i;

      if (dir) {
        var foundIndex = -1;

        for (i = byteOffset; i < arrLength; i++) {
          if (read(arr, i) === read(val, foundIndex === -1 ? 0 : i - foundIndex)) {
            if (foundIndex === -1) foundIndex = i;
            if (i - foundIndex + 1 === valLength) return foundIndex * indexSize;
          } else {
            if (foundIndex !== -1) i -= i - foundIndex;
            foundIndex = -1;
          }
        }
      } else {
        if (byteOffset + valLength > arrLength) byteOffset = arrLength - valLength;

        for (i = byteOffset; i >= 0; i--) {
          var found = true;

          for (var j = 0; j < valLength; j++) {
            if (read(arr, i + j) !== read(val, j)) {
              found = false;
              break;
            }
          }

          if (found) return i;
        }
      }

      return -1;
    }

    Buffer.prototype.includes = function includes(val, byteOffset, encoding) {
      return this.indexOf(val, byteOffset, encoding) !== -1;
    };

    Buffer.prototype.indexOf = function indexOf(val, byteOffset, encoding) {
      return bidirectionalIndexOf(this, val, byteOffset, encoding, true);
    };

    Buffer.prototype.lastIndexOf = function lastIndexOf(val, byteOffset, encoding) {
      return bidirectionalIndexOf(this, val, byteOffset, encoding, false);
    };

    function hexWrite(buf, string, offset, length) {
      offset = Number(offset) || 0;
      var remaining = buf.length - offset;

      if (!length) {
        length = remaining;
      } else {
        length = Number(length);

        if (length > remaining) {
          length = remaining;
        }
      } // must be an even number of digits


      var strLen = string.length;
      if (strLen % 2 !== 0) throw new TypeError('Invalid hex string');

      if (length > strLen / 2) {
        length = strLen / 2;
      }

      for (var i = 0; i < length; ++i) {
        var parsed = parseInt(string.substr(i * 2, 2), 16);
        if (isNaN(parsed)) return i;
        buf[offset + i] = parsed;
      }

      return i;
    }

    function utf8Write(buf, string, offset, length) {
      return blitBuffer(utf8ToBytes(string, buf.length - offset), buf, offset, length);
    }

    function asciiWrite(buf, string, offset, length) {
      return blitBuffer(asciiToBytes(string), buf, offset, length);
    }

    function latin1Write(buf, string, offset, length) {
      return asciiWrite(buf, string, offset, length);
    }

    function base64Write(buf, string, offset, length) {
      return blitBuffer(base64ToBytes(string), buf, offset, length);
    }

    function ucs2Write(buf, string, offset, length) {
      return blitBuffer(utf16leToBytes(string, buf.length - offset), buf, offset, length);
    }

    Buffer.prototype.write = function write(string, offset, length, encoding) {
      // Buffer#write(string)
      if (offset === undefined) {
        encoding = 'utf8';
        length = this.length;
        offset = 0; // Buffer#write(string, encoding)
      } else if (length === undefined && typeof offset === 'string') {
        encoding = offset;
        length = this.length;
        offset = 0; // Buffer#write(string, offset[, length][, encoding])
      } else if (isFinite(offset)) {
        offset = offset | 0;

        if (isFinite(length)) {
          length = length | 0;
          if (encoding === undefined) encoding = 'utf8';
        } else {
          encoding = length;
          length = undefined;
        } // legacy write(string, encoding, offset, length) - remove in v0.13

      } else {
        throw new Error('Buffer.write(string, encoding, offset[, length]) is no longer supported');
      }

      var remaining = this.length - offset;
      if (length === undefined || length > remaining) length = remaining;

      if (string.length > 0 && (length < 0 || offset < 0) || offset > this.length) {
        throw new RangeError('Attempt to write outside buffer bounds');
      }

      if (!encoding) encoding = 'utf8';
      var loweredCase = false;

      for (;;) {
        switch (encoding) {
          case 'hex':
            return hexWrite(this, string, offset, length);

          case 'utf8':
          case 'utf-8':
            return utf8Write(this, string, offset, length);

          case 'ascii':
            return asciiWrite(this, string, offset, length);

          case 'latin1':
          case 'binary':
            return latin1Write(this, string, offset, length);

          case 'base64':
            // Warning: maxLength not taken into account in base64Write
            return base64Write(this, string, offset, length);

          case 'ucs2':
          case 'ucs-2':
          case 'utf16le':
          case 'utf-16le':
            return ucs2Write(this, string, offset, length);

          default:
            if (loweredCase) throw new TypeError('Unknown encoding: ' + encoding);
            encoding = ('' + encoding).toLowerCase();
            loweredCase = true;
        }
      }
    };

    Buffer.prototype.toJSON = function toJSON() {
      return {
        type: 'Buffer',
        data: Array.prototype.slice.call(this._arr || this, 0)
      };
    };

    function base64Slice(buf, start, end) {
      if (start === 0 && end === buf.length) {
        return fromByteArray(buf);
      } else {
        return fromByteArray(buf.slice(start, end));
      }
    }

    function utf8Slice(buf, start, end) {
      end = Math.min(buf.length, end);
      var res = [];
      var i = start;

      while (i < end) {
        var firstByte = buf[i];
        var codePoint = null;
        var bytesPerSequence = firstByte > 0xEF ? 4 : firstByte > 0xDF ? 3 : firstByte > 0xBF ? 2 : 1;

        if (i + bytesPerSequence <= end) {
          var secondByte, thirdByte, fourthByte, tempCodePoint;

          switch (bytesPerSequence) {
            case 1:
              if (firstByte < 0x80) {
                codePoint = firstByte;
              }

              break;

            case 2:
              secondByte = buf[i + 1];

              if ((secondByte & 0xC0) === 0x80) {
                tempCodePoint = (firstByte & 0x1F) << 0x6 | secondByte & 0x3F;

                if (tempCodePoint > 0x7F) {
                  codePoint = tempCodePoint;
                }
              }

              break;

            case 3:
              secondByte = buf[i + 1];
              thirdByte = buf[i + 2];

              if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80) {
                tempCodePoint = (firstByte & 0xF) << 0xC | (secondByte & 0x3F) << 0x6 | thirdByte & 0x3F;

                if (tempCodePoint > 0x7FF && (tempCodePoint < 0xD800 || tempCodePoint > 0xDFFF)) {
                  codePoint = tempCodePoint;
                }
              }

              break;

            case 4:
              secondByte = buf[i + 1];
              thirdByte = buf[i + 2];
              fourthByte = buf[i + 3];

              if ((secondByte & 0xC0) === 0x80 && (thirdByte & 0xC0) === 0x80 && (fourthByte & 0xC0) === 0x80) {
                tempCodePoint = (firstByte & 0xF) << 0x12 | (secondByte & 0x3F) << 0xC | (thirdByte & 0x3F) << 0x6 | fourthByte & 0x3F;

                if (tempCodePoint > 0xFFFF && tempCodePoint < 0x110000) {
                  codePoint = tempCodePoint;
                }
              }

          }
        }

        if (codePoint === null) {
          // we did not generate a valid codePoint so insert a
          // replacement char (U+FFFD) and advance only 1 byte
          codePoint = 0xFFFD;
          bytesPerSequence = 1;
        } else if (codePoint > 0xFFFF) {
          // encode to utf16 (surrogate pair dance)
          codePoint -= 0x10000;
          res.push(codePoint >>> 10 & 0x3FF | 0xD800);
          codePoint = 0xDC00 | codePoint & 0x3FF;
        }

        res.push(codePoint);
        i += bytesPerSequence;
      }

      return decodeCodePointsArray(res);
    } // Based on http://stackoverflow.com/a/22747272/680742, the browser with
    // the lowest limit is Chrome, with 0x10000 args.
    // We go 1 magnitude less, for safety


    var MAX_ARGUMENTS_LENGTH = 0x1000;

    function decodeCodePointsArray(codePoints) {
      var len = codePoints.length;

      if (len <= MAX_ARGUMENTS_LENGTH) {
        return String.fromCharCode.apply(String, codePoints); // avoid extra slice()
      } // Decode in chunks to avoid "call stack size exceeded".


      var res = '';
      var i = 0;

      while (i < len) {
        res += String.fromCharCode.apply(String, codePoints.slice(i, i += MAX_ARGUMENTS_LENGTH));
      }

      return res;
    }

    function asciiSlice(buf, start, end) {
      var ret = '';
      end = Math.min(buf.length, end);

      for (var i = start; i < end; ++i) {
        ret += String.fromCharCode(buf[i] & 0x7F);
      }

      return ret;
    }

    function latin1Slice(buf, start, end) {
      var ret = '';
      end = Math.min(buf.length, end);

      for (var i = start; i < end; ++i) {
        ret += String.fromCharCode(buf[i]);
      }

      return ret;
    }

    function hexSlice(buf, start, end) {
      var len = buf.length;
      if (!start || start < 0) start = 0;
      if (!end || end < 0 || end > len) end = len;
      var out = '';

      for (var i = start; i < end; ++i) {
        out += toHex(buf[i]);
      }

      return out;
    }

    function utf16leSlice(buf, start, end) {
      var bytes = buf.slice(start, end);
      var res = '';

      for (var i = 0; i < bytes.length; i += 2) {
        res += String.fromCharCode(bytes[i] + bytes[i + 1] * 256);
      }

      return res;
    }

    Buffer.prototype.slice = function slice(start, end) {
      var len = this.length;
      start = ~~start;
      end = end === undefined ? len : ~~end;

      if (start < 0) {
        start += len;
        if (start < 0) start = 0;
      } else if (start > len) {
        start = len;
      }

      if (end < 0) {
        end += len;
        if (end < 0) end = 0;
      } else if (end > len) {
        end = len;
      }

      if (end < start) end = start;
      var newBuf;

      if (Buffer.TYPED_ARRAY_SUPPORT) {
        newBuf = this.subarray(start, end);
        newBuf.__proto__ = Buffer.prototype;
      } else {
        var sliceLen = end - start;
        newBuf = new Buffer(sliceLen, undefined);

        for (var i = 0; i < sliceLen; ++i) {
          newBuf[i] = this[i + start];
        }
      }

      return newBuf;
    };
    /*
     * Need to make sure that buffer isn't trying to write out of bounds.
     */


    function checkOffset(offset, ext, length) {
      if (offset % 1 !== 0 || offset < 0) throw new RangeError('offset is not uint');
      if (offset + ext > length) throw new RangeError('Trying to access beyond buffer length');
    }

    Buffer.prototype.readUIntLE = function readUIntLE(offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) checkOffset(offset, byteLength, this.length);
      var val = this[offset];
      var mul = 1;
      var i = 0;

      while (++i < byteLength && (mul *= 0x100)) {
        val += this[offset + i] * mul;
      }

      return val;
    };

    Buffer.prototype.readUIntBE = function readUIntBE(offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;

      if (!noAssert) {
        checkOffset(offset, byteLength, this.length);
      }

      var val = this[offset + --byteLength];
      var mul = 1;

      while (byteLength > 0 && (mul *= 0x100)) {
        val += this[offset + --byteLength] * mul;
      }

      return val;
    };

    Buffer.prototype.readUInt8 = function readUInt8(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 1, this.length);
      return this[offset];
    };

    Buffer.prototype.readUInt16LE = function readUInt16LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      return this[offset] | this[offset + 1] << 8;
    };

    Buffer.prototype.readUInt16BE = function readUInt16BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      return this[offset] << 8 | this[offset + 1];
    };

    Buffer.prototype.readUInt32LE = function readUInt32LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return (this[offset] | this[offset + 1] << 8 | this[offset + 2] << 16) + this[offset + 3] * 0x1000000;
    };

    Buffer.prototype.readUInt32BE = function readUInt32BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return this[offset] * 0x1000000 + (this[offset + 1] << 16 | this[offset + 2] << 8 | this[offset + 3]);
    };

    Buffer.prototype.readIntLE = function readIntLE(offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) checkOffset(offset, byteLength, this.length);
      var val = this[offset];
      var mul = 1;
      var i = 0;

      while (++i < byteLength && (mul *= 0x100)) {
        val += this[offset + i] * mul;
      }

      mul *= 0x80;
      if (val >= mul) val -= Math.pow(2, 8 * byteLength);
      return val;
    };

    Buffer.prototype.readIntBE = function readIntBE(offset, byteLength, noAssert) {
      offset = offset | 0;
      byteLength = byteLength | 0;
      if (!noAssert) checkOffset(offset, byteLength, this.length);
      var i = byteLength;
      var mul = 1;
      var val = this[offset + --i];

      while (i > 0 && (mul *= 0x100)) {
        val += this[offset + --i] * mul;
      }

      mul *= 0x80;
      if (val >= mul) val -= Math.pow(2, 8 * byteLength);
      return val;
    };

    Buffer.prototype.readInt8 = function readInt8(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 1, this.length);
      if (!(this[offset] & 0x80)) return this[offset];
      return (0xff - this[offset] + 1) * -1;
    };

    Buffer.prototype.readInt16LE = function readInt16LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      var val = this[offset] | this[offset + 1] << 8;
      return val & 0x8000 ? val | 0xFFFF0000 : val;
    };

    Buffer.prototype.readInt16BE = function readInt16BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 2, this.length);
      var val = this[offset + 1] | this[offset] << 8;
      return val & 0x8000 ? val | 0xFFFF0000 : val;
    };

    Buffer.prototype.readInt32LE = function readInt32LE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return this[offset] | this[offset + 1] << 8 | this[offset + 2] << 16 | this[offset + 3] << 24;
    };

    Buffer.prototype.readInt32BE = function readInt32BE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return this[offset] << 24 | this[offset + 1] << 16 | this[offset + 2] << 8 | this[offset + 3];
    };

    Buffer.prototype.readFloatLE = function readFloatLE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return read(this, offset, true, 23, 4);
    };

    Buffer.prototype.readFloatBE = function readFloatBE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 4, this.length);
      return read(this, offset, false, 23, 4);
    };

    Buffer.prototype.readDoubleLE = function readDoubleLE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 8, this.length);
      return read(this, offset, true, 52, 8);
    };

    Buffer.prototype.readDoubleBE = function readDoubleBE(offset, noAssert) {
      if (!noAssert) checkOffset(offset, 8, this.length);
      return read(this, offset, false, 52, 8);
    };

    function checkInt(buf, value, offset, ext, max, min) {
      if (!internalIsBuffer(buf)) throw new TypeError('"buffer" argument must be a Buffer instance');
      if (value > max || value < min) throw new RangeError('"value" argument is out of bounds');
      if (offset + ext > buf.length) throw new RangeError('Index out of range');
    }

    Buffer.prototype.writeUIntLE = function writeUIntLE(value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;
      byteLength = byteLength | 0;

      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength) - 1;
        checkInt(this, value, offset, byteLength, maxBytes, 0);
      }

      var mul = 1;
      var i = 0;
      this[offset] = value & 0xFF;

      while (++i < byteLength && (mul *= 0x100)) {
        this[offset + i] = value / mul & 0xFF;
      }

      return offset + byteLength;
    };

    Buffer.prototype.writeUIntBE = function writeUIntBE(value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;
      byteLength = byteLength | 0;

      if (!noAssert) {
        var maxBytes = Math.pow(2, 8 * byteLength) - 1;
        checkInt(this, value, offset, byteLength, maxBytes, 0);
      }

      var i = byteLength - 1;
      var mul = 1;
      this[offset + i] = value & 0xFF;

      while (--i >= 0 && (mul *= 0x100)) {
        this[offset + i] = value / mul & 0xFF;
      }

      return offset + byteLength;
    };

    Buffer.prototype.writeUInt8 = function writeUInt8(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 1, 0xff, 0);
      if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
      this[offset] = value & 0xff;
      return offset + 1;
    };

    function objectWriteUInt16(buf, value, offset, littleEndian) {
      if (value < 0) value = 0xffff + value + 1;

      for (var i = 0, j = Math.min(buf.length - offset, 2); i < j; ++i) {
        buf[offset + i] = (value & 0xff << 8 * (littleEndian ? i : 1 - i)) >>> (littleEndian ? i : 1 - i) * 8;
      }
    }

    Buffer.prototype.writeUInt16LE = function writeUInt16LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);

      if (Buffer.TYPED_ARRAY_SUPPORT) {
        this[offset] = value & 0xff;
        this[offset + 1] = value >>> 8;
      } else {
        objectWriteUInt16(this, value, offset, true);
      }

      return offset + 2;
    };

    Buffer.prototype.writeUInt16BE = function writeUInt16BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 0xffff, 0);

      if (Buffer.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 8;
        this[offset + 1] = value & 0xff;
      } else {
        objectWriteUInt16(this, value, offset, false);
      }

      return offset + 2;
    };

    function objectWriteUInt32(buf, value, offset, littleEndian) {
      if (value < 0) value = 0xffffffff + value + 1;

      for (var i = 0, j = Math.min(buf.length - offset, 4); i < j; ++i) {
        buf[offset + i] = value >>> (littleEndian ? i : 3 - i) * 8 & 0xff;
      }
    }

    Buffer.prototype.writeUInt32LE = function writeUInt32LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);

      if (Buffer.TYPED_ARRAY_SUPPORT) {
        this[offset + 3] = value >>> 24;
        this[offset + 2] = value >>> 16;
        this[offset + 1] = value >>> 8;
        this[offset] = value & 0xff;
      } else {
        objectWriteUInt32(this, value, offset, true);
      }

      return offset + 4;
    };

    Buffer.prototype.writeUInt32BE = function writeUInt32BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 0xffffffff, 0);

      if (Buffer.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 24;
        this[offset + 1] = value >>> 16;
        this[offset + 2] = value >>> 8;
        this[offset + 3] = value & 0xff;
      } else {
        objectWriteUInt32(this, value, offset, false);
      }

      return offset + 4;
    };

    Buffer.prototype.writeIntLE = function writeIntLE(value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;

      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength - 1);
        checkInt(this, value, offset, byteLength, limit - 1, -limit);
      }

      var i = 0;
      var mul = 1;
      var sub = 0;
      this[offset] = value & 0xFF;

      while (++i < byteLength && (mul *= 0x100)) {
        if (value < 0 && sub === 0 && this[offset + i - 1] !== 0) {
          sub = 1;
        }

        this[offset + i] = (value / mul >> 0) - sub & 0xFF;
      }

      return offset + byteLength;
    };

    Buffer.prototype.writeIntBE = function writeIntBE(value, offset, byteLength, noAssert) {
      value = +value;
      offset = offset | 0;

      if (!noAssert) {
        var limit = Math.pow(2, 8 * byteLength - 1);
        checkInt(this, value, offset, byteLength, limit - 1, -limit);
      }

      var i = byteLength - 1;
      var mul = 1;
      var sub = 0;
      this[offset + i] = value & 0xFF;

      while (--i >= 0 && (mul *= 0x100)) {
        if (value < 0 && sub === 0 && this[offset + i + 1] !== 0) {
          sub = 1;
        }

        this[offset + i] = (value / mul >> 0) - sub & 0xFF;
      }

      return offset + byteLength;
    };

    Buffer.prototype.writeInt8 = function writeInt8(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 1, 0x7f, -0x80);
      if (!Buffer.TYPED_ARRAY_SUPPORT) value = Math.floor(value);
      if (value < 0) value = 0xff + value + 1;
      this[offset] = value & 0xff;
      return offset + 1;
    };

    Buffer.prototype.writeInt16LE = function writeInt16LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);

      if (Buffer.TYPED_ARRAY_SUPPORT) {
        this[offset] = value & 0xff;
        this[offset + 1] = value >>> 8;
      } else {
        objectWriteUInt16(this, value, offset, true);
      }

      return offset + 2;
    };

    Buffer.prototype.writeInt16BE = function writeInt16BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 2, 0x7fff, -0x8000);

      if (Buffer.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 8;
        this[offset + 1] = value & 0xff;
      } else {
        objectWriteUInt16(this, value, offset, false);
      }

      return offset + 2;
    };

    Buffer.prototype.writeInt32LE = function writeInt32LE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);

      if (Buffer.TYPED_ARRAY_SUPPORT) {
        this[offset] = value & 0xff;
        this[offset + 1] = value >>> 8;
        this[offset + 2] = value >>> 16;
        this[offset + 3] = value >>> 24;
      } else {
        objectWriteUInt32(this, value, offset, true);
      }

      return offset + 4;
    };

    Buffer.prototype.writeInt32BE = function writeInt32BE(value, offset, noAssert) {
      value = +value;
      offset = offset | 0;
      if (!noAssert) checkInt(this, value, offset, 4, 0x7fffffff, -0x80000000);
      if (value < 0) value = 0xffffffff + value + 1;

      if (Buffer.TYPED_ARRAY_SUPPORT) {
        this[offset] = value >>> 24;
        this[offset + 1] = value >>> 16;
        this[offset + 2] = value >>> 8;
        this[offset + 3] = value & 0xff;
      } else {
        objectWriteUInt32(this, value, offset, false);
      }

      return offset + 4;
    };

    function checkIEEE754(buf, value, offset, ext, max, min) {
      if (offset + ext > buf.length) throw new RangeError('Index out of range');
      if (offset < 0) throw new RangeError('Index out of range');
    }

    function writeFloat(buf, value, offset, littleEndian, noAssert) {
      if (!noAssert) {
        checkIEEE754(buf, value, offset, 4);
      }

      write(buf, value, offset, littleEndian, 23, 4);
      return offset + 4;
    }

    Buffer.prototype.writeFloatLE = function writeFloatLE(value, offset, noAssert) {
      return writeFloat(this, value, offset, true, noAssert);
    };

    Buffer.prototype.writeFloatBE = function writeFloatBE(value, offset, noAssert) {
      return writeFloat(this, value, offset, false, noAssert);
    };

    function writeDouble(buf, value, offset, littleEndian, noAssert) {
      if (!noAssert) {
        checkIEEE754(buf, value, offset, 8);
      }

      write(buf, value, offset, littleEndian, 52, 8);
      return offset + 8;
    }

    Buffer.prototype.writeDoubleLE = function writeDoubleLE(value, offset, noAssert) {
      return writeDouble(this, value, offset, true, noAssert);
    };

    Buffer.prototype.writeDoubleBE = function writeDoubleBE(value, offset, noAssert) {
      return writeDouble(this, value, offset, false, noAssert);
    }; // copy(targetBuffer, targetStart=0, sourceStart=0, sourceEnd=buffer.length)


    Buffer.prototype.copy = function copy(target, targetStart, start, end) {
      if (!start) start = 0;
      if (!end && end !== 0) end = this.length;
      if (targetStart >= target.length) targetStart = target.length;
      if (!targetStart) targetStart = 0;
      if (end > 0 && end < start) end = start; // Copy 0 bytes; we're done

      if (end === start) return 0;
      if (target.length === 0 || this.length === 0) return 0; // Fatal error conditions

      if (targetStart < 0) {
        throw new RangeError('targetStart out of bounds');
      }

      if (start < 0 || start >= this.length) throw new RangeError('sourceStart out of bounds');
      if (end < 0) throw new RangeError('sourceEnd out of bounds'); // Are we oob?

      if (end > this.length) end = this.length;

      if (target.length - targetStart < end - start) {
        end = target.length - targetStart + start;
      }

      var len = end - start;
      var i;

      if (this === target && start < targetStart && targetStart < end) {
        // descending copy from end
        for (i = len - 1; i >= 0; --i) {
          target[i + targetStart] = this[i + start];
        }
      } else if (len < 1000 || !Buffer.TYPED_ARRAY_SUPPORT) {
        // ascending copy from start
        for (i = 0; i < len; ++i) {
          target[i + targetStart] = this[i + start];
        }
      } else {
        Uint8Array.prototype.set.call(target, this.subarray(start, start + len), targetStart);
      }

      return len;
    }; // Usage:
    //    buffer.fill(number[, offset[, end]])
    //    buffer.fill(buffer[, offset[, end]])
    //    buffer.fill(string[, offset[, end]][, encoding])


    Buffer.prototype.fill = function fill(val, start, end, encoding) {
      // Handle string cases:
      if (typeof val === 'string') {
        if (typeof start === 'string') {
          encoding = start;
          start = 0;
          end = this.length;
        } else if (typeof end === 'string') {
          encoding = end;
          end = this.length;
        }

        if (val.length === 1) {
          var code = val.charCodeAt(0);

          if (code < 256) {
            val = code;
          }
        }

        if (encoding !== undefined && typeof encoding !== 'string') {
          throw new TypeError('encoding must be a string');
        }

        if (typeof encoding === 'string' && !Buffer.isEncoding(encoding)) {
          throw new TypeError('Unknown encoding: ' + encoding);
        }
      } else if (typeof val === 'number') {
        val = val & 255;
      } // Invalid ranges are not set to a default, so can range check early.


      if (start < 0 || this.length < start || this.length < end) {
        throw new RangeError('Out of range index');
      }

      if (end <= start) {
        return this;
      }

      start = start >>> 0;
      end = end === undefined ? this.length : end >>> 0;
      if (!val) val = 0;
      var i;

      if (typeof val === 'number') {
        for (i = start; i < end; ++i) {
          this[i] = val;
        }
      } else {
        var bytes = internalIsBuffer(val) ? val : utf8ToBytes(new Buffer(val, encoding).toString());
        var len = bytes.length;

        for (i = 0; i < end - start; ++i) {
          this[i + start] = bytes[i % len];
        }
      }

      return this;
    }; // HELPER FUNCTIONS
    // ================


    var INVALID_BASE64_RE = /[^+\/0-9A-Za-z-_]/g;

    function base64clean(str) {
      // Node strips out invalid characters like \n and \t from the string, base64-js does not
      str = stringtrim(str).replace(INVALID_BASE64_RE, ''); // Node converts strings with length < 2 to ''

      if (str.length < 2) return ''; // Node allows for non-padded base64 strings (missing trailing ===), base64-js does not

      while (str.length % 4 !== 0) {
        str = str + '=';
      }

      return str;
    }

    function stringtrim(str) {
      if (str.trim) return str.trim();
      return str.replace(/^\s+|\s+$/g, '');
    }

    function toHex(n) {
      if (n < 16) return '0' + n.toString(16);
      return n.toString(16);
    }

    function utf8ToBytes(string, units) {
      units = units || Infinity;
      var codePoint;
      var length = string.length;
      var leadSurrogate = null;
      var bytes = [];

      for (var i = 0; i < length; ++i) {
        codePoint = string.charCodeAt(i); // is surrogate component

        if (codePoint > 0xD7FF && codePoint < 0xE000) {
          // last char was a lead
          if (!leadSurrogate) {
            // no lead yet
            if (codePoint > 0xDBFF) {
              // unexpected trail
              if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
              continue;
            } else if (i + 1 === length) {
              // unpaired lead
              if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
              continue;
            } // valid lead


            leadSurrogate = codePoint;
            continue;
          } // 2 leads in a row


          if (codePoint < 0xDC00) {
            if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
            leadSurrogate = codePoint;
            continue;
          } // valid surrogate pair


          codePoint = (leadSurrogate - 0xD800 << 10 | codePoint - 0xDC00) + 0x10000;
        } else if (leadSurrogate) {
          // valid bmp char, but last char was a lead
          if ((units -= 3) > -1) bytes.push(0xEF, 0xBF, 0xBD);
        }

        leadSurrogate = null; // encode utf8

        if (codePoint < 0x80) {
          if ((units -= 1) < 0) break;
          bytes.push(codePoint);
        } else if (codePoint < 0x800) {
          if ((units -= 2) < 0) break;
          bytes.push(codePoint >> 0x6 | 0xC0, codePoint & 0x3F | 0x80);
        } else if (codePoint < 0x10000) {
          if ((units -= 3) < 0) break;
          bytes.push(codePoint >> 0xC | 0xE0, codePoint >> 0x6 & 0x3F | 0x80, codePoint & 0x3F | 0x80);
        } else if (codePoint < 0x110000) {
          if ((units -= 4) < 0) break;
          bytes.push(codePoint >> 0x12 | 0xF0, codePoint >> 0xC & 0x3F | 0x80, codePoint >> 0x6 & 0x3F | 0x80, codePoint & 0x3F | 0x80);
        } else {
          throw new Error('Invalid code point');
        }
      }

      return bytes;
    }

    function asciiToBytes(str) {
      var byteArray = [];

      for (var i = 0; i < str.length; ++i) {
        // Node's code seems to be doing this and not & 0x7F..
        byteArray.push(str.charCodeAt(i) & 0xFF);
      }

      return byteArray;
    }

    function utf16leToBytes(str, units) {
      var c, hi, lo;
      var byteArray = [];

      for (var i = 0; i < str.length; ++i) {
        if ((units -= 2) < 0) break;
        c = str.charCodeAt(i);
        hi = c >> 8;
        lo = c % 256;
        byteArray.push(lo);
        byteArray.push(hi);
      }

      return byteArray;
    }

    function base64ToBytes(str) {
      return toByteArray(base64clean(str));
    }

    function blitBuffer(src, dst, offset, length) {
      for (var i = 0; i < length; ++i) {
        if (i + offset >= dst.length || i >= src.length) break;
        dst[i + offset] = src[i];
      }

      return i;
    }

    function isnan(val) {
      return val !== val; // eslint-disable-line no-self-compare
    } // the following is from is-buffer, also by Feross Aboukhadijeh and with same lisence
    // The _isBuffer check is for Safari 5-7 support, because it's missing
    // Object.prototype.constructor. Remove this eventually


    function isBuffer(obj) {
      return obj != null && (!!obj._isBuffer || isFastBuffer(obj) || isSlowBuffer(obj));
    }

    function isFastBuffer(obj) {
      return !!obj.constructor && typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj);
    } // For Node v0.10 support. Remove this eventually.


    function isSlowBuffer(obj) {
      return typeof obj.readFloatLE === 'function' && typeof obj.slice === 'function' && isFastBuffer(obj.slice(0, 0));
    }

    var hasFetch = isFunction$1(global$1.fetch) && isFunction$1(global$1.ReadableStream);

    var _blobConstructor;

    function blobConstructor() {
      if (typeof _blobConstructor !== 'undefined') {
        return _blobConstructor;
      }

      try {
        new global$1.Blob([new ArrayBuffer(1)]);
        _blobConstructor = true;
      } catch (e) {
        _blobConstructor = false;
      }

      return _blobConstructor;
    }
    var xhr;

    function checkTypeSupport(type) {
      if (!xhr) {
        xhr = new global$1.XMLHttpRequest(); // If location.host is empty, e.g. if this page/worker was loaded
        // from a Blob, then use example.com to avoid an error

        xhr.open('GET', global$1.location.host ? '/' : 'https://example.com');
      }

      try {
        xhr.responseType = type;
        return xhr.responseType === type;
      } catch (e) {
        return false;
      }
    } // For some strange reason, Safari 7.0 reports typeof global.ArrayBuffer === 'object'.
    // Safari 7.1 appears to have fixed this bug.


    var haveArrayBuffer = typeof global$1.ArrayBuffer !== 'undefined';
    var haveSlice = haveArrayBuffer && isFunction$1(global$1.ArrayBuffer.prototype.slice);
    var arraybuffer = haveArrayBuffer && checkTypeSupport('arraybuffer'); // These next two tests unavoidably show warnings in Chrome. Since fetch will always
    // be used if it's available, just return false for these to avoid the warnings.

    var msstream = !hasFetch && haveSlice && checkTypeSupport('ms-stream');
    var mozchunkedarraybuffer = !hasFetch && haveArrayBuffer && checkTypeSupport('moz-chunked-arraybuffer');
    var overrideMimeType = isFunction$1(xhr.overrideMimeType);
    var vbArray = isFunction$1(global$1.VBArray);

    function isFunction$1(value) {
      return typeof value === 'function';
    }

    xhr = null; // Help gc

    var inherits;

    if (typeof Object.create === 'function') {
      inherits = function inherits(ctor, superCtor) {
        // implementation from standard node.js 'util' module
        ctor.super_ = superCtor;
        ctor.prototype = Object.create(superCtor.prototype, {
          constructor: {
            value: ctor,
            enumerable: false,
            writable: true,
            configurable: true
          }
        });
      };
    } else {
      inherits = function inherits(ctor, superCtor) {
        ctor.super_ = superCtor;

        var TempCtor = function TempCtor() {};

        TempCtor.prototype = superCtor.prototype;
        ctor.prototype = new TempCtor();
        ctor.prototype.constructor = ctor;
      };
    }

    var inherits$1 = inherits;

    var formatRegExp = /%[sdj%]/g;
    function format(f) {
      if (!isString(f)) {
        var objects = [];

        for (var i = 0; i < arguments.length; i++) {
          objects.push(inspect(arguments[i]));
        }

        return objects.join(' ');
      }

      var i = 1;
      var args = arguments;
      var len = args.length;
      var str = String(f).replace(formatRegExp, function (x) {
        if (x === '%%') return '%';
        if (i >= len) return x;

        switch (x) {
          case '%s':
            return String(args[i++]);

          case '%d':
            return Number(args[i++]);

          case '%j':
            try {
              return JSON.stringify(args[i++]);
            } catch (_) {
              return '[Circular]';
            }

          default:
            return x;
        }
      });

      for (var x = args[i]; i < len; x = args[++i]) {
        if (isNull(x) || !isObject(x)) {
          str += ' ' + x;
        } else {
          str += ' ' + inspect(x);
        }
      }

      return str;
    }
    // Returns a modified function which warns once by default.
    // If --no-deprecation is set, then it is a no-op.

    function deprecate(fn, msg) {
      // Allow for deprecating things in the process of starting up.
      if (isUndefined(global$1.process)) {
        return function () {
          return deprecate(fn, msg).apply(this, arguments);
        };
      }

      if (browser$1.noDeprecation === true) {
        return fn;
      }

      var warned = false;

      function deprecated() {
        if (!warned) {
          if (browser$1.throwDeprecation) {
            throw new Error(msg);
          } else if (browser$1.traceDeprecation) {
            console.trace(msg);
          } else {
            console.error(msg);
          }

          warned = true;
        }

        return fn.apply(this, arguments);
      }

      return deprecated;
    }
    var debugs = {};
    var debugEnviron;
    function debuglog(set) {
      if (isUndefined(debugEnviron)) debugEnviron = browser$1.env.NODE_DEBUG || '';
      set = set.toUpperCase();

      if (!debugs[set]) {
        if (new RegExp('\\b' + set + '\\b', 'i').test(debugEnviron)) {
          var pid = 0;

          debugs[set] = function () {
            var msg = format.apply(null, arguments);
            console.error('%s %d: %s', set, pid, msg);
          };
        } else {
          debugs[set] = function () {};
        }
      }

      return debugs[set];
    }
    /**
     * Echos the value of a value. Trys to print the value out
     * in the best way possible given the different types.
     *
     * @param {Object} obj The object to print out.
     * @param {Object} opts Optional options object that alters the output.
     */

    /* legacy: obj, showHidden, depth, colors*/

    function inspect(obj, opts) {
      // default options
      var ctx = {
        seen: [],
        stylize: stylizeNoColor
      }; // legacy...

      if (arguments.length >= 3) ctx.depth = arguments[2];
      if (arguments.length >= 4) ctx.colors = arguments[3];

      if (isBoolean(opts)) {
        // legacy...
        ctx.showHidden = opts;
      } else if (opts) {
        // got an "options" object
        _extend(ctx, opts);
      } // set default options


      if (isUndefined(ctx.showHidden)) ctx.showHidden = false;
      if (isUndefined(ctx.depth)) ctx.depth = 2;
      if (isUndefined(ctx.colors)) ctx.colors = false;
      if (isUndefined(ctx.customInspect)) ctx.customInspect = true;
      if (ctx.colors) ctx.stylize = stylizeWithColor;
      return formatValue(ctx, obj, ctx.depth);
    } // http://en.wikipedia.org/wiki/ANSI_escape_code#graphics

    inspect.colors = {
      'bold': [1, 22],
      'italic': [3, 23],
      'underline': [4, 24],
      'inverse': [7, 27],
      'white': [37, 39],
      'grey': [90, 39],
      'black': [30, 39],
      'blue': [34, 39],
      'cyan': [36, 39],
      'green': [32, 39],
      'magenta': [35, 39],
      'red': [31, 39],
      'yellow': [33, 39]
    }; // Don't use 'blue' not visible on cmd.exe

    inspect.styles = {
      'special': 'cyan',
      'number': 'yellow',
      'boolean': 'yellow',
      'undefined': 'grey',
      'null': 'bold',
      'string': 'green',
      'date': 'magenta',
      // "name": intentionally not styling
      'regexp': 'red'
    };

    function stylizeWithColor(str, styleType) {
      var style = inspect.styles[styleType];

      if (style) {
        return "\x1B[" + inspect.colors[style][0] + 'm' + str + "\x1B[" + inspect.colors[style][1] + 'm';
      } else {
        return str;
      }
    }

    function stylizeNoColor(str, styleType) {
      return str;
    }

    function arrayToHash(array) {
      var hash = {};
      array.forEach(function (val, idx) {
        hash[val] = true;
      });
      return hash;
    }

    function formatValue(ctx, value, recurseTimes) {
      // Provide a hook for user-specified inspect functions.
      // Check that value is an object with an inspect function on it
      if (ctx.customInspect && value && isFunction(value.inspect) && // Filter out the util module, it's inspect function is special
      value.inspect !== inspect && // Also filter out any prototype objects using the circular check.
      !(value.constructor && value.constructor.prototype === value)) {
        var ret = value.inspect(recurseTimes, ctx);

        if (!isString(ret)) {
          ret = formatValue(ctx, ret, recurseTimes);
        }

        return ret;
      } // Primitive types cannot have properties


      var primitive = formatPrimitive(ctx, value);

      if (primitive) {
        return primitive;
      } // Look up the keys of the object.


      var keys = Object.keys(value);
      var visibleKeys = arrayToHash(keys);

      if (ctx.showHidden) {
        keys = Object.getOwnPropertyNames(value);
      } // IE doesn't make error fields non-enumerable
      // http://msdn.microsoft.com/en-us/library/ie/dww52sbt(v=vs.94).aspx


      if (isError(value) && (keys.indexOf('message') >= 0 || keys.indexOf('description') >= 0)) {
        return formatError(value);
      } // Some type of object without properties can be shortcutted.


      if (keys.length === 0) {
        if (isFunction(value)) {
          var name = value.name ? ': ' + value.name : '';
          return ctx.stylize('[Function' + name + ']', 'special');
        }

        if (isRegExp(value)) {
          return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
        }

        if (isDate(value)) {
          return ctx.stylize(Date.prototype.toString.call(value), 'date');
        }

        if (isError(value)) {
          return formatError(value);
        }
      }

      var base = '',
          array = false,
          braces = ['{', '}']; // Make Array say that they are Array

      if (isArray(value)) {
        array = true;
        braces = ['[', ']'];
      } // Make functions say that they are functions


      if (isFunction(value)) {
        var n = value.name ? ': ' + value.name : '';
        base = ' [Function' + n + ']';
      } // Make RegExps say that they are RegExps


      if (isRegExp(value)) {
        base = ' ' + RegExp.prototype.toString.call(value);
      } // Make dates with properties first say the date


      if (isDate(value)) {
        base = ' ' + Date.prototype.toUTCString.call(value);
      } // Make error with message first say the error


      if (isError(value)) {
        base = ' ' + formatError(value);
      }

      if (keys.length === 0 && (!array || value.length == 0)) {
        return braces[0] + base + braces[1];
      }

      if (recurseTimes < 0) {
        if (isRegExp(value)) {
          return ctx.stylize(RegExp.prototype.toString.call(value), 'regexp');
        } else {
          return ctx.stylize('[Object]', 'special');
        }
      }

      ctx.seen.push(value);
      var output;

      if (array) {
        output = formatArray(ctx, value, recurseTimes, visibleKeys, keys);
      } else {
        output = keys.map(function (key) {
          return formatProperty(ctx, value, recurseTimes, visibleKeys, key, array);
        });
      }

      ctx.seen.pop();
      return reduceToSingleString(output, base, braces);
    }

    function formatPrimitive(ctx, value) {
      if (isUndefined(value)) return ctx.stylize('undefined', 'undefined');

      if (isString(value)) {
        var simple = '\'' + JSON.stringify(value).replace(/^"|"$/g, '').replace(/'/g, "\\'").replace(/\\"/g, '"') + '\'';
        return ctx.stylize(simple, 'string');
      }

      if (isNumber(value)) return ctx.stylize('' + value, 'number');
      if (isBoolean(value)) return ctx.stylize('' + value, 'boolean'); // For some reason typeof null is "object", so special case here.

      if (isNull(value)) return ctx.stylize('null', 'null');
    }

    function formatError(value) {
      return '[' + Error.prototype.toString.call(value) + ']';
    }

    function formatArray(ctx, value, recurseTimes, visibleKeys, keys) {
      var output = [];

      for (var i = 0, l = value.length; i < l; ++i) {
        if (hasOwnProperty(value, String(i))) {
          output.push(formatProperty(ctx, value, recurseTimes, visibleKeys, String(i), true));
        } else {
          output.push('');
        }
      }

      keys.forEach(function (key) {
        if (!key.match(/^\d+$/)) {
          output.push(formatProperty(ctx, value, recurseTimes, visibleKeys, key, true));
        }
      });
      return output;
    }

    function formatProperty(ctx, value, recurseTimes, visibleKeys, key, array) {
      var name, str, desc;
      desc = Object.getOwnPropertyDescriptor(value, key) || {
        value: value[key]
      };

      if (desc.get) {
        if (desc.set) {
          str = ctx.stylize('[Getter/Setter]', 'special');
        } else {
          str = ctx.stylize('[Getter]', 'special');
        }
      } else {
        if (desc.set) {
          str = ctx.stylize('[Setter]', 'special');
        }
      }

      if (!hasOwnProperty(visibleKeys, key)) {
        name = '[' + key + ']';
      }

      if (!str) {
        if (ctx.seen.indexOf(desc.value) < 0) {
          if (isNull(recurseTimes)) {
            str = formatValue(ctx, desc.value, null);
          } else {
            str = formatValue(ctx, desc.value, recurseTimes - 1);
          }

          if (str.indexOf('\n') > -1) {
            if (array) {
              str = str.split('\n').map(function (line) {
                return '  ' + line;
              }).join('\n').substr(2);
            } else {
              str = '\n' + str.split('\n').map(function (line) {
                return '   ' + line;
              }).join('\n');
            }
          }
        } else {
          str = ctx.stylize('[Circular]', 'special');
        }
      }

      if (isUndefined(name)) {
        if (array && key.match(/^\d+$/)) {
          return str;
        }

        name = JSON.stringify('' + key);

        if (name.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)) {
          name = name.substr(1, name.length - 2);
          name = ctx.stylize(name, 'name');
        } else {
          name = name.replace(/'/g, "\\'").replace(/\\"/g, '"').replace(/(^"|"$)/g, "'");
          name = ctx.stylize(name, 'string');
        }
      }

      return name + ': ' + str;
    }

    function reduceToSingleString(output, base, braces) {
      var length = output.reduce(function (prev, cur) {
        if (cur.indexOf('\n') >= 0) ;
        return prev + cur.replace(/\u001b\[\d\d?m/g, '').length + 1;
      }, 0);

      if (length > 60) {
        return braces[0] + (base === '' ? '' : base + '\n ') + ' ' + output.join(',\n  ') + ' ' + braces[1];
      }

      return braces[0] + base + ' ' + output.join(', ') + ' ' + braces[1];
    } // NOTE: These type checking functions intentionally don't use `instanceof`
    // because it is fragile and can be easily faked with `Object.create()`.


    function isArray(ar) {
      return Array.isArray(ar);
    }
    function isBoolean(arg) {
      return typeof arg === 'boolean';
    }
    function isNull(arg) {
      return arg === null;
    }
    function isNumber(arg) {
      return typeof arg === 'number';
    }
    function isString(arg) {
      return typeof arg === 'string';
    }
    function isUndefined(arg) {
      return arg === void 0;
    }
    function isRegExp(re) {
      return isObject(re) && objectToString(re) === '[object RegExp]';
    }
    function isObject(arg) {
      return _typeof(arg) === 'object' && arg !== null;
    }
    function isDate(d) {
      return isObject(d) && objectToString(d) === '[object Date]';
    }
    function isError(e) {
      return isObject(e) && (objectToString(e) === '[object Error]' || e instanceof Error);
    }
    function isFunction(arg) {
      return typeof arg === 'function';
    }

    function objectToString(o) {
      return Object.prototype.toString.call(o);
    }
    function _extend(origin, add) {
      // Don't do anything if add isn't an object
      if (!add || !isObject(add)) return origin;
      var keys = Object.keys(add);
      var i = keys.length;

      while (i--) {
        origin[keys[i]] = add[keys[i]];
      }

      return origin;
    }

    function hasOwnProperty(obj, prop) {
      return Object.prototype.hasOwnProperty.call(obj, prop);
    }

    var domain; // This constructor is used to store event handlers. Instantiating this is
    // faster than explicitly calling `Object.create(null)` to get a "clean" empty
    // object (tested with v8 v4.9).

    function EventHandlers() {}

    EventHandlers.prototype = Object.create(null);

    function EventEmitter() {
      EventEmitter.init.call(this);
    }
    // require('events') === require('events').EventEmitter

    EventEmitter.EventEmitter = EventEmitter;
    EventEmitter.usingDomains = false;
    EventEmitter.prototype.domain = undefined;
    EventEmitter.prototype._events = undefined;
    EventEmitter.prototype._maxListeners = undefined; // By default EventEmitters will print a warning if more than 10 listeners are
    // added to it. This is a useful default which helps finding memory leaks.

    EventEmitter.defaultMaxListeners = 10;

    EventEmitter.init = function () {
      this.domain = null;

      if (EventEmitter.usingDomains) {
        // if there is an active domain, then attach to it.
        if (domain.active ) ;
      }

      if (!this._events || this._events === Object.getPrototypeOf(this)._events) {
        this._events = new EventHandlers();
        this._eventsCount = 0;
      }

      this._maxListeners = this._maxListeners || undefined;
    }; // Obviously not all Emitters should be limited to 10. This function allows
    // that to be increased. Set to zero for unlimited.


    EventEmitter.prototype.setMaxListeners = function setMaxListeners(n) {
      if (typeof n !== 'number' || n < 0 || isNaN(n)) throw new TypeError('"n" argument must be a positive number');
      this._maxListeners = n;
      return this;
    };

    function $getMaxListeners(that) {
      if (that._maxListeners === undefined) return EventEmitter.defaultMaxListeners;
      return that._maxListeners;
    }

    EventEmitter.prototype.getMaxListeners = function getMaxListeners() {
      return $getMaxListeners(this);
    }; // These standalone emit* functions are used to optimize calling of event
    // handlers for fast cases because emit() itself often has a variable number of
    // arguments and can be deoptimized because of that. These functions always have
    // the same number of arguments and thus do not get deoptimized, so the code
    // inside them can execute faster.


    function emitNone(handler, isFn, self) {
      if (isFn) handler.call(self);else {
        var len = handler.length;
        var listeners = arrayClone(handler, len);

        for (var i = 0; i < len; ++i) {
          listeners[i].call(self);
        }
      }
    }

    function emitOne(handler, isFn, self, arg1) {
      if (isFn) handler.call(self, arg1);else {
        var len = handler.length;
        var listeners = arrayClone(handler, len);

        for (var i = 0; i < len; ++i) {
          listeners[i].call(self, arg1);
        }
      }
    }

    function emitTwo(handler, isFn, self, arg1, arg2) {
      if (isFn) handler.call(self, arg1, arg2);else {
        var len = handler.length;
        var listeners = arrayClone(handler, len);

        for (var i = 0; i < len; ++i) {
          listeners[i].call(self, arg1, arg2);
        }
      }
    }

    function emitThree(handler, isFn, self, arg1, arg2, arg3) {
      if (isFn) handler.call(self, arg1, arg2, arg3);else {
        var len = handler.length;
        var listeners = arrayClone(handler, len);

        for (var i = 0; i < len; ++i) {
          listeners[i].call(self, arg1, arg2, arg3);
        }
      }
    }

    function emitMany(handler, isFn, self, args) {
      if (isFn) handler.apply(self, args);else {
        var len = handler.length;
        var listeners = arrayClone(handler, len);

        for (var i = 0; i < len; ++i) {
          listeners[i].apply(self, args);
        }
      }
    }

    EventEmitter.prototype.emit = function emit(type) {
      var er, handler, len, args, i, events, domain;
      var doError = type === 'error';
      events = this._events;
      if (events) doError = doError && events.error == null;else if (!doError) return false;
      domain = this.domain; // If there is no 'error' event listener then throw.

      if (doError) {
        er = arguments[1];

        if (domain) {
          if (!er) er = new Error('Uncaught, unspecified "error" event');
          er.domainEmitter = this;
          er.domain = domain;
          er.domainThrown = false;
          domain.emit('error', er);
        } else if (er instanceof Error) {
          throw er; // Unhandled 'error' event
        } else {
          // At least give some kind of context to the user
          var err = new Error('Uncaught, unspecified "error" event. (' + er + ')');
          err.context = er;
          throw err;
        }

        return false;
      }

      handler = events[type];
      if (!handler) return false;
      var isFn = typeof handler === 'function';
      len = arguments.length;

      switch (len) {
        // fast cases
        case 1:
          emitNone(handler, isFn, this);
          break;

        case 2:
          emitOne(handler, isFn, this, arguments[1]);
          break;

        case 3:
          emitTwo(handler, isFn, this, arguments[1], arguments[2]);
          break;

        case 4:
          emitThree(handler, isFn, this, arguments[1], arguments[2], arguments[3]);
          break;
        // slower

        default:
          args = new Array(len - 1);

          for (i = 1; i < len; i++) {
            args[i - 1] = arguments[i];
          }

          emitMany(handler, isFn, this, args);
      }
      return true;
    };

    function _addListener(target, type, listener, prepend) {
      var m;
      var events;
      var existing;
      if (typeof listener !== 'function') throw new TypeError('"listener" argument must be a function');
      events = target._events;

      if (!events) {
        events = target._events = new EventHandlers();
        target._eventsCount = 0;
      } else {
        // To avoid recursion in the case that type === "newListener"! Before
        // adding it to the listeners, first emit "newListener".
        if (events.newListener) {
          target.emit('newListener', type, listener.listener ? listener.listener : listener); // Re-assign `events` because a newListener handler could have caused the
          // this._events to be assigned to a new object

          events = target._events;
        }

        existing = events[type];
      }

      if (!existing) {
        // Optimize the case of one listener. Don't need the extra array object.
        existing = events[type] = listener;
        ++target._eventsCount;
      } else {
        if (typeof existing === 'function') {
          // Adding the second element, need to change to array.
          existing = events[type] = prepend ? [listener, existing] : [existing, listener];
        } else {
          // If we've already got an array, just append.
          if (prepend) {
            existing.unshift(listener);
          } else {
            existing.push(listener);
          }
        } // Check for listener leak


        if (!existing.warned) {
          m = $getMaxListeners(target);

          if (m && m > 0 && existing.length > m) {
            existing.warned = true;
            var w = new Error('Possible EventEmitter memory leak detected. ' + existing.length + ' ' + type + ' listeners added. ' + 'Use emitter.setMaxListeners() to increase limit');
            w.name = 'MaxListenersExceededWarning';
            w.emitter = target;
            w.type = type;
            w.count = existing.length;
            emitWarning(w);
          }
        }
      }

      return target;
    }

    function emitWarning(e) {
      typeof console.warn === 'function' ? console.warn(e) : console.log(e);
    }

    EventEmitter.prototype.addListener = function addListener(type, listener) {
      return _addListener(this, type, listener, false);
    };

    EventEmitter.prototype.on = EventEmitter.prototype.addListener;

    EventEmitter.prototype.prependListener = function prependListener(type, listener) {
      return _addListener(this, type, listener, true);
    };

    function _onceWrap(target, type, listener) {
      var fired = false;

      function g() {
        target.removeListener(type, g);

        if (!fired) {
          fired = true;
          listener.apply(target, arguments);
        }
      }

      g.listener = listener;
      return g;
    }

    EventEmitter.prototype.once = function once(type, listener) {
      if (typeof listener !== 'function') throw new TypeError('"listener" argument must be a function');
      this.on(type, _onceWrap(this, type, listener));
      return this;
    };

    EventEmitter.prototype.prependOnceListener = function prependOnceListener(type, listener) {
      if (typeof listener !== 'function') throw new TypeError('"listener" argument must be a function');
      this.prependListener(type, _onceWrap(this, type, listener));
      return this;
    }; // emits a 'removeListener' event iff the listener was removed


    EventEmitter.prototype.removeListener = function removeListener(type, listener) {
      var list, events, position, i, originalListener;
      if (typeof listener !== 'function') throw new TypeError('"listener" argument must be a function');
      events = this._events;
      if (!events) return this;
      list = events[type];
      if (!list) return this;

      if (list === listener || list.listener && list.listener === listener) {
        if (--this._eventsCount === 0) this._events = new EventHandlers();else {
          delete events[type];
          if (events.removeListener) this.emit('removeListener', type, list.listener || listener);
        }
      } else if (typeof list !== 'function') {
        position = -1;

        for (i = list.length; i-- > 0;) {
          if (list[i] === listener || list[i].listener && list[i].listener === listener) {
            originalListener = list[i].listener;
            position = i;
            break;
          }
        }

        if (position < 0) return this;

        if (list.length === 1) {
          list[0] = undefined;

          if (--this._eventsCount === 0) {
            this._events = new EventHandlers();
            return this;
          } else {
            delete events[type];
          }
        } else {
          spliceOne(list, position);
        }

        if (events.removeListener) this.emit('removeListener', type, originalListener || listener);
      }

      return this;
    };

    EventEmitter.prototype.removeAllListeners = function removeAllListeners(type) {
      var listeners, events;
      events = this._events;
      if (!events) return this; // not listening for removeListener, no need to emit

      if (!events.removeListener) {
        if (arguments.length === 0) {
          this._events = new EventHandlers();
          this._eventsCount = 0;
        } else if (events[type]) {
          if (--this._eventsCount === 0) this._events = new EventHandlers();else delete events[type];
        }

        return this;
      } // emit removeListener for all listeners on all events


      if (arguments.length === 0) {
        var keys = Object.keys(events);

        for (var i = 0, key; i < keys.length; ++i) {
          key = keys[i];
          if (key === 'removeListener') continue;
          this.removeAllListeners(key);
        }

        this.removeAllListeners('removeListener');
        this._events = new EventHandlers();
        this._eventsCount = 0;
        return this;
      }

      listeners = events[type];

      if (typeof listeners === 'function') {
        this.removeListener(type, listeners);
      } else if (listeners) {
        // LIFO order
        do {
          this.removeListener(type, listeners[listeners.length - 1]);
        } while (listeners[0]);
      }

      return this;
    };

    EventEmitter.prototype.listeners = function listeners(type) {
      var evlistener;
      var ret;
      var events = this._events;
      if (!events) ret = [];else {
        evlistener = events[type];
        if (!evlistener) ret = [];else if (typeof evlistener === 'function') ret = [evlistener.listener || evlistener];else ret = unwrapListeners(evlistener);
      }
      return ret;
    };

    EventEmitter.listenerCount = function (emitter, type) {
      if (typeof emitter.listenerCount === 'function') {
        return emitter.listenerCount(type);
      } else {
        return listenerCount$1.call(emitter, type);
      }
    };

    EventEmitter.prototype.listenerCount = listenerCount$1;

    function listenerCount$1(type) {
      var events = this._events;

      if (events) {
        var evlistener = events[type];

        if (typeof evlistener === 'function') {
          return 1;
        } else if (evlistener) {
          return evlistener.length;
        }
      }

      return 0;
    }

    EventEmitter.prototype.eventNames = function eventNames() {
      return this._eventsCount > 0 ? Reflect.ownKeys(this._events) : [];
    }; // About 1.5x faster than the two-arg version of Array#splice().


    function spliceOne(list, index) {
      for (var i = index, k = i + 1, n = list.length; k < n; i += 1, k += 1) {
        list[i] = list[k];
      }

      list.pop();
    }

    function arrayClone(arr, i) {
      var copy = new Array(i);

      while (i--) {
        copy[i] = arr[i];
      }

      return copy;
    }

    function unwrapListeners(arr) {
      var ret = new Array(arr.length);

      for (var i = 0; i < ret.length; ++i) {
        ret[i] = arr[i].listener || arr[i];
      }

      return ret;
    }

    function BufferList() {
      this.head = null;
      this.tail = null;
      this.length = 0;
    }

    BufferList.prototype.push = function (v) {
      var entry = {
        data: v,
        next: null
      };
      if (this.length > 0) this.tail.next = entry;else this.head = entry;
      this.tail = entry;
      ++this.length;
    };

    BufferList.prototype.unshift = function (v) {
      var entry = {
        data: v,
        next: this.head
      };
      if (this.length === 0) this.tail = entry;
      this.head = entry;
      ++this.length;
    };

    BufferList.prototype.shift = function () {
      if (this.length === 0) return;
      var ret = this.head.data;
      if (this.length === 1) this.head = this.tail = null;else this.head = this.head.next;
      --this.length;
      return ret;
    };

    BufferList.prototype.clear = function () {
      this.head = this.tail = null;
      this.length = 0;
    };

    BufferList.prototype.join = function (s) {
      if (this.length === 0) return '';
      var p = this.head;
      var ret = '' + p.data;

      while (p = p.next) {
        ret += s + p.data;
      }

      return ret;
    };

    BufferList.prototype.concat = function (n) {
      if (this.length === 0) return Buffer.alloc(0);
      if (this.length === 1) return this.head.data;
      var ret = Buffer.allocUnsafe(n >>> 0);
      var p = this.head;
      var i = 0;

      while (p) {
        p.data.copy(ret, i);
        i += p.data.length;
        p = p.next;
      }

      return ret;
    };

    // Copyright Joyent, Inc. and other Node contributors.

    var isBufferEncoding = Buffer.isEncoding || function (encoding) {
      switch (encoding && encoding.toLowerCase()) {
        case 'hex':
        case 'utf8':
        case 'utf-8':
        case 'ascii':
        case 'binary':
        case 'base64':
        case 'ucs2':
        case 'ucs-2':
        case 'utf16le':
        case 'utf-16le':
        case 'raw':
          return true;

        default:
          return false;
      }
    };

    function assertEncoding(encoding) {
      if (encoding && !isBufferEncoding(encoding)) {
        throw new Error('Unknown encoding: ' + encoding);
      }
    } // StringDecoder provides an interface for efficiently splitting a series of
    // buffers into a series of JS strings without breaking apart multi-byte
    // characters. CESU-8 is handled as part of the UTF-8 encoding.
    //
    // @TODO Handling all encodings inside a single object makes it very difficult
    // to reason about this code, so it should be split up in the future.
    // @TODO There should be a utf8-strict encoding that rejects invalid UTF-8 code
    // points as used by CESU-8.


    function StringDecoder(encoding) {
      this.encoding = (encoding || 'utf8').toLowerCase().replace(/[-_]/, '');
      assertEncoding(encoding);

      switch (this.encoding) {
        case 'utf8':
          // CESU-8 represents each of Surrogate Pair by 3-bytes
          this.surrogateSize = 3;
          break;

        case 'ucs2':
        case 'utf16le':
          // UTF-16 represents each of Surrogate Pair by 2-bytes
          this.surrogateSize = 2;
          this.detectIncompleteChar = utf16DetectIncompleteChar;
          break;

        case 'base64':
          // Base-64 stores 3 bytes in 4 chars, and pads the remainder.
          this.surrogateSize = 3;
          this.detectIncompleteChar = base64DetectIncompleteChar;
          break;

        default:
          this.write = passThroughWrite;
          return;
      } // Enough space to store all bytes of a single character. UTF-8 needs 4
      // bytes, but CESU-8 may require up to 6 (3 bytes per surrogate).


      this.charBuffer = new Buffer(6); // Number of bytes received for the current incomplete multi-byte character.

      this.charReceived = 0; // Number of bytes expected for the current incomplete multi-byte character.

      this.charLength = 0;
    }
    // guaranteed to not contain any partial multi-byte characters. Any partial
    // character found at the end of the buffer is buffered up, and will be
    // returned when calling write again with the remaining bytes.
    //
    // Note: Converting a Buffer containing an orphan surrogate to a String
    // currently works, but converting a String to a Buffer (via `new Buffer`, or
    // Buffer#write) will replace incomplete surrogates with the unicode
    // replacement character. See https://codereview.chromium.org/121173009/ .

    StringDecoder.prototype.write = function (buffer) {
      var charStr = ''; // if our last write ended with an incomplete multibyte character

      while (this.charLength) {
        // determine how many remaining bytes this buffer has to offer for this char
        var available = buffer.length >= this.charLength - this.charReceived ? this.charLength - this.charReceived : buffer.length; // add the new bytes to the char buffer

        buffer.copy(this.charBuffer, this.charReceived, 0, available);
        this.charReceived += available;

        if (this.charReceived < this.charLength) {
          // still not enough chars in this buffer? wait for more ...
          return '';
        } // remove bytes belonging to the current character from the buffer


        buffer = buffer.slice(available, buffer.length); // get the character that was split

        charStr = this.charBuffer.slice(0, this.charLength).toString(this.encoding); // CESU-8: lead surrogate (D800-DBFF) is also the incomplete character

        var charCode = charStr.charCodeAt(charStr.length - 1);

        if (charCode >= 0xD800 && charCode <= 0xDBFF) {
          this.charLength += this.surrogateSize;
          charStr = '';
          continue;
        }

        this.charReceived = this.charLength = 0; // if there are no more bytes in this buffer, just emit our char

        if (buffer.length === 0) {
          return charStr;
        }

        break;
      } // determine and set charLength / charReceived


      this.detectIncompleteChar(buffer);
      var end = buffer.length;

      if (this.charLength) {
        // buffer the incomplete character bytes we got
        buffer.copy(this.charBuffer, 0, buffer.length - this.charReceived, end);
        end -= this.charReceived;
      }

      charStr += buffer.toString(this.encoding, 0, end);
      var end = charStr.length - 1;
      var charCode = charStr.charCodeAt(end); // CESU-8: lead surrogate (D800-DBFF) is also the incomplete character

      if (charCode >= 0xD800 && charCode <= 0xDBFF) {
        var size = this.surrogateSize;
        this.charLength += size;
        this.charReceived += size;
        this.charBuffer.copy(this.charBuffer, size, 0, size);
        buffer.copy(this.charBuffer, 0, 0, size);
        return charStr.substring(0, end);
      } // or just emit the charStr


      return charStr;
    }; // detectIncompleteChar determines if there is an incomplete UTF-8 character at
    // the end of the given buffer. If so, it sets this.charLength to the byte
    // length that character, and sets this.charReceived to the number of bytes
    // that are available for this character.


    StringDecoder.prototype.detectIncompleteChar = function (buffer) {
      // determine how many bytes we have to check at the end of this buffer
      var i = buffer.length >= 3 ? 3 : buffer.length; // Figure out if one of the last i bytes of our buffer announces an
      // incomplete char.

      for (; i > 0; i--) {
        var c = buffer[buffer.length - i]; // See http://en.wikipedia.org/wiki/UTF-8#Description
        // 110XXXXX

        if (i == 1 && c >> 5 == 0x06) {
          this.charLength = 2;
          break;
        } // 1110XXXX


        if (i <= 2 && c >> 4 == 0x0E) {
          this.charLength = 3;
          break;
        } // 11110XXX


        if (i <= 3 && c >> 3 == 0x1E) {
          this.charLength = 4;
          break;
        }
      }

      this.charReceived = i;
    };

    StringDecoder.prototype.end = function (buffer) {
      var res = '';
      if (buffer && buffer.length) res = this.write(buffer);

      if (this.charReceived) {
        var cr = this.charReceived;
        var buf = this.charBuffer;
        var enc = this.encoding;
        res += buf.slice(0, cr).toString(enc);
      }

      return res;
    };

    function passThroughWrite(buffer) {
      return buffer.toString(this.encoding);
    }

    function utf16DetectIncompleteChar(buffer) {
      this.charReceived = buffer.length % 2;
      this.charLength = this.charReceived ? 2 : 0;
    }

    function base64DetectIncompleteChar(buffer) {
      this.charReceived = buffer.length % 3;
      this.charLength = this.charReceived ? 3 : 0;
    }

    Readable.ReadableState = ReadableState;
    var debug = debuglog('stream');
    inherits$1(Readable, EventEmitter);

    function prependListener(emitter, event, fn) {
      // Sadly this is not cacheable as some libraries bundle their own
      // event emitter implementation with them.
      if (typeof emitter.prependListener === 'function') {
        return emitter.prependListener(event, fn);
      } else {
        // This is a hack to make sure that our error handler is attached before any
        // userland ones.  NEVER DO THIS. This is here only because this code needs
        // to continue to work with older versions of Node.js that do not include
        // the prependListener() method. The goal is to eventually remove this hack.
        if (!emitter._events || !emitter._events[event]) emitter.on(event, fn);else if (Array.isArray(emitter._events[event])) emitter._events[event].unshift(fn);else emitter._events[event] = [fn, emitter._events[event]];
      }
    }

    function listenerCount(emitter, type) {
      return emitter.listeners(type).length;
    }

    function ReadableState(options, stream) {
      options = options || {}; // object stream flag. Used to make read(n) ignore n and to
      // make all the buffer merging and length checks go away

      this.objectMode = !!options.objectMode;
      if (stream instanceof Duplex) this.objectMode = this.objectMode || !!options.readableObjectMode; // the point at which it stops calling _read() to fill the buffer
      // Note: 0 is a valid value, means "don't call _read preemptively ever"

      var hwm = options.highWaterMark;
      var defaultHwm = this.objectMode ? 16 : 16 * 1024;
      this.highWaterMark = hwm || hwm === 0 ? hwm : defaultHwm; // cast to ints.

      this.highWaterMark = ~~this.highWaterMark; // A linked list is used to store data chunks instead of an array because the
      // linked list can remove elements from the beginning faster than
      // array.shift()

      this.buffer = new BufferList();
      this.length = 0;
      this.pipes = null;
      this.pipesCount = 0;
      this.flowing = null;
      this.ended = false;
      this.endEmitted = false;
      this.reading = false; // a flag to be able to tell if the onwrite cb is called immediately,
      // or on a later tick.  We set this to true at first, because any
      // actions that shouldn't happen until "later" should generally also
      // not happen before the first write call.

      this.sync = true; // whenever we return null, then we set a flag to say
      // that we're awaiting a 'readable' event emission.

      this.needReadable = false;
      this.emittedReadable = false;
      this.readableListening = false;
      this.resumeScheduled = false; // Crypto is kind of old and crusty.  Historically, its default string
      // encoding is 'binary' so we have to make this configurable.
      // Everything else in the universe uses 'utf8', though.

      this.defaultEncoding = options.defaultEncoding || 'utf8'; // when piping, we only care about 'readable' events that happen
      // after read()ing all the bytes and not getting any pushback.

      this.ranOut = false; // the number of writers that are awaiting a drain event in .pipe()s

      this.awaitDrain = 0; // if true, a maybeReadMore has been scheduled

      this.readingMore = false;
      this.decoder = null;
      this.encoding = null;

      if (options.encoding) {
        this.decoder = new StringDecoder(options.encoding);
        this.encoding = options.encoding;
      }
    }
    function Readable(options) {
      if (!(this instanceof Readable)) return new Readable(options);
      this._readableState = new ReadableState(options, this); // legacy

      this.readable = true;
      if (options && typeof options.read === 'function') this._read = options.read;
      EventEmitter.call(this);
    } // Manually shove something into the read() buffer.
    // This returns true if the highWaterMark has not been hit yet,
    // similar to how Writable.write() returns true if you should
    // write() some more.

    Readable.prototype.push = function (chunk, encoding) {
      var state = this._readableState;

      if (!state.objectMode && typeof chunk === 'string') {
        encoding = encoding || state.defaultEncoding;

        if (encoding !== state.encoding) {
          chunk = Buffer.from(chunk, encoding);
          encoding = '';
        }
      }

      return readableAddChunk(this, state, chunk, encoding, false);
    }; // Unshift should *always* be something directly out of read()


    Readable.prototype.unshift = function (chunk) {
      var state = this._readableState;
      return readableAddChunk(this, state, chunk, '', true);
    };

    Readable.prototype.isPaused = function () {
      return this._readableState.flowing === false;
    };

    function readableAddChunk(stream, state, chunk, encoding, addToFront) {
      var er = chunkInvalid(state, chunk);

      if (er) {
        stream.emit('error', er);
      } else if (chunk === null) {
        state.reading = false;
        onEofChunk(stream, state);
      } else if (state.objectMode || chunk && chunk.length > 0) {
        if (state.ended && !addToFront) {
          var e = new Error('stream.push() after EOF');
          stream.emit('error', e);
        } else if (state.endEmitted && addToFront) {
          var _e = new Error('stream.unshift() after end event');

          stream.emit('error', _e);
        } else {
          var skipAdd;

          if (state.decoder && !addToFront && !encoding) {
            chunk = state.decoder.write(chunk);
            skipAdd = !state.objectMode && chunk.length === 0;
          }

          if (!addToFront) state.reading = false; // Don't add to the buffer if we've decoded to an empty string chunk and
          // we're not in object mode

          if (!skipAdd) {
            // if we want the data now, just emit it.
            if (state.flowing && state.length === 0 && !state.sync) {
              stream.emit('data', chunk);
              stream.read(0);
            } else {
              // update the buffer info.
              state.length += state.objectMode ? 1 : chunk.length;
              if (addToFront) state.buffer.unshift(chunk);else state.buffer.push(chunk);
              if (state.needReadable) emitReadable(stream);
            }
          }

          maybeReadMore(stream, state);
        }
      } else if (!addToFront) {
        state.reading = false;
      }

      return needMoreData(state);
    } // if it's past the high water mark, we can push in some more.
    // Also, if we have no data yet, we can stand some
    // more bytes.  This is to work around cases where hwm=0,
    // such as the repl.  Also, if the push() triggered a
    // readable event, and the user called read(largeNumber) such that
    // needReadable was set, then we ought to push more, so that another
    // 'readable' event will be triggered.


    function needMoreData(state) {
      return !state.ended && (state.needReadable || state.length < state.highWaterMark || state.length === 0);
    } // backwards compatibility.


    Readable.prototype.setEncoding = function (enc) {
      this._readableState.decoder = new StringDecoder(enc);
      this._readableState.encoding = enc;
      return this;
    }; // Don't raise the hwm > 8MB


    var MAX_HWM = 0x800000;

    function computeNewHighWaterMark(n) {
      if (n >= MAX_HWM) {
        n = MAX_HWM;
      } else {
        // Get the next highest power of 2 to prevent increasing hwm excessively in
        // tiny amounts
        n--;
        n |= n >>> 1;
        n |= n >>> 2;
        n |= n >>> 4;
        n |= n >>> 8;
        n |= n >>> 16;
        n++;
      }

      return n;
    } // This function is designed to be inlinable, so please take care when making
    // changes to the function body.


    function howMuchToRead(n, state) {
      if (n <= 0 || state.length === 0 && state.ended) return 0;
      if (state.objectMode) return 1;

      if (n !== n) {
        // Only flow one buffer at a time
        if (state.flowing && state.length) return state.buffer.head.data.length;else return state.length;
      } // If we're asking for more than the current hwm, then raise the hwm.


      if (n > state.highWaterMark) state.highWaterMark = computeNewHighWaterMark(n);
      if (n <= state.length) return n; // Don't have enough

      if (!state.ended) {
        state.needReadable = true;
        return 0;
      }

      return state.length;
    } // you can override either this method, or the async _read(n) below.


    Readable.prototype.read = function (n) {
      debug('read', n);
      n = parseInt(n, 10);
      var state = this._readableState;
      var nOrig = n;
      if (n !== 0) state.emittedReadable = false; // if we're doing read(0) to trigger a readable event, but we
      // already have a bunch of data in the buffer, then just trigger
      // the 'readable' event and move on.

      if (n === 0 && state.needReadable && (state.length >= state.highWaterMark || state.ended)) {
        debug('read: emitReadable', state.length, state.ended);
        if (state.length === 0 && state.ended) endReadable(this);else emitReadable(this);
        return null;
      }

      n = howMuchToRead(n, state); // if we've ended, and we're now clear, then finish it up.

      if (n === 0 && state.ended) {
        if (state.length === 0) endReadable(this);
        return null;
      } // All the actual chunk generation logic needs to be
      // *below* the call to _read.  The reason is that in certain
      // synthetic stream cases, such as passthrough streams, _read
      // may be a completely synchronous operation which may change
      // the state of the read buffer, providing enough data when
      // before there was *not* enough.
      //
      // So, the steps are:
      // 1. Figure out what the state of things will be after we do
      // a read from the buffer.
      //
      // 2. If that resulting state will trigger a _read, then call _read.
      // Note that this may be asynchronous, or synchronous.  Yes, it is
      // deeply ugly to write APIs this way, but that still doesn't mean
      // that the Readable class should behave improperly, as streams are
      // designed to be sync/async agnostic.
      // Take note if the _read call is sync or async (ie, if the read call
      // has returned yet), so that we know whether or not it's safe to emit
      // 'readable' etc.
      //
      // 3. Actually pull the requested chunks out of the buffer and return.
      // if we need a readable event, then we need to do some reading.


      var doRead = state.needReadable;
      debug('need readable', doRead); // if we currently have less than the highWaterMark, then also read some

      if (state.length === 0 || state.length - n < state.highWaterMark) {
        doRead = true;
        debug('length less than watermark', doRead);
      } // however, if we've ended, then there's no point, and if we're already
      // reading, then it's unnecessary.


      if (state.ended || state.reading) {
        doRead = false;
        debug('reading or ended', doRead);
      } else if (doRead) {
        debug('do read');
        state.reading = true;
        state.sync = true; // if the length is currently zero, then we *need* a readable event.

        if (state.length === 0) state.needReadable = true; // call internal read method

        this._read(state.highWaterMark);

        state.sync = false; // If _read pushed data synchronously, then `reading` will be false,
        // and we need to re-evaluate how much data we can return to the user.

        if (!state.reading) n = howMuchToRead(nOrig, state);
      }

      var ret;
      if (n > 0) ret = fromList(n, state);else ret = null;

      if (ret === null) {
        state.needReadable = true;
        n = 0;
      } else {
        state.length -= n;
      }

      if (state.length === 0) {
        // If we have nothing in the buffer, then we want to know
        // as soon as we *do* get something into the buffer.
        if (!state.ended) state.needReadable = true; // If we tried to read() past the EOF, then emit end on the next tick.

        if (nOrig !== n && state.ended) endReadable(this);
      }

      if (ret !== null) this.emit('data', ret);
      return ret;
    };

    function chunkInvalid(state, chunk) {
      var er = null;

      if (!Buffer.isBuffer(chunk) && typeof chunk !== 'string' && chunk !== null && chunk !== undefined && !state.objectMode) {
        er = new TypeError('Invalid non-string/buffer chunk');
      }

      return er;
    }

    function onEofChunk(stream, state) {
      if (state.ended) return;

      if (state.decoder) {
        var chunk = state.decoder.end();

        if (chunk && chunk.length) {
          state.buffer.push(chunk);
          state.length += state.objectMode ? 1 : chunk.length;
        }
      }

      state.ended = true; // emit 'readable' now to make sure it gets picked up.

      emitReadable(stream);
    } // Don't emit readable right away in sync mode, because this can trigger
    // another read() call => stack overflow.  This way, it might trigger
    // a nextTick recursion warning, but that's not so bad.


    function emitReadable(stream) {
      var state = stream._readableState;
      state.needReadable = false;

      if (!state.emittedReadable) {
        debug('emitReadable', state.flowing);
        state.emittedReadable = true;
        if (state.sync) nextTick(emitReadable_, stream);else emitReadable_(stream);
      }
    }

    function emitReadable_(stream) {
      debug('emit readable');
      stream.emit('readable');
      flow(stream);
    } // at this point, the user has presumably seen the 'readable' event,
    // and called read() to consume some data.  that may have triggered
    // in turn another _read(n) call, in which case reading = true if
    // it's in progress.
    // However, if we're not ended, or reading, and the length < hwm,
    // then go ahead and try to read some more preemptively.


    function maybeReadMore(stream, state) {
      if (!state.readingMore) {
        state.readingMore = true;
        nextTick(maybeReadMore_, stream, state);
      }
    }

    function maybeReadMore_(stream, state) {
      var len = state.length;

      while (!state.reading && !state.flowing && !state.ended && state.length < state.highWaterMark) {
        debug('maybeReadMore read 0');
        stream.read(0);
        if (len === state.length) // didn't get any data, stop spinning.
          break;else len = state.length;
      }

      state.readingMore = false;
    } // abstract method.  to be overridden in specific implementation classes.
    // call cb(er, data) where data is <= n in length.
    // for virtual (non-string, non-buffer) streams, "length" is somewhat
    // arbitrary, and perhaps not very meaningful.


    Readable.prototype._read = function (n) {
      this.emit('error', new Error('not implemented'));
    };

    Readable.prototype.pipe = function (dest, pipeOpts) {
      var src = this;
      var state = this._readableState;

      switch (state.pipesCount) {
        case 0:
          state.pipes = dest;
          break;

        case 1:
          state.pipes = [state.pipes, dest];
          break;

        default:
          state.pipes.push(dest);
          break;
      }

      state.pipesCount += 1;
      debug('pipe count=%d opts=%j', state.pipesCount, pipeOpts);
      var doEnd = !pipeOpts || pipeOpts.end !== false;
      var endFn = doEnd ? onend : cleanup;
      if (state.endEmitted) nextTick(endFn);else src.once('end', endFn);
      dest.on('unpipe', onunpipe);

      function onunpipe(readable) {
        debug('onunpipe');

        if (readable === src) {
          cleanup();
        }
      }

      function onend() {
        debug('onend');
        dest.end();
      } // when the dest drains, it reduces the awaitDrain counter
      // on the source.  This would be more elegant with a .once()
      // handler in flow(), but adding and removing repeatedly is
      // too slow.


      var ondrain = pipeOnDrain(src);
      dest.on('drain', ondrain);
      var cleanedUp = false;

      function cleanup() {
        debug('cleanup'); // cleanup event handlers once the pipe is broken

        dest.removeListener('close', onclose);
        dest.removeListener('finish', onfinish);
        dest.removeListener('drain', ondrain);
        dest.removeListener('error', onerror);
        dest.removeListener('unpipe', onunpipe);
        src.removeListener('end', onend);
        src.removeListener('end', cleanup);
        src.removeListener('data', ondata);
        cleanedUp = true; // if the reader is waiting for a drain event from this
        // specific writer, then it would cause it to never start
        // flowing again.
        // So, if this is awaiting a drain, then we just call it now.
        // If we don't know, then assume that we are waiting for one.

        if (state.awaitDrain && (!dest._writableState || dest._writableState.needDrain)) ondrain();
      } // If the user pushes more data while we're writing to dest then we'll end up
      // in ondata again. However, we only want to increase awaitDrain once because
      // dest will only emit one 'drain' event for the multiple writes.
      // => Introduce a guard on increasing awaitDrain.


      var increasedAwaitDrain = false;
      src.on('data', ondata);

      function ondata(chunk) {
        debug('ondata');
        increasedAwaitDrain = false;
        var ret = dest.write(chunk);

        if (false === ret && !increasedAwaitDrain) {
          // If the user unpiped during `dest.write()`, it is possible
          // to get stuck in a permanently paused state if that write
          // also returned false.
          // => Check whether `dest` is still a piping destination.
          if ((state.pipesCount === 1 && state.pipes === dest || state.pipesCount > 1 && indexOf(state.pipes, dest) !== -1) && !cleanedUp) {
            debug('false write response, pause', src._readableState.awaitDrain);
            src._readableState.awaitDrain++;
            increasedAwaitDrain = true;
          }

          src.pause();
        }
      } // if the dest has an error, then stop piping into it.
      // however, don't suppress the throwing behavior for this.


      function onerror(er) {
        debug('onerror', er);
        unpipe();
        dest.removeListener('error', onerror);
        if (listenerCount(dest, 'error') === 0) dest.emit('error', er);
      } // Make sure our error handler is attached before userland ones.


      prependListener(dest, 'error', onerror); // Both close and finish should trigger unpipe, but only once.

      function onclose() {
        dest.removeListener('finish', onfinish);
        unpipe();
      }

      dest.once('close', onclose);

      function onfinish() {
        debug('onfinish');
        dest.removeListener('close', onclose);
        unpipe();
      }

      dest.once('finish', onfinish);

      function unpipe() {
        debug('unpipe');
        src.unpipe(dest);
      } // tell the dest that it's being piped to


      dest.emit('pipe', src); // start the flow if it hasn't been started already.

      if (!state.flowing) {
        debug('pipe resume');
        src.resume();
      }

      return dest;
    };

    function pipeOnDrain(src) {
      return function () {
        var state = src._readableState;
        debug('pipeOnDrain', state.awaitDrain);
        if (state.awaitDrain) state.awaitDrain--;

        if (state.awaitDrain === 0 && src.listeners('data').length) {
          state.flowing = true;
          flow(src);
        }
      };
    }

    Readable.prototype.unpipe = function (dest) {
      var state = this._readableState; // if we're not piping anywhere, then do nothing.

      if (state.pipesCount === 0) return this; // just one destination.  most common case.

      if (state.pipesCount === 1) {
        // passed in one, but it's not the right one.
        if (dest && dest !== state.pipes) return this;
        if (!dest) dest = state.pipes; // got a match.

        state.pipes = null;
        state.pipesCount = 0;
        state.flowing = false;
        if (dest) dest.emit('unpipe', this);
        return this;
      } // slow case. multiple pipe destinations.


      if (!dest) {
        // remove all.
        var dests = state.pipes;
        var len = state.pipesCount;
        state.pipes = null;
        state.pipesCount = 0;
        state.flowing = false;

        for (var _i = 0; _i < len; _i++) {
          dests[_i].emit('unpipe', this);
        }

        return this;
      } // try to find the right one.


      var i = indexOf(state.pipes, dest);
      if (i === -1) return this;
      state.pipes.splice(i, 1);
      state.pipesCount -= 1;
      if (state.pipesCount === 1) state.pipes = state.pipes[0];
      dest.emit('unpipe', this);
      return this;
    }; // set up data events if they are asked for
    // Ensure readable listeners eventually get something


    Readable.prototype.on = function (ev, fn) {
      var res = EventEmitter.prototype.on.call(this, ev, fn);

      if (ev === 'data') {
        // Start flowing on next tick if stream isn't explicitly paused
        if (this._readableState.flowing !== false) this.resume();
      } else if (ev === 'readable') {
        var state = this._readableState;

        if (!state.endEmitted && !state.readableListening) {
          state.readableListening = state.needReadable = true;
          state.emittedReadable = false;

          if (!state.reading) {
            nextTick(nReadingNextTick, this);
          } else if (state.length) {
            emitReadable(this);
          }
        }
      }

      return res;
    };

    Readable.prototype.addListener = Readable.prototype.on;

    function nReadingNextTick(self) {
      debug('readable nexttick read 0');
      self.read(0);
    } // pause() and resume() are remnants of the legacy readable stream API
    // If the user uses them, then switch into old mode.


    Readable.prototype.resume = function () {
      var state = this._readableState;

      if (!state.flowing) {
        debug('resume');
        state.flowing = true;
        resume(this, state);
      }

      return this;
    };

    function resume(stream, state) {
      if (!state.resumeScheduled) {
        state.resumeScheduled = true;
        nextTick(resume_, stream, state);
      }
    }

    function resume_(stream, state) {
      if (!state.reading) {
        debug('resume read 0');
        stream.read(0);
      }

      state.resumeScheduled = false;
      state.awaitDrain = 0;
      stream.emit('resume');
      flow(stream);
      if (state.flowing && !state.reading) stream.read(0);
    }

    Readable.prototype.pause = function () {
      debug('call pause flowing=%j', this._readableState.flowing);

      if (false !== this._readableState.flowing) {
        debug('pause');
        this._readableState.flowing = false;
        this.emit('pause');
      }

      return this;
    };

    function flow(stream) {
      var state = stream._readableState;
      debug('flow', state.flowing);

      while (state.flowing && stream.read() !== null) {}
    } // wrap an old-style stream as the async data source.
    // This is *not* part of the readable stream interface.
    // It is an ugly unfortunate mess of history.


    Readable.prototype.wrap = function (stream) {
      var state = this._readableState;
      var paused = false;
      var self = this;
      stream.on('end', function () {
        debug('wrapped end');

        if (state.decoder && !state.ended) {
          var chunk = state.decoder.end();
          if (chunk && chunk.length) self.push(chunk);
        }

        self.push(null);
      });
      stream.on('data', function (chunk) {
        debug('wrapped data');
        if (state.decoder) chunk = state.decoder.write(chunk); // don't skip over falsy values in objectMode

        if (state.objectMode && (chunk === null || chunk === undefined)) return;else if (!state.objectMode && (!chunk || !chunk.length)) return;
        var ret = self.push(chunk);

        if (!ret) {
          paused = true;
          stream.pause();
        }
      }); // proxy all the other methods.
      // important when wrapping filters and duplexes.

      for (var i in stream) {
        if (this[i] === undefined && typeof stream[i] === 'function') {
          this[i] = function (method) {
            return function () {
              return stream[method].apply(stream, arguments);
            };
          }(i);
        }
      } // proxy certain important events.


      var events = ['error', 'close', 'destroy', 'pause', 'resume'];
      forEach(events, function (ev) {
        stream.on(ev, self.emit.bind(self, ev));
      }); // when we try to consume some more bytes, simply unpause the
      // underlying stream.

      self._read = function (n) {
        debug('wrapped _read', n);

        if (paused) {
          paused = false;
          stream.resume();
        }
      };

      return self;
    }; // exposed for testing purposes only.


    Readable._fromList = fromList; // Pluck off n bytes from an array of buffers.
    // Length is the combined lengths of all the buffers in the list.
    // This function is designed to be inlinable, so please take care when making
    // changes to the function body.

    function fromList(n, state) {
      // nothing buffered
      if (state.length === 0) return null;
      var ret;
      if (state.objectMode) ret = state.buffer.shift();else if (!n || n >= state.length) {
        // read it all, truncate the list
        if (state.decoder) ret = state.buffer.join('');else if (state.buffer.length === 1) ret = state.buffer.head.data;else ret = state.buffer.concat(state.length);
        state.buffer.clear();
      } else {
        // read part of list
        ret = fromListPartial(n, state.buffer, state.decoder);
      }
      return ret;
    } // Extracts only enough buffered data to satisfy the amount requested.
    // This function is designed to be inlinable, so please take care when making
    // changes to the function body.


    function fromListPartial(n, list, hasStrings) {
      var ret;

      if (n < list.head.data.length) {
        // slice is the same for buffers and strings
        ret = list.head.data.slice(0, n);
        list.head.data = list.head.data.slice(n);
      } else if (n === list.head.data.length) {
        // first chunk is a perfect match
        ret = list.shift();
      } else {
        // result spans more than one buffer
        ret = hasStrings ? copyFromBufferString(n, list) : copyFromBuffer(n, list);
      }

      return ret;
    } // Copies a specified amount of characters from the list of buffered data
    // chunks.
    // This function is designed to be inlinable, so please take care when making
    // changes to the function body.


    function copyFromBufferString(n, list) {
      var p = list.head;
      var c = 1;
      var ret = p.data;
      n -= ret.length;

      while (p = p.next) {
        var str = p.data;
        var nb = n > str.length ? str.length : n;
        if (nb === str.length) ret += str;else ret += str.slice(0, n);
        n -= nb;

        if (n === 0) {
          if (nb === str.length) {
            ++c;
            if (p.next) list.head = p.next;else list.head = list.tail = null;
          } else {
            list.head = p;
            p.data = str.slice(nb);
          }

          break;
        }

        ++c;
      }

      list.length -= c;
      return ret;
    } // Copies a specified amount of bytes from the list of buffered data chunks.
    // This function is designed to be inlinable, so please take care when making
    // changes to the function body.


    function copyFromBuffer(n, list) {
      var ret = Buffer.allocUnsafe(n);
      var p = list.head;
      var c = 1;
      p.data.copy(ret);
      n -= p.data.length;

      while (p = p.next) {
        var buf = p.data;
        var nb = n > buf.length ? buf.length : n;
        buf.copy(ret, ret.length - n, 0, nb);
        n -= nb;

        if (n === 0) {
          if (nb === buf.length) {
            ++c;
            if (p.next) list.head = p.next;else list.head = list.tail = null;
          } else {
            list.head = p;
            p.data = buf.slice(nb);
          }

          break;
        }

        ++c;
      }

      list.length -= c;
      return ret;
    }

    function endReadable(stream) {
      var state = stream._readableState; // If we get here before consuming all the bytes, then that is a
      // bug in node.  Should never happen.

      if (state.length > 0) throw new Error('"endReadable()" called on non-empty stream');

      if (!state.endEmitted) {
        state.ended = true;
        nextTick(endReadableNT, state, stream);
      }
    }

    function endReadableNT(state, stream) {
      // Check that we didn't get one last unshift.
      if (!state.endEmitted && state.length === 0) {
        state.endEmitted = true;
        stream.readable = false;
        stream.emit('end');
      }
    }

    function forEach(xs, f) {
      for (var i = 0, l = xs.length; i < l; i++) {
        f(xs[i], i);
      }
    }

    function indexOf(xs, x) {
      for (var i = 0, l = xs.length; i < l; i++) {
        if (xs[i] === x) return i;
      }

      return -1;
    }

    // A bit simpler than readable streams.
    Writable.WritableState = WritableState;
    inherits$1(Writable, EventEmitter);

    function nop() {}

    function WriteReq(chunk, encoding, cb) {
      this.chunk = chunk;
      this.encoding = encoding;
      this.callback = cb;
      this.next = null;
    }

    function WritableState(options, stream) {
      Object.defineProperty(this, 'buffer', {
        get: deprecate(function () {
          return this.getBuffer();
        }, '_writableState.buffer is deprecated. Use _writableState.getBuffer ' + 'instead.')
      });
      options = options || {}; // object stream flag to indicate whether or not this stream
      // contains buffers or objects.

      this.objectMode = !!options.objectMode;
      if (stream instanceof Duplex) this.objectMode = this.objectMode || !!options.writableObjectMode; // the point at which write() starts returning false
      // Note: 0 is a valid value, means that we always return false if
      // the entire buffer is not flushed immediately on write()

      var hwm = options.highWaterMark;
      var defaultHwm = this.objectMode ? 16 : 16 * 1024;
      this.highWaterMark = hwm || hwm === 0 ? hwm : defaultHwm; // cast to ints.

      this.highWaterMark = ~~this.highWaterMark;
      this.needDrain = false; // at the start of calling end()

      this.ending = false; // when end() has been called, and returned

      this.ended = false; // when 'finish' is emitted

      this.finished = false; // should we decode strings into buffers before passing to _write?
      // this is here so that some node-core streams can optimize string
      // handling at a lower level.

      var noDecode = options.decodeStrings === false;
      this.decodeStrings = !noDecode; // Crypto is kind of old and crusty.  Historically, its default string
      // encoding is 'binary' so we have to make this configurable.
      // Everything else in the universe uses 'utf8', though.

      this.defaultEncoding = options.defaultEncoding || 'utf8'; // not an actual buffer we keep track of, but a measurement
      // of how much we're waiting to get pushed to some underlying
      // socket or file.

      this.length = 0; // a flag to see when we're in the middle of a write.

      this.writing = false; // when true all writes will be buffered until .uncork() call

      this.corked = 0; // a flag to be able to tell if the onwrite cb is called immediately,
      // or on a later tick.  We set this to true at first, because any
      // actions that shouldn't happen until "later" should generally also
      // not happen before the first write call.

      this.sync = true; // a flag to know if we're processing previously buffered items, which
      // may call the _write() callback in the same tick, so that we don't
      // end up in an overlapped onwrite situation.

      this.bufferProcessing = false; // the callback that's passed to _write(chunk,cb)

      this.onwrite = function (er) {
        onwrite(stream, er);
      }; // the callback that the user supplies to write(chunk,encoding,cb)


      this.writecb = null; // the amount that is being written when _write is called.

      this.writelen = 0;
      this.bufferedRequest = null;
      this.lastBufferedRequest = null; // number of pending user-supplied write callbacks
      // this must be 0 before 'finish' can be emitted

      this.pendingcb = 0; // emit prefinish if the only thing we're waiting for is _write cbs
      // This is relevant for synchronous Transform streams

      this.prefinished = false; // True if the error was already emitted and should not be thrown again

      this.errorEmitted = false; // count buffered requests

      this.bufferedRequestCount = 0; // allocate the first CorkedRequest, there is always
      // one allocated and free to use, and we maintain at most two

      this.corkedRequestsFree = new CorkedRequest(this);
    }

    WritableState.prototype.getBuffer = function writableStateGetBuffer() {
      var current = this.bufferedRequest;
      var out = [];

      while (current) {
        out.push(current);
        current = current.next;
      }

      return out;
    };
    function Writable(options) {
      // Writable ctor is applied to Duplexes, though they're not
      // instanceof Writable, they're instanceof Readable.
      if (!(this instanceof Writable) && !(this instanceof Duplex)) return new Writable(options);
      this._writableState = new WritableState(options, this); // legacy.

      this.writable = true;

      if (options) {
        if (typeof options.write === 'function') this._write = options.write;
        if (typeof options.writev === 'function') this._writev = options.writev;
      }

      EventEmitter.call(this);
    } // Otherwise people can pipe Writable streams, which is just wrong.

    Writable.prototype.pipe = function () {
      this.emit('error', new Error('Cannot pipe, not readable'));
    };

    function writeAfterEnd(stream, cb) {
      var er = new Error('write after end'); // TODO: defer error events consistently everywhere, not just the cb

      stream.emit('error', er);
      nextTick(cb, er);
    } // If we get something that is not a buffer, string, null, or undefined,
    // and we're not in objectMode, then that's an error.
    // Otherwise stream chunks are all considered to be of length=1, and the
    // watermarks determine how many objects to keep in the buffer, rather than
    // how many bytes or characters.


    function validChunk(stream, state, chunk, cb) {
      var valid = true;
      var er = false; // Always throw error if a null is written
      // if we are not in object mode then throw
      // if it is not a buffer, string, or undefined.

      if (chunk === null) {
        er = new TypeError('May not write null values to stream');
      } else if (!Buffer.isBuffer(chunk) && typeof chunk !== 'string' && chunk !== undefined && !state.objectMode) {
        er = new TypeError('Invalid non-string/buffer chunk');
      }

      if (er) {
        stream.emit('error', er);
        nextTick(cb, er);
        valid = false;
      }

      return valid;
    }

    Writable.prototype.write = function (chunk, encoding, cb) {
      var state = this._writableState;
      var ret = false;

      if (typeof encoding === 'function') {
        cb = encoding;
        encoding = null;
      }

      if (Buffer.isBuffer(chunk)) encoding = 'buffer';else if (!encoding) encoding = state.defaultEncoding;
      if (typeof cb !== 'function') cb = nop;
      if (state.ended) writeAfterEnd(this, cb);else if (validChunk(this, state, chunk, cb)) {
        state.pendingcb++;
        ret = writeOrBuffer(this, state, chunk, encoding, cb);
      }
      return ret;
    };

    Writable.prototype.cork = function () {
      var state = this._writableState;
      state.corked++;
    };

    Writable.prototype.uncork = function () {
      var state = this._writableState;

      if (state.corked) {
        state.corked--;
        if (!state.writing && !state.corked && !state.finished && !state.bufferProcessing && state.bufferedRequest) clearBuffer(this, state);
      }
    };

    Writable.prototype.setDefaultEncoding = function setDefaultEncoding(encoding) {
      // node::ParseEncoding() requires lower case.
      if (typeof encoding === 'string') encoding = encoding.toLowerCase();
      if (!(['hex', 'utf8', 'utf-8', 'ascii', 'binary', 'base64', 'ucs2', 'ucs-2', 'utf16le', 'utf-16le', 'raw'].indexOf((encoding + '').toLowerCase()) > -1)) throw new TypeError('Unknown encoding: ' + encoding);
      this._writableState.defaultEncoding = encoding;
      return this;
    };

    function decodeChunk(state, chunk, encoding) {
      if (!state.objectMode && state.decodeStrings !== false && typeof chunk === 'string') {
        chunk = Buffer.from(chunk, encoding);
      }

      return chunk;
    } // if we're already writing something, then just put this
    // in the queue, and wait our turn.  Otherwise, call _write
    // If we return false, then we need a drain event, so set that flag.


    function writeOrBuffer(stream, state, chunk, encoding, cb) {
      chunk = decodeChunk(state, chunk, encoding);
      if (Buffer.isBuffer(chunk)) encoding = 'buffer';
      var len = state.objectMode ? 1 : chunk.length;
      state.length += len;
      var ret = state.length < state.highWaterMark; // we must ensure that previous needDrain will not be reset to false.

      if (!ret) state.needDrain = true;

      if (state.writing || state.corked) {
        var last = state.lastBufferedRequest;
        state.lastBufferedRequest = new WriteReq(chunk, encoding, cb);

        if (last) {
          last.next = state.lastBufferedRequest;
        } else {
          state.bufferedRequest = state.lastBufferedRequest;
        }

        state.bufferedRequestCount += 1;
      } else {
        doWrite(stream, state, false, len, chunk, encoding, cb);
      }

      return ret;
    }

    function doWrite(stream, state, writev, len, chunk, encoding, cb) {
      state.writelen = len;
      state.writecb = cb;
      state.writing = true;
      state.sync = true;
      if (writev) stream._writev(chunk, state.onwrite);else stream._write(chunk, encoding, state.onwrite);
      state.sync = false;
    }

    function onwriteError(stream, state, sync, er, cb) {
      --state.pendingcb;
      if (sync) nextTick(cb, er);else cb(er);
      stream._writableState.errorEmitted = true;
      stream.emit('error', er);
    }

    function onwriteStateUpdate(state) {
      state.writing = false;
      state.writecb = null;
      state.length -= state.writelen;
      state.writelen = 0;
    }

    function onwrite(stream, er) {
      var state = stream._writableState;
      var sync = state.sync;
      var cb = state.writecb;
      onwriteStateUpdate(state);
      if (er) onwriteError(stream, state, sync, er, cb);else {
        // Check if we're actually ready to finish, but don't emit yet
        var finished = needFinish(state);

        if (!finished && !state.corked && !state.bufferProcessing && state.bufferedRequest) {
          clearBuffer(stream, state);
        }

        if (sync) {
          /*<replacement>*/
          nextTick(afterWrite, stream, state, finished, cb);
          /*</replacement>*/
        } else {
          afterWrite(stream, state, finished, cb);
        }
      }
    }

    function afterWrite(stream, state, finished, cb) {
      if (!finished) onwriteDrain(stream, state);
      state.pendingcb--;
      cb();
      finishMaybe(stream, state);
    } // Must force callback to be called on nextTick, so that we don't
    // emit 'drain' before the write() consumer gets the 'false' return
    // value, and has a chance to attach a 'drain' listener.


    function onwriteDrain(stream, state) {
      if (state.length === 0 && state.needDrain) {
        state.needDrain = false;
        stream.emit('drain');
      }
    } // if there's something in the buffer waiting, then process it


    function clearBuffer(stream, state) {
      state.bufferProcessing = true;
      var entry = state.bufferedRequest;

      if (stream._writev && entry && entry.next) {
        // Fast case, write everything using _writev()
        var l = state.bufferedRequestCount;
        var buffer = new Array(l);
        var holder = state.corkedRequestsFree;
        holder.entry = entry;
        var count = 0;

        while (entry) {
          buffer[count] = entry;
          entry = entry.next;
          count += 1;
        }

        doWrite(stream, state, true, state.length, buffer, '', holder.finish); // doWrite is almost always async, defer these to save a bit of time
        // as the hot path ends with doWrite

        state.pendingcb++;
        state.lastBufferedRequest = null;

        if (holder.next) {
          state.corkedRequestsFree = holder.next;
          holder.next = null;
        } else {
          state.corkedRequestsFree = new CorkedRequest(state);
        }
      } else {
        // Slow case, write chunks one-by-one
        while (entry) {
          var chunk = entry.chunk;
          var encoding = entry.encoding;
          var cb = entry.callback;
          var len = state.objectMode ? 1 : chunk.length;
          doWrite(stream, state, false, len, chunk, encoding, cb);
          entry = entry.next; // if we didn't call the onwrite immediately, then
          // it means that we need to wait until it does.
          // also, that means that the chunk and cb are currently
          // being processed, so move the buffer counter past them.

          if (state.writing) {
            break;
          }
        }

        if (entry === null) state.lastBufferedRequest = null;
      }

      state.bufferedRequestCount = 0;
      state.bufferedRequest = entry;
      state.bufferProcessing = false;
    }

    Writable.prototype._write = function (chunk, encoding, cb) {
      cb(new Error('not implemented'));
    };

    Writable.prototype._writev = null;

    Writable.prototype.end = function (chunk, encoding, cb) {
      var state = this._writableState;

      if (typeof chunk === 'function') {
        cb = chunk;
        chunk = null;
        encoding = null;
      } else if (typeof encoding === 'function') {
        cb = encoding;
        encoding = null;
      }

      if (chunk !== null && chunk !== undefined) this.write(chunk, encoding); // .end() fully uncorks

      if (state.corked) {
        state.corked = 1;
        this.uncork();
      } // ignore unnecessary end() calls.


      if (!state.ending && !state.finished) endWritable(this, state, cb);
    };

    function needFinish(state) {
      return state.ending && state.length === 0 && state.bufferedRequest === null && !state.finished && !state.writing;
    }

    function prefinish(stream, state) {
      if (!state.prefinished) {
        state.prefinished = true;
        stream.emit('prefinish');
      }
    }

    function finishMaybe(stream, state) {
      var need = needFinish(state);

      if (need) {
        if (state.pendingcb === 0) {
          prefinish(stream, state);
          state.finished = true;
          stream.emit('finish');
        } else {
          prefinish(stream, state);
        }
      }

      return need;
    }

    function endWritable(stream, state, cb) {
      state.ending = true;
      finishMaybe(stream, state);

      if (cb) {
        if (state.finished) nextTick(cb);else stream.once('finish', cb);
      }

      state.ended = true;
      stream.writable = false;
    } // It seems a linked list but it is not
    // there will be only 2 of these for each stream


    function CorkedRequest(state) {
      var _this = this;

      this.next = null;
      this.entry = null;

      this.finish = function (err) {
        var entry = _this.entry;
        _this.entry = null;

        while (entry) {
          var cb = entry.callback;
          state.pendingcb--;
          cb(err);
          entry = entry.next;
        }

        if (state.corkedRequestsFree) {
          state.corkedRequestsFree.next = _this;
        } else {
          state.corkedRequestsFree = _this;
        }
      };
    }

    inherits$1(Duplex, Readable);
    var keys = Object.keys(Writable.prototype);

    for (var v = 0; v < keys.length; v++) {
      var method = keys[v];
      if (!Duplex.prototype[method]) Duplex.prototype[method] = Writable.prototype[method];
    }
    function Duplex(options) {
      if (!(this instanceof Duplex)) return new Duplex(options);
      Readable.call(this, options);
      Writable.call(this, options);
      if (options && options.readable === false) this.readable = false;
      if (options && options.writable === false) this.writable = false;
      this.allowHalfOpen = true;
      if (options && options.allowHalfOpen === false) this.allowHalfOpen = false;
      this.once('end', onend);
    } // the no-half-open enforcer

    function onend() {
      // if we allow half-open state, or if the writable side ended,
      // then we're ok.
      if (this.allowHalfOpen || this._writableState.ended) return; // no more data can be written.
      // But allow more writes to happen in this tick.

      nextTick(onEndNT, this);
    }

    function onEndNT(self) {
      self.end();
    }

    // a transform stream is a readable/writable stream where you do
    inherits$1(Transform, Duplex);

    function TransformState(stream) {
      this.afterTransform = function (er, data) {
        return afterTransform(stream, er, data);
      };

      this.needTransform = false;
      this.transforming = false;
      this.writecb = null;
      this.writechunk = null;
      this.writeencoding = null;
    }

    function afterTransform(stream, er, data) {
      var ts = stream._transformState;
      ts.transforming = false;
      var cb = ts.writecb;
      if (!cb) return stream.emit('error', new Error('no writecb in Transform class'));
      ts.writechunk = null;
      ts.writecb = null;
      if (data !== null && data !== undefined) stream.push(data);
      cb(er);
      var rs = stream._readableState;
      rs.reading = false;

      if (rs.needReadable || rs.length < rs.highWaterMark) {
        stream._read(rs.highWaterMark);
      }
    }
    function Transform(options) {
      if (!(this instanceof Transform)) return new Transform(options);
      Duplex.call(this, options);
      this._transformState = new TransformState(this); // when the writable side finishes, then flush out anything remaining.

      var stream = this; // start out asking for a readable event once data is transformed.

      this._readableState.needReadable = true; // we have implemented the _read method, and done the other things
      // that Readable wants before the first _read call, so unset the
      // sync guard flag.

      this._readableState.sync = false;

      if (options) {
        if (typeof options.transform === 'function') this._transform = options.transform;
        if (typeof options.flush === 'function') this._flush = options.flush;
      }

      this.once('prefinish', function () {
        if (typeof this._flush === 'function') this._flush(function (er) {
          done(stream, er);
        });else done(stream);
      });
    }

    Transform.prototype.push = function (chunk, encoding) {
      this._transformState.needTransform = false;
      return Duplex.prototype.push.call(this, chunk, encoding);
    }; // This is the part where you do stuff!
    // override this function in implementation classes.
    // 'chunk' is an input chunk.
    //
    // Call `push(newChunk)` to pass along transformed output
    // to the readable side.  You may call 'push' zero or more times.
    //
    // Call `cb(err)` when you are done with this chunk.  If you pass
    // an error, then that'll put the hurt on the whole operation.  If you
    // never call cb(), then you'll never get another chunk.


    Transform.prototype._transform = function (chunk, encoding, cb) {
      throw new Error('Not implemented');
    };

    Transform.prototype._write = function (chunk, encoding, cb) {
      var ts = this._transformState;
      ts.writecb = cb;
      ts.writechunk = chunk;
      ts.writeencoding = encoding;

      if (!ts.transforming) {
        var rs = this._readableState;
        if (ts.needTransform || rs.needReadable || rs.length < rs.highWaterMark) this._read(rs.highWaterMark);
      }
    }; // Doesn't matter what the args are here.
    // _transform does all the work.
    // That we got here means that the readable side wants more data.


    Transform.prototype._read = function (n) {
      var ts = this._transformState;

      if (ts.writechunk !== null && ts.writecb && !ts.transforming) {
        ts.transforming = true;

        this._transform(ts.writechunk, ts.writeencoding, ts.afterTransform);
      } else {
        // mark that we need a transform, so that any data that comes in
        // will get processed, now that we've asked for it.
        ts.needTransform = true;
      }
    };

    function done(stream, er) {
      if (er) return stream.emit('error', er); // if there's nothing in the write buffer, then that means
      // that nothing more will ever be provided

      var ws = stream._writableState;
      var ts = stream._transformState;
      if (ws.length) throw new Error('Calling transform done when ws.length != 0');
      if (ts.transforming) throw new Error('Calling transform done when still transforming');
      return stream.push(null);
    }

    inherits$1(PassThrough, Transform);
    function PassThrough(options) {
      if (!(this instanceof PassThrough)) return new PassThrough(options);
      Transform.call(this, options);
    }

    PassThrough.prototype._transform = function (chunk, encoding, cb) {
      cb(null, chunk);
    };

    inherits$1(Stream, EventEmitter);
    Stream.Readable = Readable;
    Stream.Writable = Writable;
    Stream.Duplex = Duplex;
    Stream.Transform = Transform;
    Stream.PassThrough = PassThrough; // Backwards-compat with node 0.4.x

    Stream.Stream = Stream;
    // part of this class) is overridden in the Readable class.

    function Stream() {
      EventEmitter.call(this);
    }

    Stream.prototype.pipe = function (dest, options) {
      var source = this;

      function ondata(chunk) {
        if (dest.writable) {
          if (false === dest.write(chunk) && source.pause) {
            source.pause();
          }
        }
      }

      source.on('data', ondata);

      function ondrain() {
        if (source.readable && source.resume) {
          source.resume();
        }
      }

      dest.on('drain', ondrain); // If the 'end' option is not supplied, dest.end() will be called when
      // source gets the 'end' or 'close' events.  Only dest.end() once.

      if (!dest._isStdio && (!options || options.end !== false)) {
        source.on('end', onend);
        source.on('close', onclose);
      }

      var didOnEnd = false;

      function onend() {
        if (didOnEnd) return;
        didOnEnd = true;
        dest.end();
      }

      function onclose() {
        if (didOnEnd) return;
        didOnEnd = true;
        if (typeof dest.destroy === 'function') dest.destroy();
      } // don't leave dangling pipes when there are errors.


      function onerror(er) {
        cleanup();

        if (EventEmitter.listenerCount(this, 'error') === 0) {
          throw er; // Unhandled stream error in pipe.
        }
      }

      source.on('error', onerror);
      dest.on('error', onerror); // remove all the event listeners that were added.

      function cleanup() {
        source.removeListener('data', ondata);
        dest.removeListener('drain', ondrain);
        source.removeListener('end', onend);
        source.removeListener('close', onclose);
        source.removeListener('error', onerror);
        dest.removeListener('error', onerror);
        source.removeListener('end', cleanup);
        source.removeListener('close', cleanup);
        dest.removeListener('close', cleanup);
      }

      source.on('end', cleanup);
      source.on('close', cleanup);
      dest.on('close', cleanup);
      dest.emit('pipe', source); // Allow for unix-like usage: A.pipe(B).pipe(C)

      return dest;
    };

    var rStates = {
      UNSENT: 0,
      OPENED: 1,
      HEADERS_RECEIVED: 2,
      LOADING: 3,
      DONE: 4
    };
    function IncomingMessage(xhr, response, mode) {
      var self = this;
      Readable.call(self);
      self._mode = mode;
      self.headers = {};
      self.rawHeaders = [];
      self.trailers = {};
      self.rawTrailers = []; // Fake the 'close' event, but only once 'end' fires

      self.on('end', function () {
        // The nextTick is necessary to prevent the 'request' module from causing an infinite loop
        browser$1.nextTick(function () {
          self.emit('close');
        });
      });

      var _read;

      if (mode === 'fetch') {
        self._fetchResponse = response;
        self.url = response.url;
        self.statusCode = response.status;
        self.statusMessage = response.statusText; // backwards compatible version of for (<item> of <iterable>):
        // for (var <item>,_i,_it = <iterable>[Symbol.iterator](); <item> = (_i = _it.next()).value,!_i.done;)

        for (var header, _i, _it = response.headers[Symbol.iterator](); header = (_i = _it.next()).value, !_i.done;) {
          self.headers[header[0].toLowerCase()] = header[1];
          self.rawHeaders.push(header[0], header[1]);
        } // TODO: this doesn't respect backpressure. Once WritableStream is available, this can be fixed


        var reader = response.body.getReader();

        _read = function read() {
          reader.read().then(function (result) {
            if (self._destroyed) return;

            if (result.done) {
              self.push(null);
              return;
            }

            self.push(new Buffer(result.value));

            _read();
          });
        };

        _read();
      } else {
        self._xhr = xhr;
        self._pos = 0;
        self.url = xhr.responseURL;
        self.statusCode = xhr.status;
        self.statusMessage = xhr.statusText;
        var headers = xhr.getAllResponseHeaders().split(/\r?\n/);
        headers.forEach(function (header) {
          var matches = header.match(/^([^:]+):\s*(.*)/);

          if (matches) {
            var key = matches[1].toLowerCase();

            if (key === 'set-cookie') {
              if (self.headers[key] === undefined) {
                self.headers[key] = [];
              }

              self.headers[key].push(matches[2]);
            } else if (self.headers[key] !== undefined) {
              self.headers[key] += ', ' + matches[2];
            } else {
              self.headers[key] = matches[2];
            }

            self.rawHeaders.push(matches[1], matches[2]);
          }
        });
        self._charset = 'x-user-defined';

        if (!overrideMimeType) {
          var mimeType = self.rawHeaders['mime-type'];

          if (mimeType) {
            var charsetMatch = mimeType.match(/;\s*charset=([^;])(;|$)/);

            if (charsetMatch) {
              self._charset = charsetMatch[1].toLowerCase();
            }
          }

          if (!self._charset) self._charset = 'utf-8'; // best guess
        }
      }
    }
    inherits$1(IncomingMessage, Readable);

    IncomingMessage.prototype._read = function () {};

    IncomingMessage.prototype._onXHRProgress = function () {
      var self = this;
      var xhr = self._xhr;
      var response = null;

      switch (self._mode) {
        case 'text:vbarray':
          // For IE9
          if (xhr.readyState !== rStates.DONE) break;

          try {
            // This fails in IE8
            response = new global$1.VBArray(xhr.responseBody).toArray();
          } catch (e) {// pass
          }

          if (response !== null) {
            self.push(new Buffer(response));
            break;
          }

        // Falls through in IE8

        case 'text':
          try {
            // This will fail when readyState = 3 in IE9. Switch mode and wait for readyState = 4
            response = xhr.responseText;
          } catch (e) {
            self._mode = 'text:vbarray';
            break;
          }

          if (response.length > self._pos) {
            var newData = response.substr(self._pos);

            if (self._charset === 'x-user-defined') {
              var buffer = new Buffer(newData.length);

              for (var i = 0; i < newData.length; i++) {
                buffer[i] = newData.charCodeAt(i) & 0xff;
              }

              self.push(buffer);
            } else {
              self.push(newData, self._charset);
            }

            self._pos = response.length;
          }

          break;

        case 'arraybuffer':
          if (xhr.readyState !== rStates.DONE || !xhr.response) break;
          response = xhr.response;
          self.push(new Buffer(new Uint8Array(response)));
          break;

        case 'moz-chunked-arraybuffer':
          // take whole
          response = xhr.response;
          if (xhr.readyState !== rStates.LOADING || !response) break;
          self.push(new Buffer(new Uint8Array(response)));
          break;

        case 'ms-stream':
          response = xhr.response;
          if (xhr.readyState !== rStates.LOADING) break;
          var reader = new global$1.MSStreamReader();

          reader.onprogress = function () {
            if (reader.result.byteLength > self._pos) {
              self.push(new Buffer(new Uint8Array(reader.result.slice(self._pos))));
              self._pos = reader.result.byteLength;
            }
          };

          reader.onload = function () {
            self.push(null);
          }; // reader.onerror = ??? // TODO: this


          reader.readAsArrayBuffer(response);
          break;
      } // The ms-stream case handles end separately in reader.onload()


      if (self._xhr.readyState === rStates.DONE && self._mode !== 'ms-stream') {
        self.push(null);
      }
    };

    // from https://github.com/jhiesey/to-arraybuffer/blob/6502d9850e70ba7935a7df4ad86b358fc216f9f0/index.js
    function toArrayBuffer (buf) {
      // If the buffer is backed by a Uint8Array, a faster version will work
      if (buf instanceof Uint8Array) {
        // If the buffer isn't a subarray, return the underlying ArrayBuffer
        if (buf.byteOffset === 0 && buf.byteLength === buf.buffer.byteLength) {
          return buf.buffer;
        } else if (typeof buf.buffer.slice === 'function') {
          // Otherwise we need to get a proper copy
          return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
        }
      }

      if (isBuffer(buf)) {
        // This is the slow version that will work with any Buffer
        // implementation (even in old browsers)
        var arrayCopy = new Uint8Array(buf.length);
        var len = buf.length;

        for (var i = 0; i < len; i++) {
          arrayCopy[i] = buf[i];
        }

        return arrayCopy.buffer;
      } else {
        throw new Error('Argument must be a Buffer');
      }
    }

    function decideMode(preferBinary, useFetch) {
      if (hasFetch && useFetch) {
        return 'fetch';
      } else if (mozchunkedarraybuffer) {
        return 'moz-chunked-arraybuffer';
      } else if (msstream) {
        return 'ms-stream';
      } else if (arraybuffer && preferBinary) {
        return 'arraybuffer';
      } else if (vbArray && preferBinary) {
        return 'text:vbarray';
      } else {
        return 'text';
      }
    }

    function ClientRequest(opts) {
      var self = this;
      Writable.call(self);
      self._opts = opts;
      self._body = [];
      self._headers = {};
      if (opts.auth) self.setHeader('Authorization', 'Basic ' + new Buffer(opts.auth).toString('base64'));
      Object.keys(opts.headers).forEach(function (name) {
        self.setHeader(name, opts.headers[name]);
      });
      var preferBinary;
      var useFetch = true;

      if (opts.mode === 'disable-fetch') {
        // If the use of XHR should be preferred and includes preserving the 'content-type' header
        useFetch = false;
        preferBinary = true;
      } else if (opts.mode === 'prefer-streaming') {
        // If streaming is a high priority but binary compatibility and
        // the accuracy of the 'content-type' header aren't
        preferBinary = false;
      } else if (opts.mode === 'allow-wrong-content-type') {
        // If streaming is more important than preserving the 'content-type' header
        preferBinary = !overrideMimeType;
      } else if (!opts.mode || opts.mode === 'default' || opts.mode === 'prefer-fast') {
        // Use binary if text streaming may corrupt data or the content-type header, or for speed
        preferBinary = true;
      } else {
        throw new Error('Invalid value for opts.mode');
      }

      self._mode = decideMode(preferBinary, useFetch);
      self.on('finish', function () {
        self._onFinish();
      });
    }

    inherits$1(ClientRequest, Writable); // Taken from http://www.w3.org/TR/XMLHttpRequest/#the-setrequestheader%28%29-method

    var unsafeHeaders = ['accept-charset', 'accept-encoding', 'access-control-request-headers', 'access-control-request-method', 'connection', 'content-length', 'cookie', 'cookie2', 'date', 'dnt', 'expect', 'host', 'keep-alive', 'origin', 'referer', 'te', 'trailer', 'transfer-encoding', 'upgrade', 'user-agent', 'via'];

    ClientRequest.prototype.setHeader = function (name, value) {
      var self = this;
      var lowerName = name.toLowerCase(); // This check is not necessary, but it prevents warnings from browsers about setting unsafe
      // headers. To be honest I'm not entirely sure hiding these warnings is a good thing, but
      // http-browserify did it, so I will too.

      if (unsafeHeaders.indexOf(lowerName) !== -1) return;
      self._headers[lowerName] = {
        name: name,
        value: value
      };
    };

    ClientRequest.prototype.getHeader = function (name) {
      var self = this;
      return self._headers[name.toLowerCase()].value;
    };

    ClientRequest.prototype.removeHeader = function (name) {
      var self = this;
      delete self._headers[name.toLowerCase()];
    };

    ClientRequest.prototype._onFinish = function () {
      var self = this;
      if (self._destroyed) return;
      var opts = self._opts;
      var headersObj = self._headers;
      var body;

      if (opts.method === 'POST' || opts.method === 'PUT' || opts.method === 'PATCH') {
        if (blobConstructor()) {
          body = new global$1.Blob(self._body.map(function (buffer) {
            return toArrayBuffer(buffer);
          }), {
            type: (headersObj['content-type'] || {}).value || ''
          });
        } else {
          // get utf8 string
          body = Buffer.concat(self._body).toString();
        }
      }

      if (self._mode === 'fetch') {
        var headers = Object.keys(headersObj).map(function (name) {
          return [headersObj[name].name, headersObj[name].value];
        });
        global$1.fetch(self._opts.url, {
          method: self._opts.method,
          headers: headers,
          body: body,
          mode: 'cors',
          credentials: opts.withCredentials ? 'include' : 'same-origin'
        }).then(function (response) {
          self._fetchResponse = response;

          self._connect();
        }, function (reason) {
          self.emit('error', reason);
        });
      } else {
        var xhr = self._xhr = new global$1.XMLHttpRequest();

        try {
          xhr.open(self._opts.method, self._opts.url, true);
        } catch (err) {
          browser$1.nextTick(function () {
            self.emit('error', err);
          });
          return;
        } // Can't set responseType on really old browsers


        if ('responseType' in xhr) xhr.responseType = self._mode.split(':')[0];
        if ('withCredentials' in xhr) xhr.withCredentials = !!opts.withCredentials;
        if (self._mode === 'text' && 'overrideMimeType' in xhr) xhr.overrideMimeType('text/plain; charset=x-user-defined');
        Object.keys(headersObj).forEach(function (name) {
          xhr.setRequestHeader(headersObj[name].name, headersObj[name].value);
        });
        self._response = null;

        xhr.onreadystatechange = function () {
          switch (xhr.readyState) {
            case rStates.LOADING:
            case rStates.DONE:
              self._onXHRProgress();

              break;
          }
        }; // Necessary for streaming in Firefox, since xhr.response is ONLY defined
        // in onprogress, not in onreadystatechange with xhr.readyState = 3


        if (self._mode === 'moz-chunked-arraybuffer') {
          xhr.onprogress = function () {
            self._onXHRProgress();
          };
        }

        xhr.onerror = function () {
          if (self._destroyed) return;
          self.emit('error', new Error('XHR error'));
        };

        try {
          xhr.send(body);
        } catch (err) {
          browser$1.nextTick(function () {
            self.emit('error', err);
          });
          return;
        }
      }
    };
    /**
     * Checks if xhr.status is readable and non-zero, indicating no error.
     * Even though the spec says it should be available in readyState 3,
     * accessing it throws an exception in IE8
     */


    function statusValid(xhr) {
      try {
        var status = xhr.status;
        return status !== null && status !== 0;
      } catch (e) {
        return false;
      }
    }

    ClientRequest.prototype._onXHRProgress = function () {
      var self = this;
      if (!statusValid(self._xhr) || self._destroyed) return;
      if (!self._response) self._connect();

      self._response._onXHRProgress();
    };

    ClientRequest.prototype._connect = function () {
      var self = this;
      if (self._destroyed) return;
      self._response = new IncomingMessage(self._xhr, self._fetchResponse, self._mode);
      self.emit('response', self._response);
    };

    ClientRequest.prototype._write = function (chunk, encoding, cb) {
      var self = this;

      self._body.push(chunk);

      cb();
    };

    ClientRequest.prototype.abort = ClientRequest.prototype.destroy = function () {
      var self = this;
      self._destroyed = true;
      if (self._response) self._response._destroyed = true;
      if (self._xhr) self._xhr.abort(); // Currently, there isn't a way to truly abort a fetch.
      // If you like bikeshedding, see https://github.com/whatwg/fetch/issues/27
    };

    ClientRequest.prototype.end = function (data, encoding, cb) {
      var self = this;

      if (typeof data === 'function') {
        cb = data;
        data = undefined;
      }

      Writable.prototype.end.call(self, data, encoding, cb);
    };

    ClientRequest.prototype.flushHeaders = function () {};

    ClientRequest.prototype.setTimeout = function () {};

    ClientRequest.prototype.setNoDelay = function () {};

    ClientRequest.prototype.setSocketKeepAlive = function () {};

    function Agent() {}
    Agent.defaultMaxSockets = 4;

    var fetch$1 = fetch;

    var AUTH_ERRORS = [401, 403, 440, 499];

    var getAgent = function getAgent() {
      return null;
    };

    if (Agent && Agent) {
      var httpAgent = new Agent({
        keepAlive: true,
        keepAliveMsecs: 120000,
        timeout: 60000,
        scheduling: "fifo"
      });
      var httpsAgent = new Agent({
        keepAlive: true,
        keepAliveMsecs: 120000,
        timeout: 60000,
        scheduling: "fifo"
      });

      getAgent = function getAgent(parsedURL) {
        return parsedURL.protocol === "http:" ? httpAgent : httpsAgent;
      };
    }

    var API = /*#__PURE__*/function (_Observable) {
      _inherits(API, _Observable);

      var _super = _createSuper(API);

      function API() {
        var _this;

        var kwargs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        _classCallCheck(this, API);

        _this = _super.call(this);
        _this.kwargs = kwargs;
        return _this;
      }

      _createClass(API, [{
        key: "build",
        value: function () {
          var _build = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(method, url) {
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:

                  case 1:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));

          function build(_x, _x2) {
            return _build.apply(this, arguments);
          }

          return build;
        }()
      }, {
        key: "authCallback",
        value: function () {
          var _authCallback = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(params, headers) {
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2);
          }));

          function authCallback(_x3, _x4) {
            return _authCallback.apply(this, arguments);
          }

          return authCallback;
        }()
      }, {
        key: "get",
        value: function () {
          var _get = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(url) {
            var options,
                result,
                _args3 = arguments;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    options = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : {};
                    _context3.next = 3;
                    return this.methodBasic("GET", url, options);

                  case 3:
                    result = _context3.sent;
                    return _context3.abrupt("return", result);

                  case 5:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3, this);
          }));

          function get(_x5) {
            return _get.apply(this, arguments);
          }

          return get;
        }()
      }, {
        key: "post",
        value: function () {
          var _post = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(url) {
            var options,
                result,
                _args4 = arguments;
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    options = _args4.length > 1 && _args4[1] !== undefined ? _args4[1] : {};
                    _context4.next = 3;
                    return this.methodPayload("POST", url, options);

                  case 3:
                    result = _context4.sent;
                    return _context4.abrupt("return", result);

                  case 5:
                  case "end":
                    return _context4.stop();
                }
              }
            }, _callee4, this);
          }));

          function post(_x6) {
            return _post.apply(this, arguments);
          }

          return post;
        }()
      }, {
        key: "put",
        value: function () {
          var _put = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(url) {
            var options,
                result,
                _args5 = arguments;
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    options = _args5.length > 1 && _args5[1] !== undefined ? _args5[1] : {};
                    _context5.next = 3;
                    return this.methodPayload("PUT", url, options);

                  case 3:
                    result = _context5.sent;
                    return _context5.abrupt("return", result);

                  case 5:
                  case "end":
                    return _context5.stop();
                }
              }
            }, _callee5, this);
          }));

          function put(_x7) {
            return _put.apply(this, arguments);
          }

          return put;
        }()
      }, {
        key: "delete",
        value: function () {
          var _delete2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(url) {
            var options,
                result,
                _args6 = arguments;
            return regeneratorRuntime.wrap(function _callee6$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    options = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : {};
                    _context6.next = 3;
                    return this.methodBasic("DELETE", url, options);

                  case 3:
                    result = _context6.sent;
                    return _context6.abrupt("return", result);

                  case 5:
                  case "end":
                    return _context6.stop();
                }
              }
            }, _callee6, this);
          }));

          function _delete(_x8) {
            return _delete2.apply(this, arguments);
          }

          return _delete;
        }()
      }, {
        key: "patch",
        value: function () {
          var _patch = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(url) {
            var options,
                result,
                _args7 = arguments;
            return regeneratorRuntime.wrap(function _callee7$(_context7) {
              while (1) {
                switch (_context7.prev = _context7.next) {
                  case 0:
                    options = _args7.length > 1 && _args7[1] !== undefined ? _args7[1] : {};
                    _context7.next = 3;
                    return this.methodPayload("PATCH", url, options);

                  case 3:
                    result = _context7.sent;
                    return _context7.abrupt("return", result);

                  case 5:
                  case "end":
                    return _context7.stop();
                }
              }
            }, _callee7, this);
          }));

          function patch(_x9) {
            return _patch.apply(this, arguments);
          }

          return patch;
        }()
      }, {
        key: "options",
        value: function () {
          var _options2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(url) {
            var _options,
                result,
                _args8 = arguments;

            return regeneratorRuntime.wrap(function _callee8$(_context8) {
              while (1) {
                switch (_context8.prev = _context8.next) {
                  case 0:
                    _options = _args8.length > 1 && _args8[1] !== undefined ? _args8[1] : {};
                    _context8.next = 3;
                    return this.methodBasic("OPTIONS", url, _options);

                  case 3:
                    result = _context8.sent;
                    return _context8.abrupt("return", result);

                  case 5:
                  case "end":
                    return _context8.stop();
                }
              }
            }, _callee8, this);
          }));

          function options(_x10) {
            return _options2.apply(this, arguments);
          }

          return options;
        }()
      }, {
        key: "methodBasic",
        value: function () {
          var _methodBasic2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(method, url) {
            var options,
                _args9 = arguments;
            return regeneratorRuntime.wrap(function _callee9$(_context9) {
              while (1) {
                switch (_context9.prev = _context9.next) {
                  case 0:
                    options = _args9.length > 2 && _args9[2] !== undefined ? _args9[2] : {};
                    options.params = options.params !== undefined ? options.params : {};
                    options.headers = options.headers !== undefined ? options.headers : {};
                    _context9.prev = 3;
                    _context9.next = 6;
                    return this._methodBasic(method, url, options);

                  case 6:
                    return _context9.abrupt("return", _context9.sent);

                  case 9:
                    _context9.prev = 9;
                    _context9.t0 = _context9["catch"](3);

                    if (!AUTH_ERRORS.includes(_context9.t0.code)) {
                      _context9.next = 19;
                      break;
                    }

                    _context9.next = 14;
                    return this.authCallback(options.params, options.headers);

                  case 14:
                    _context9.next = 16;
                    return this._methodBasic(method, url, options);

                  case 16:
                    return _context9.abrupt("return", _context9.sent);

                  case 19:
                    throw _context9.t0;

                  case 20:
                  case "end":
                    return _context9.stop();
                }
              }
            }, _callee9, this, [[3, 9]]);
          }));

          function methodBasic(_x11, _x12) {
            return _methodBasic2.apply(this, arguments);
          }

          return methodBasic;
        }()
      }, {
        key: "methodPayload",
        value: function () {
          var _methodPayload2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(method, url) {
            var options,
                _args10 = arguments;
            return regeneratorRuntime.wrap(function _callee10$(_context10) {
              while (1) {
                switch (_context10.prev = _context10.next) {
                  case 0:
                    options = _args10.length > 2 && _args10[2] !== undefined ? _args10[2] : {};
                    options.params = options.params !== undefined ? options.params : {};
                    options.headers = options.headers !== undefined ? options.headers : {};
                    _context10.prev = 3;
                    _context10.next = 6;
                    return this._methodPayload(method, url, options);

                  case 6:
                    return _context10.abrupt("return", _context10.sent);

                  case 9:
                    _context10.prev = 9;
                    _context10.t0 = _context10["catch"](3);

                    if (!AUTH_ERRORS.includes(_context10.t0.code)) {
                      _context10.next = 19;
                      break;
                    }

                    _context10.next = 14;
                    return this.authCallback(options.params, options.headers);

                  case 14:
                    _context10.next = 16;
                    return this._methodPayload(method, url, options);

                  case 16:
                    return _context10.abrupt("return", _context10.sent);

                  case 19:
                    throw _context10.t0;

                  case 20:
                  case "end":
                    return _context10.stop();
                }
              }
            }, _callee10, this, [[3, 9]]);
          }));

          function methodPayload(_x13, _x14) {
            return _methodPayload2.apply(this, arguments);
          }

          return methodPayload;
        }()
      }, {
        key: "_methodBasic",
        value: function () {
          var _methodBasic3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(method, url) {
            var options,
                params,
                headers,
                kwargs,
                handle,
                query,
                response,
                result,
                _args11 = arguments;
            return regeneratorRuntime.wrap(function _callee11$(_context11) {
              while (1) {
                switch (_context11.prev = _context11.next) {
                  case 0:
                    options = _args11.length > 2 && _args11[2] !== undefined ? _args11[2] : {};
                    params = options.params !== undefined ? options.params : {};
                    headers = options.headers !== undefined ? options.headers : {};
                    kwargs = options.kwargs !== undefined ? options.kwargs : {};
                    handle = options.handle !== undefined ? options.handle : true;
                    _context11.next = 7;
                    return this.build(method, url, {
                      params: params,
                      headers: headers,
                      kwargs: kwargs
                    });

                  case 7:
                    query = urlEncode(params || {});
                    if (query) url += url.includes("?") ? "&" + query : "?" + query;
                    _context11.next = 11;
                    return fetch$1(url, {
                      method: method,
                      headers: headers || {},
                      agent: getAgent
                    });

                  case 11:
                    response = _context11.sent;

                    if (!handle) {
                      _context11.next = 18;
                      break;
                    }

                    _context11.next = 15;
                    return this._handleResponse(response);

                  case 15:
                    _context11.t0 = _context11.sent;
                    _context11.next = 19;
                    break;

                  case 18:
                    _context11.t0 = response;

                  case 19:
                    result = _context11.t0;
                    return _context11.abrupt("return", result);

                  case 21:
                  case "end":
                    return _context11.stop();
                }
              }
            }, _callee11, this);
          }));

          function _methodBasic(_x15, _x16) {
            return _methodBasic3.apply(this, arguments);
          }

          return _methodBasic;
        }()
      }, {
        key: "_methodPayload",
        value: function () {
          var _methodPayload3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(method, url) {
            var options,
                params,
                headers,
                data,
                dataJ,
                dataM,
                mime,
                kwargs,
                handle,
                query,
                _this$_encodeMultipar,
                _this$_encodeMultipar2,
                response,
                result,
                _args12 = arguments;

            return regeneratorRuntime.wrap(function _callee12$(_context12) {
              while (1) {
                switch (_context12.prev = _context12.next) {
                  case 0:
                    options = _args12.length > 2 && _args12[2] !== undefined ? _args12[2] : {};
                    params = options.params !== undefined ? options.params : {};
                    headers = options.headers !== undefined ? options.headers : {};
                    data = options.data !== undefined ? options.data : null;
                    dataJ = options.dataJ !== undefined ? options.dataJ : null;
                    dataM = options.dataM !== undefined ? options.dataM : null;
                    mime = options.mime !== undefined ? options.mime : null;
                    kwargs = options.kwargs !== undefined ? options.kwargs : {};
                    handle = options.handle !== undefined ? options.handle : true;
                    _context12.next = 11;
                    return this.build(method, url, {
                      params: params,
                      headers: headers,
                      data: data,
                      dataJ: dataJ,
                      dataM: dataM,
                      mime: mime,
                      kwargs: kwargs
                    });

                  case 11:
                    query = urlEncode(params || {});

                    if (data !== null) {
                      if (query) url += url.includes("?") ? "&" + query : "?" + query;
                    } else if (dataJ !== null) {
                      data = JSON.stringify(dataJ);
                      if (query) url += url.includes("?") ? "&" + query : "?" + query;
                      mime = mime || "application/json";
                    } else if (dataM !== null) {
                      if (query) url += url.includes("?") ? "&" + query : "?" + query;
                      _this$_encodeMultipar = this._encodeMultipart(dataM, mime, true);
                      _this$_encodeMultipar2 = _slicedToArray(_this$_encodeMultipar, 2);
                      mime = _this$_encodeMultipar2[0];
                      data = _this$_encodeMultipar2[1];
                    } else if (query) {
                      data = query;
                      mime = mime || "application/x-www-form-urlencoded";
                    }

                    headers = Object.assign({}, headers);
                    if (mime) headers["Content-Type"] = mime;
                    _context12.next = 17;
                    return fetch$1(url, {
                      method: method,
                      headers: headers || {},
                      body: data,
                      agent: getAgent
                    });

                  case 17:
                    response = _context12.sent;

                    if (!handle) {
                      _context12.next = 24;
                      break;
                    }

                    _context12.next = 21;
                    return this._handleResponse(response);

                  case 21:
                    _context12.t0 = _context12.sent;
                    _context12.next = 25;
                    break;

                  case 24:
                    _context12.t0 = response;

                  case 25:
                    result = _context12.t0;
                    return _context12.abrupt("return", result);

                  case 27:
                  case "end":
                    return _context12.stop();
                }
              }
            }, _callee12, this);
          }));

          function _methodPayload(_x17, _x18) {
            return _methodPayload3.apply(this, arguments);
          }

          return _methodPayload;
        }()
      }, {
        key: "_handleResponse",
        value: function () {
          var _handleResponse2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(response) {
            var errorMessage,
                result,
                _args13 = arguments;
            return regeneratorRuntime.wrap(function _callee13$(_context13) {
              while (1) {
                switch (_context13.prev = _context13.next) {
                  case 0:
                    errorMessage = _args13.length > 1 && _args13[1] !== undefined ? _args13[1] : "Problem in request";
                    result = null;

                    if (!(response.headers.get("content-type") && response.headers.get("content-type").toLowerCase().startsWith("application/json"))) {
                      _context13.next = 8;
                      break;
                    }

                    _context13.next = 5;
                    return response.json();

                  case 5:
                    result = _context13.sent;
                    _context13.next = 17;
                    break;

                  case 8:
                    if (!(response.headers.get("content-type") && response.headers.get("content-type").toLowerCase().startsWith("text/"))) {
                      _context13.next = 14;
                      break;
                    }

                    _context13.next = 11;
                    return response.text();

                  case 11:
                    result = _context13.sent;
                    _context13.next = 17;
                    break;

                  case 14:
                    _context13.next = 16;
                    return response.blob();

                  case 16:
                    result = _context13.sent;

                  case 17:
                    verify(response.ok, result.error || errorMessage, response.status || 500);
                    return _context13.abrupt("return", result);

                  case 19:
                  case "end":
                    return _context13.stop();
                }
              }
            }, _callee13);
          }));

          function _handleResponse(_x19) {
            return _handleResponse2.apply(this, arguments);
          }

          return _handleResponse;
        }()
      }, {
        key: "_encodeMultipart",
        value: function _encodeMultipart(fields) {
          var mime = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
          var doseq = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
          mime = mime || "multipart/form-data";

          var boundary = this._createBoundary(fields, undefined, doseq);

          var encoder = new TextEncoder("utf-8");
          var buffer = [];

          for (var _i = 0, _Object$entries = Object.entries(fields); _i < _Object$entries.length; _i++) {
            var _Object$entries$_i = _slicedToArray(_Object$entries[_i], 2),
                key = _Object$entries$_i[0],
                values = _Object$entries$_i[1];

            var isList = doseq && Array.isArray(values);
            values = isList ? values : [values];

            var _iterator = _createForOfIteratorHelper(values),
                _step;

            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                var value = _step.value;
                if (value === null) continue;
                var header = void 0;

                if (_typeof(value) === "object" && !Array.isArray(value) && value.constructor !== Uint8Array) {
                  var headerL = [];
                  var data = null;

                  for (var _i2 = 0, _Object$entries2 = Object.entries(value); _i2 < _Object$entries2.length; _i2++) {
                    var _Object$entries2$_i = _slicedToArray(_Object$entries2[_i2], 2),
                        _key = _Object$entries2$_i[0],
                        item = _Object$entries2$_i[1];

                    if (_key === "data") data = item;else headerL.push("".concat(_key, ": ").concat(item));
                  }

                  value = data;
                  header = headerL.join("\r\n");
                } else if (Array.isArray(value)) {
                  var name = null;
                  var contents = null;
                  var contentTypeD = null;

                  if (value.length === 2) {
                    var _value = value;

                    var _value2 = _slicedToArray(_value, 2);

                    name = _value2[0];
                    contents = _value2[1];
                  } else {
                    var _value3 = value;

                    var _value4 = _slicedToArray(_value3, 3);

                    name = _value4[0];
                    contentTypeD = _value4[1];
                    contents = _value4[2];
                  }

                  header = "Content-Disposition: form-data; name=\"".concat(key, "\"; filename=\"").concat(name, "\"");
                  if (contentTypeD) header += "\r\nContent-Type: ".concat(contentTypeD);
                  value = contents;
                } else {
                  header = "Content-Disposition: form-data; name=\"".concat(key, "\"");
                }

                buffer.push(encoder.encode("--" + boundary + "\r\n"));
                buffer.push(encoder.encode(header + "\r\n"));
                buffer.push(encoder.encode("\r\n"));
                buffer.push(value);
                buffer.push(encoder.encode("\r\n"));
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }
          }

          buffer.push(encoder.encode("--" + boundary + "--\r\n"));
          buffer.push(encoder.encode("\r\n"));

          var body = this._joinBuffer(buffer);

          var contentType = "".concat(mime, "; boundary=").concat(boundary);
          return [contentType, body];
        }
      }, {
        key: "_createBoundary",
        value: function _createBoundary(fields) {
          return "Vq2xNWWHbmWYF644q9bC5T2ALtj5CynryArNQRXGYsfm37vwFKMNsqPBrpPeprFs";
        }
      }, {
        key: "_joinBuffer",
        value: function _joinBuffer(bufferArray) {
          var bufferSize = bufferArray.map(function (item) {
            return item.byteLength;
          }).reduce(function (a, v) {
            return a + v;
          }, 0);
          var buffer = new Uint8Array(bufferSize);
          var offset = 0;

          var _iterator2 = _createForOfIteratorHelper(bufferArray),
              _step2;

          try {
            for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
              var item = _step2.value;
              buffer.set(item, offset);
              offset += item.byteLength;
            }
          } catch (err) {
            _iterator2.e(err);
          } finally {
            _iterator2.f();
          }

          return buffer;
        }
      }]);

      return API;
    }(Observable);

    var OAuthAPI = /*#__PURE__*/function (_API) {
      _inherits(OAuthAPI, _API);

      var _super = _createSuper(OAuthAPI);

      function OAuthAPI() {
        _classCallCheck(this, OAuthAPI);

        return _super.apply(this, arguments);
      }

      return OAuthAPI;
    }(API);

    var OAuth1API = /*#__PURE__*/function (_OAuthAPI) {
      _inherits(OAuth1API, _OAuthAPI);

      var _super = _createSuper(OAuth1API);

      function OAuth1API() {
        _classCallCheck(this, OAuth1API);

        return _super.apply(this, arguments);
      }

      return OAuth1API;
    }(OAuthAPI);

    var OAuth2API = /*#__PURE__*/function (_OAuthAPI) {
      _inherits(OAuth2API, _OAuthAPI);

      var _super = _createSuper(OAuth2API);

      function OAuth2API() {
        var _this;

        var kwargs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        _classCallCheck(this, OAuth2API);

        _this = _super.call(this, kwargs);
        _this.accessToken = null;
        return _this;
      }

      _createClass(OAuth2API, [{
        key: "build",
        value: function () {
          var _build = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(method, url) {
            var options,
                params,
                headers,
                kwargs,
                token,
                _args = arguments;
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    options = _args.length > 2 && _args[2] !== undefined ? _args[2] : {};
                    _context.next = 3;
                    return _get(_getPrototypeOf(OAuth2API.prototype), "build", this).call(this, method, url, options);

                  case 3:
                    params = options.params !== undefined ? options.params : {};
                    headers = options.headers !== undefined ? options.headers : {};
                    kwargs = options.kwargs !== undefined ? options.kwargs : {};
                    token = kwargs.token === undefined ? this.tokenDefault : kwargs.token;
                    delete kwargs.token;

                    if (token && this.oauthTypes.includes("param")) {
                      params[this.oauthParam] = this.getAccessToken();
                    }

                    if (token && this.oauthTypes.includes("header")) {
                      headers.Authorization = "Bearer ".concat(this.getAccessToken());
                    }

                  case 10:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          function build(_x, _x2) {
            return _build.apply(this, arguments);
          }

          return build;
        }()
      }, {
        key: "getAccessToken",
        value: function getAccessToken() {
          if (this.accessToken) return this.accessToken;
          throw new Error("No access token found must re-authorize");
        }
      }, {
        key: "oauthTypes",
        get: function get() {
          return ["param", "header"];
        }
      }, {
        key: "oauthParam",
        get: function get() {
          return "access_token";
        }
      }, {
        key: "tokenDefault",
        get: function get() {
          return true;
        }
      }]);

      return OAuth2API;
    }(OAuthAPI);

    /**
     * Ensures that the current "session" context contains the
     * requested ACL token as valid.
     *
     * In case the validation fails an exception is raised
     * indicating the auth validation error.
     *
     * @param {String} token The ACL token to ensure permission,
     * the logged user should be allowed to id.
     * @param {Object} ctx The context object to be used in
     * the session basic ACL retrieval, should contain proper
     * injected methods for retrieval (eg: `getAcl`).
     */

    var ensurePermissions = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(token, ctx) {
        var acl, tokens;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!ctx.getAcl) {
                  _context.next = 6;
                  break;
                }

                _context.next = 3;
                return ctx.getAcl(ctx);

              case 3:
                _context.t0 = _context.sent;
                _context.next = 7;
                break;

              case 6:
                _context.t0 = {};

              case 7:
                acl = _context.t0;
                tokens = toTokensM(acl); // in case the permission validation test is not positive
                // then an exception should be raised indicating the issue

                if (_hasPermission(token, tokens)) {
                  _context.next = 11;
                  break;
                }

                throw new OperationalError("You don't have authorization to access this resource", 401);

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function ensurePermissions(_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }();
    /**
     * Converts the provided list of token strings separated by dots
     * into a map based representation on an hierarchical structure.
     *
     * @param {Array} tokens A linear array of tokens to convert into
     * an hierarchical representation.
     * @returns {Object} The map containing the hierarchy of tokens
     * for the provided linear string based sequence of tokens.
     */

    var toTokensM = function toTokensM(tokens) {
      var tokensM = {};
      if (tokens === undefined) return tokensM;
      if (tokens === null) return tokensM;
      if (!Array.isArray(tokens)) return tokensM;

      var _iterator = _createForOfIteratorHelper(tokens),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var token = _step.value;
          var tokensC = tokensM;
          var tokenL = token.split(".");
          var head = tokenL.slice(0, tokenL.length - 1);
          var tail = tokenL[tokenL.length - 1];

          var _iterator2 = _createForOfIteratorHelper(head),
              _step2;

          try {
            for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
              var tokenP = _step2.value;
              var current = tokensC[tokenP] || {};
              var isDict = _typeof(current) === "object";
              if (!isDict) current = {
                _: current
              };
              tokensC[tokenP] = current;
              tokensC = current;
            }
          } catch (err) {
            _iterator2.e(err);
          } finally {
            _iterator2.f();
          }

          var leaf = tokensC[tail] || null;
          if (leaf && _typeof(leaf) === "object") leaf._ = true;else tokensC[tail] = true;
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return tokensM;
    };

    var _hasPermission = function _hasPermission(token) {
      var tokensM = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      if (!token) return true;
      if (tokensM === undefined || tokensM === null) return false;
      var tokenL = token.split(".");

      var _iterator3 = _createForOfIteratorHelper(tokenL),
          _step3;

      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var tokenP = _step3.value;
          if (_typeof(tokensM) !== "object") return false;
          if (tokensM["*"]) return true;
          if (tokensM[tokenP] === undefined) return false;
          tokensM = tokensM[tokenP];
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }

      var isDict = _typeof(tokensM) === "object";
      var result = isDict ? tokensM._ || false : tokensM;
      return Boolean(result);
    };

    var REGISTRY = {};
    var load = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return load$1();

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function load() {
        return _ref.apply(this, arguments);
      };
    }();
    var unload = /*#__PURE__*/function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function unload() {
        return _ref2.apply(this, arguments);
      };
    }();
    var register = function register(name, value) {
      REGISTRY[name] = value;
    };
    var unregister = function unregister(name) {
      delete REGISTRY[name];
    };
    var request = function request(name) {
      if (REGISTRY[name] === undefined) {
        throw new OperationalError("Name '".concat(name, "' not found in registry"));
      }

      return REGISTRY[name];
    };

    var FileTuple = /*#__PURE__*/function (_Array) {
      _inherits(FileTuple, _Array);

      var _super = _createSuper(FileTuple);

      function FileTuple() {
        _classCallCheck(this, FileTuple);

        return _super.apply(this, arguments);
      }

      _createClass(FileTuple, [{
        key: "name",
        get: function get() {
          return this[0];
        }
      }, {
        key: "mime",
        get: function get() {
          return this[1];
        }
      }, {
        key: "data",
        get: function get() {
          return this[2];
        }
      }], [{
        key: "fromData",
        value: function fromData(data) {
          var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
          var mime = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
          var fileTuple = new this(name, mime, data);
          return fileTuple;
        }
      }, {
        key: "fromString",
        value: function fromString(dataString) {
          var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
          var mime = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
          var data = new TextEncoder("utf-8").encode(dataString);
          return this.fromData(data, name, mime);
        }
      }]);

      return FileTuple;
    }( /*#__PURE__*/_wrapNativeSuper(Array));

    /**
     * Abstract class definition that defines the interface
     * expected to be implemented by data driven collections
     * in the Yonius context.
     */

    var Collection = /*#__PURE__*/function () {
      function Collection(options) {
        _classCallCheck(this, Collection);

        this.options = options;
      }

      _createClass(Collection, [{
        key: "find",
        value: function () {
          var _find = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(conditions) {
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    throw new NotImplementedError();

                  case 3:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee);
          }));

          function find(_x) {
            return _find.apply(this, arguments);
          }

          return find;
        }()
      }, {
        key: "findOne",
        value: function () {
          var _findOne = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(conditions) {
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    throw new NotImplementedError();

                  case 3:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2);
          }));

          function findOne(_x2) {
            return _findOne.apply(this, arguments);
          }

          return findOne;
        }()
      }, {
        key: "findOneAndUpdate",
        value: function () {
          var _findOneAndUpdate = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(conditions, data) {
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    throw new NotImplementedError();

                  case 2:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3);
          }));

          function findOneAndUpdate(_x3, _x4) {
            return _findOneAndUpdate.apply(this, arguments);
          }

          return findOneAndUpdate;
        }()
      }, {
        key: "findOneAndDelete",
        value: function () {
          var _findOneAndDelete = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(conditions) {
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    throw new NotImplementedError();

                  case 2:
                  case "end":
                    return _context4.stop();
                }
              }
            }, _callee4);
          }));

          function findOneAndDelete(_x5) {
            return _findOneAndDelete.apply(this, arguments);
          }

          return findOneAndDelete;
        }()
      }, {
        key: "create",
        value: function () {
          var _create = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(data) {
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
              while (1) {
                switch (_context5.prev = _context5.next) {
                  case 0:
                    throw new NotImplementedError();

                  case 2:
                  case "end":
                    return _context5.stop();
                }
              }
            }, _callee5);
          }));

          function create(_x6) {
            return _create.apply(this, arguments);
          }

          return create;
        }()
      }]);

      return Collection;
    }();
    /**
     * Mongo based collection that implements the collection
     * abstract interface applying it to a specific mongodb
     * instance. Most of the interface is already "mongodb
     * oriented", so only a thin layer of adaptation is required.
     */

    var MongoCollection = /*#__PURE__*/function (_Collection) {
      _inherits(MongoCollection, _Collection);

      var _super = _createSuper(MongoCollection);

      function MongoCollection(name, schema) {
        var _this;

        _classCallCheck(this, MongoCollection);

        _this = _super.call(this, name, schema);
        _this._mongoose = _this.constructor.getModel(_this.options.name, _this.options.schema);
        return _this;
      }

      _createClass(MongoCollection, [{
        key: "find",
        value: function () {
          var _find2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(conditions) {
            var projection,
                options,
                model,
                _args6 = arguments;
            return regeneratorRuntime.wrap(function _callee6$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    projection = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : {};
                    options = _args6.length > 2 && _args6[2] !== undefined ? _args6[2] : {};
                    _context6.next = 4;
                    return this._mongoose.find(conditions, projection, options);

                  case 4:
                    model = _context6.sent;
                    return _context6.abrupt("return", model);

                  case 6:
                  case "end":
                    return _context6.stop();
                }
              }
            }, _callee6, this);
          }));

          function find(_x7) {
            return _find2.apply(this, arguments);
          }

          return find;
        }()
      }, {
        key: "findOne",
        value: function () {
          var _findOne2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(conditions) {
            var projection,
                options,
                model,
                _args7 = arguments;
            return regeneratorRuntime.wrap(function _callee7$(_context7) {
              while (1) {
                switch (_context7.prev = _context7.next) {
                  case 0:
                    projection = _args7.length > 1 && _args7[1] !== undefined ? _args7[1] : {};
                    options = _args7.length > 2 && _args7[2] !== undefined ? _args7[2] : {};
                    model = this._mongoose.findOne(conditions, projection, options);
                    return _context7.abrupt("return", model);

                  case 4:
                  case "end":
                    return _context7.stop();
                }
              }
            }, _callee7, this);
          }));

          function findOne(_x8) {
            return _findOne2.apply(this, arguments);
          }

          return findOne;
        }()
      }, {
        key: "findOneAndUpdate",
        value: function () {
          var _findOneAndUpdate2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(conditions, data) {
            var options,
                model,
                _args8 = arguments;
            return regeneratorRuntime.wrap(function _callee8$(_context8) {
              while (1) {
                switch (_context8.prev = _context8.next) {
                  case 0:
                    options = _args8.length > 2 && _args8[2] !== undefined ? _args8[2] : {};
                    _context8.next = 3;
                    return this._mongoose.findOneAndUpdate(conditions, data, _objectSpread2({
                      upsert: true,
                      "new": true
                    }, options));

                  case 3:
                    model = _context8.sent;
                    return _context8.abrupt("return", model);

                  case 5:
                  case "end":
                    return _context8.stop();
                }
              }
            }, _callee8, this);
          }));

          function findOneAndUpdate(_x9, _x10) {
            return _findOneAndUpdate2.apply(this, arguments);
          }

          return findOneAndUpdate;
        }()
      }, {
        key: "findOneAndDelete",
        value: function () {
          var _findOneAndDelete2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(conditions) {
            var options,
                model,
                _args9 = arguments;
            return regeneratorRuntime.wrap(function _callee9$(_context9) {
              while (1) {
                switch (_context9.prev = _context9.next) {
                  case 0:
                    options = _args9.length > 1 && _args9[1] !== undefined ? _args9[1] : {};
                    _context9.next = 3;
                    return this._mongoose.findOneAndDelete(conditions, options);

                  case 3:
                    model = _context9.sent;
                    return _context9.abrupt("return", model);

                  case 5:
                  case "end":
                    return _context9.stop();
                }
              }
            }, _callee9, this);
          }));

          function findOneAndDelete(_x11) {
            return _findOneAndDelete2.apply(this, arguments);
          }

          return findOneAndDelete;
        }()
      }, {
        key: "create",
        value: function () {
          var _create2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(data) {
            var options,
                models,
                _args10 = arguments;
            return regeneratorRuntime.wrap(function _callee10$(_context10) {
              while (1) {
                switch (_context10.prev = _context10.next) {
                  case 0:
                    options = _args10.length > 1 && _args10[1] !== undefined ? _args10[1] : {};
                    _context10.next = 3;
                    return this._mongoose.create([data], options);

                  case 3:
                    models = _context10.sent;
                    return _context10.abrupt("return", models[0]);

                  case 5:
                  case "end":
                    return _context10.stop();
                }
              }
            }, _callee10, this);
          }));

          function create(_x12) {
            return _create2.apply(this, arguments);
          }

          return create;
        }()
      }], [{
        key: "getModel",
        value: function getModel(name, schema) {
          // verifies if the model is already present in the global
          // cache and if that the case re-uses it
          this._models = this._models || {};
          if (this._models[name]) return this._models[name]; // obtains a reference to the mongoose, that
          // should have been registered by 3rd party

          var mongoose = request("mongoose"); // creates the internal "mongoose" reference to the
          // model by encapsulating its name and schema

          this._models[name] = mongoose.model(name, new mongoose.Schema(schema)); // returns the newly constructor mongoose model to
          // the caller methods

          return this._models[name];
        }
      }]);

      return MongoCollection;
    }(Collection);

    var collection = /*#__PURE__*/Object.freeze({
        __proto__: null,
        Collection: Collection,
        MongoCollection: MongoCollection,
        'default': Collection
    });

    var MEMORY_STORAGE = {};
    var TYPE_DEFAULTS = {
      bytes: null,
      unicode: null,
      "int": null,
      "float": null,
      bool: false,
      list: function list() {
        return [];
      },
      dict: function dict() {
        return {};
      },
      object: function object() {
        return {};
      }
    };
    /**
     * The map that associates the various operators with the boolean
     * values that define if an insensitive base search should be used
     * instead of the "typical" sensitive search.
     */

    var INSENSITIVE = {
      likei: true,
      llikei: true,
      rlikei: true
    };
    /**
     * The map containing the mapping association between the
     * normalized version of the operators and the infra-structure
     * specific value for each of this operations, note that some
     * of the values don't have a valid mapping for this operations
     * the operator must be ignored and not used explicitly.
     */

    var OPERATORS = {
      eq: null,
      equals: null,
      ne: "$ne",
      not_equals: "$ne",
      "in": "$in",
      nin: "$nin",
      not_in: "$nin",
      like: "$regex",
      likei: "$regex",
      llike: "$regex",
      llikei: "$regex",
      rlike: "$regex",
      rlikei: "$regex",
      gt: "$gt",
      greater: "$gt",
      gte: "$gte",
      greater_equal: "$gte",
      lt: "$lt",
      lesser: "$lt",
      lte: "$lte",
      lesser_equal: "$lte",
      "null": null,
      is_null: null,
      not_null: "$ne",
      is_not_null: "$ne",
      contains: "$all"
    };
    /**
     * Map that associates each of the normalized operations with
     * an inline function that together with the data type maps the
     * the base string based value into the target normalized value.
     */

    var VALUE_METHODS = {
      "in": function _in(v, t) {
        return v.split(";").map(t);
      },
      not_in: function not_in(v, t) {
        return v.split(";").map(t);
      },
      like: function like(v, t) {
        return "^.*" + escapeStringRegexp(v) + ".*$";
      },
      likei: function likei(v, t) {
        return "^.*" + escapeStringRegexp(v) + ".*$";
      },
      llike: function llike(v, t) {
        return "^.*" + escapeStringRegexp(v) + "$";
      },
      llikei: function llikei(v, t) {
        return "^.*" + escapeStringRegexp(v) + "$";
      },
      rlike: function rlike(v, t) {
        return "^" + escapeStringRegexp(v) + ".*$";
      },
      rlikei: function rlikei(v, t) {
        return "^" + escapeStringRegexp(v) + ".*$";
      },
      "null": function _null(v, t) {
        return null;
      },
      is_null: function is_null(v, t) {
        return null;
      },
      not_null: function not_null(v, t) {
        return null;
      },
      is_not_null: function is_not_null(v, t) {
        return null;
      },
      contains: function contains(v, t) {
        return v.split(";");
      }
    };
    var Model = /*#__PURE__*/function () {
      function Model() {
        var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        _classCallCheck(this, Model);

        var fill = options.fill === undefined ? true : options.fill;
        if (fill) this.constructor.fill(this);
      }

      _createClass(Model, [{
        key: "validate",
        value: function () {
          var _validate2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
            var errors;
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    errors = _toConsumableArray(this._validate());

                    if (!errors.length) {
                      _context.next = 3;
                      break;
                    }

                    throw new ValidationError("Invalid model: ".concat(errors.map(function (err) {
                      return String(err);
                    }).join(", ")));

                  case 3:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          function validate() {
            return _validate2.apply(this, arguments);
          }

          return validate;
        }()
      }, {
        key: "apply",
        value: function () {
          var _apply = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(model) {
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    _context2.next = 2;
                    return this.wrap(model);

                  case 2:
                    return _context2.abrupt("return", this);

                  case 3:
                  case "end":
                    return _context2.stop();
                }
              }
            }, _callee2, this);
          }));

          function apply(_x) {
            return _apply.apply(this, arguments);
          }

          return apply;
        }()
      }, {
        key: "wrap",
        value: function () {
          var _wrap2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(model) {
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    _context3.next = 2;
                    return this._wrap(model);

                  case 2:
                    return _context3.abrupt("return", this);

                  case 3:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3, this);
          }));

          function wrap(_x2) {
            return _wrap2.apply(this, arguments);
          }

          return wrap;
        }()
      }, {
        key: "isNew",
        get: function get() {
          return this._id === undefined;
        }
      }, {
        key: "model",
        get: function get() {
          return this;
        }
      }, {
        key: "jsonV",
        get: function get() {
          return this.model;
        }
      }, {
        key: "string",
        get: function get() {
          return JSON.stringify(this.model);
        }
        /**
         * Wraps the provided model object around the current instance, making
         * sure that all of the elements are compliant with the schema.
         *
         * It should be possible to override the `_wrap` operation to implement
         * a custom "way" of setting data into a model.
         *
         * @param {Object} model The model structure that is going to be used
         * to wrap the current model object, meaning that all of its elements
         * are going to be stored in the current object.
         */

      }, {
        key: "_wrap",
        value: function () {
          var _wrap3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(model) {
            var _i, _Object$keys, key;

            return regeneratorRuntime.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    _i = 0, _Object$keys = Object.keys(this.constructor.schema);

                  case 1:
                    if (!(_i < _Object$keys.length)) {
                      _context4.next = 9;
                      break;
                    }

                    key = _Object$keys[_i];

                    if (!(model[key] === undefined)) {
                      _context4.next = 5;
                      break;
                    }

                    return _context4.abrupt("continue", 6);

                  case 5:
                    this[key] = model[key];

                  case 6:
                    _i++;
                    _context4.next = 1;
                    break;

                  case 9:
                    if (model._id !== undefined) this._id = model._id;

                  case 10:
                  case "end":
                    return _context4.stop();
                }
              }
            }, _callee4, this);
          }));

          function _wrap(_x3) {
            return _wrap3.apply(this, arguments);
          }

          return _wrap;
        }()
      }, {
        key: "_validate",
        value: /*#__PURE__*/regeneratorRuntime.mark(function _validate() {
          var _i2, _Object$entries, _Object$entries$_i, name, value, validation, _iterator, _step, callable;

          return regeneratorRuntime.wrap(function _validate$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  _i2 = 0, _Object$entries = Object.entries(this.constructor.schema);

                case 1:
                  if (!(_i2 < _Object$entries.length)) {
                    _context5.next = 32;
                    break;
                  }

                  _Object$entries$_i = _slicedToArray(_Object$entries[_i2], 2), name = _Object$entries$_i[0], value = _Object$entries$_i[1];
                  validation = value.validation || false;

                  if (validation) {
                    _context5.next = 6;
                    break;
                  }

                  return _context5.abrupt("continue", 29);

                case 6:
                  _iterator = _createForOfIteratorHelper(validation);
                  _context5.prev = 7;

                  _iterator.s();

                case 9:
                  if ((_step = _iterator.n()).done) {
                    _context5.next = 21;
                    break;
                  }

                  callable = _step.value;
                  _context5.prev = 11;
                  callable(this[name]);
                  _context5.next = 19;
                  break;

                case 15:
                  _context5.prev = 15;
                  _context5.t0 = _context5["catch"](11);
                  _context5.next = 19;
                  return _context5.t0;

                case 19:
                  _context5.next = 9;
                  break;

                case 21:
                  _context5.next = 26;
                  break;

                case 23:
                  _context5.prev = 23;
                  _context5.t1 = _context5["catch"](7);

                  _iterator.e(_context5.t1);

                case 26:
                  _context5.prev = 26;

                  _iterator.f();

                  return _context5.finish(26);

                case 29:
                  _i2++;
                  _context5.next = 1;
                  break;

                case 32:
                case "end":
                  return _context5.stop();
              }
            }
          }, _validate, this, [[7, 23, 26, 29], [11, 15]]);
        })
      }], [{
        key: "niw",
        value: function niw() {
          return new this();
        }
        /**
         * Fills the current model with the proper values so that
         * no values are unset as this would violate the model definition
         * integrity. This is required when retrieving an object(s) from
         * the data source (as some of them may be incomplete).
         *
         * @param {Object} model The model that is going to have its unset
         * attributes filled with "default" data, in case none is provided
         * all of the attributes will be filled with "default" data.
         * @param {Boolean} safe If the safe mode should be used for the fill
         * operation meaning that under some conditions no unit fill
         * operation is going to be applied (eg: retrieval operations).
         */

      }, {
        key: "fill",
        value: function () {
          var _fill = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
            var model,
                safe,
                _i3,
                _Object$entries2,
                _Object$entries2$_i,
                name,
                field,
                _private,
                increment,
                initial,
                type,
                _default,
                _args6 = arguments;

            return regeneratorRuntime.wrap(function _callee5$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    model = _args6.length > 0 && _args6[0] !== undefined ? _args6[0] : {};
                    safe = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : false;
                    _i3 = 0, _Object$entries2 = Object.entries(this.schema);

                  case 3:
                    if (!(_i3 < _Object$entries2.length)) {
                      _context6.next = 19;
                      break;
                    }

                    _Object$entries2$_i = _slicedToArray(_Object$entries2[_i3], 2), name = _Object$entries2$_i[0], field = _Object$entries2$_i[1];

                    if (!(model[name] !== undefined)) {
                      _context6.next = 7;
                      break;
                    }

                    return _context6.abrupt("continue", 16);

                  case 7:
                    if (!["_id"].includes(model[name])) {
                      _context6.next = 9;
                      break;
                    }

                    return _context6.abrupt("continue", 16);

                  case 9:
                    _private = field["private"] === undefined ? false : field["private"];
                    increment = field.increment === undefined ? false : field.increment;

                    if (!(_private && safe)) {
                      _context6.next = 13;
                      break;
                    }

                    return _context6.abrupt("continue", 16);

                  case 13:
                    if (!increment) {
                      _context6.next = 15;
                      break;
                    }

                    return _context6.abrupt("continue", 16);

                  case 15:
                    if (field.initial !== undefined) {
                      initial = field.initial;
                      model[name] = initial;
                    } else {
                      type = field.type || null;
                      _default = typeD(type, null);
                      _default = type._default === undefined ? _default : type._default();
                      model[name] = _default;
                    }

                  case 16:
                    _i3++;
                    _context6.next = 3;
                    break;

                  case 19:
                  case "end":
                    return _context6.stop();
                }
              }
            }, _callee5, this);
          }));

          function fill() {
            return _fill.apply(this, arguments);
          }

          return fill;
        }()
        /**
         * The name of the data source adapter that is going
         * to be used to handle this model instance.
         *
         * @type {String}
         */

      }, {
        key: "adapter",
        get: function get() {
          return process.env.ADAPTER || "mongo";
        }
      }]);

      return Model;
    }();
    var ModelStore = /*#__PURE__*/function (_Model) {
      _inherits(ModelStore, _Model);

      var _super = _createSuper(ModelStore);

      function ModelStore() {
        _classCallCheck(this, ModelStore);

        return _super.apply(this, arguments);
      }

      _createClass(ModelStore, [{
        key: "save",
        value: function () {
          var _save = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
            var _ref,
                _ref$validate,
                validate,
                _ref$preSave,
                preSave,
                _ref$preCreate,
                preCreate,
                _ref$preUpdate,
                preUpdate,
                _ref$postSave,
                postSave,
                _ref$postCreate,
                postCreate,
                _ref$postUpdate,
                postUpdate,
                _ref$beforeCallbacks,
                beforeCallbacks,
                _ref$afterCallbacks,
                afterCallbacks,
                model,
                _iterator2,
                _step2,
                name,
                exists,
                _iterator3,
                _step3,
                callback,
                isNew,
                conditions,
                _iterator4,
                _step4,
                _callback,
                _args7 = arguments;

            return regeneratorRuntime.wrap(function _callee6$(_context7) {
              while (1) {
                switch (_context7.prev = _context7.next) {
                  case 0:
                    _ref = _args7.length > 0 && _args7[0] !== undefined ? _args7[0] : {}, _ref$validate = _ref.validate, validate = _ref$validate === void 0 ? true : _ref$validate, _ref$preSave = _ref.preSave, preSave = _ref$preSave === void 0 ? true : _ref$preSave, _ref$preCreate = _ref.preCreate, preCreate = _ref$preCreate === void 0 ? true : _ref$preCreate, _ref$preUpdate = _ref.preUpdate, preUpdate = _ref$preUpdate === void 0 ? true : _ref$preUpdate, _ref$postSave = _ref.postSave, postSave = _ref$postSave === void 0 ? true : _ref$postSave, _ref$postCreate = _ref.postCreate, postCreate = _ref$postCreate === void 0 ? true : _ref$postCreate, _ref$postUpdate = _ref.postUpdate, postUpdate = _ref$postUpdate === void 0 ? true : _ref$postUpdate, _ref$beforeCallbacks = _ref.beforeCallbacks, beforeCallbacks = _ref$beforeCallbacks === void 0 ? [] : _ref$beforeCallbacks, _ref$afterCallbacks = _ref.afterCallbacks, afterCallbacks = _ref$afterCallbacks === void 0 ? [] : _ref$afterCallbacks;
                    // iterates over each of the fields that are meant to have its value
                    // increment and performs the appropriate operation taking into account
                    // if the value is already populated or not
                    _iterator2 = _createForOfIteratorHelper(this.constructor.increments);
                    _context7.prev = 2;

                    _iterator2.s();

                  case 4:
                    if ((_step2 = _iterator2.n()).done) {
                      _context7.next = 18;
                      break;
                    }

                    name = _step2.value;
                    exists = this.model[name] !== undefined;

                    if (!exists) {
                      _context7.next = 13;
                      break;
                    }

                    _context7.next = 10;
                    return this.constructor._ensureMin(name, this.model[name]);

                  case 10:
                    this.model[name] = _context7.sent;
                    _context7.next = 16;
                    break;

                  case 13:
                    _context7.next = 15;
                    return this.constructor._increment(name);

                  case 15:
                    this.model[name] = _context7.sent;

                  case 16:
                    _context7.next = 4;
                    break;

                  case 18:
                    _context7.next = 23;
                    break;

                  case 20:
                    _context7.prev = 20;
                    _context7.t0 = _context7["catch"](2);

                    _iterator2.e(_context7.t0);

                  case 23:
                    _context7.prev = 23;

                    _iterator2.f();

                    return _context7.finish(23);

                  case 26:
                    if (!validate) {
                      _context7.next = 29;
                      break;
                    }

                    _context7.next = 29;
                    return this.validate();

                  case 29:
                    _context7.next = 31;
                    return this.verify();

                  case 31:
                    if (!preSave) {
                      _context7.next = 34;
                      break;
                    }

                    _context7.next = 34;
                    return this.preSave();

                  case 34:
                    if (!preCreate) {
                      _context7.next = 37;
                      break;
                    }

                    _context7.next = 37;
                    return this.preCreate();

                  case 37:
                    if (!preUpdate) {
                      _context7.next = 40;
                      break;
                    }

                    _context7.next = 40;
                    return this.preUpdate();

                  case 40:
                    // calls the complete set of callbacks that should be called
                    // before the concrete data store save operation
                    _iterator3 = _createForOfIteratorHelper(beforeCallbacks);
                    _context7.prev = 41;

                    _iterator3.s();

                  case 43:
                    if ((_step3 = _iterator3.n()).done) {
                      _context7.next = 49;
                      break;
                    }

                    callback = _step3.value;
                    _context7.next = 47;
                    return callback(this, this.model);

                  case 47:
                    _context7.next = 43;
                    break;

                  case 49:
                    _context7.next = 54;
                    break;

                  case 51:
                    _context7.prev = 51;
                    _context7.t1 = _context7["catch"](41);

                    _iterator3.e(_context7.t1);

                  case 54:
                    _context7.prev = 54;

                    _iterator3.f();

                    return _context7.finish(54);

                  case 57:
                    // verifies if the current model is a new one or if instead
                    // represents an update to a previously stored model and create
                    // or update data accordingly
                    isNew = this._id === undefined;

                    if (!isNew) {
                      _context7.next = 64;
                      break;
                    }

                    _context7.next = 61;
                    return this.constructor.collection.create(this.model);

                  case 61:
                    model = _context7.sent;
                    _context7.next = 69;
                    break;

                  case 64:
                    conditions = {};
                    conditions[this.constructor.idName] = this.identifier;
                    _context7.next = 68;
                    return this.constructor.collection.findOneAndUpdate(conditions, this.model);

                  case 68:
                    model = _context7.sent;

                  case 69:
                    // wraps the model object using the current instance
                    // effectively making the data available for consumers
                    this.wrap(model); // calls the complete set of callbacks that should be called
                    // after the concrete data store save operation

                    _iterator4 = _createForOfIteratorHelper(afterCallbacks);
                    _context7.prev = 71;

                    _iterator4.s();

                  case 73:
                    if ((_step4 = _iterator4.n()).done) {
                      _context7.next = 79;
                      break;
                    }

                    _callback = _step4.value;
                    _context7.next = 77;
                    return _callback(this, this.model);

                  case 77:
                    _context7.next = 73;
                    break;

                  case 79:
                    _context7.next = 84;
                    break;

                  case 81:
                    _context7.prev = 81;
                    _context7.t2 = _context7["catch"](71);

                    _iterator4.e(_context7.t2);

                  case 84:
                    _context7.prev = 84;

                    _iterator4.f();

                    return _context7.finish(84);

                  case 87:
                    if (!postSave) {
                      _context7.next = 90;
                      break;
                    }

                    _context7.next = 90;
                    return this.postSave();

                  case 90:
                    if (!postCreate) {
                      _context7.next = 93;
                      break;
                    }

                    _context7.next = 93;
                    return this.postCreate();

                  case 93:
                    if (!postUpdate) {
                      _context7.next = 96;
                      break;
                    }

                    _context7.next = 96;
                    return this.postUpdate();

                  case 96:
                    return _context7.abrupt("return", this);

                  case 97:
                  case "end":
                    return _context7.stop();
                }
              }
            }, _callee6, this, [[2, 20, 23, 26], [41, 51, 54, 57], [71, 81, 84, 87]]);
          }));

          function save() {
            return _save.apply(this, arguments);
          }

          return save;
        }()
      }, {
        key: "delete",
        value: function () {
          var _delete2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
            var _ref2,
                _ref2$preDelete,
                preDelete,
                _ref2$postDelete,
                postDelete,
                _ref2$beforeCallbacks,
                beforeCallbacks,
                _ref2$afterCallbacks,
                afterCallbacks,
                _iterator5,
                _step5,
                callback,
                conditions,
                _iterator6,
                _step6,
                _callback2,
                _args8 = arguments;

            return regeneratorRuntime.wrap(function _callee7$(_context8) {
              while (1) {
                switch (_context8.prev = _context8.next) {
                  case 0:
                    _ref2 = _args8.length > 0 && _args8[0] !== undefined ? _args8[0] : {}, _ref2$preDelete = _ref2.preDelete, preDelete = _ref2$preDelete === void 0 ? true : _ref2$preDelete, _ref2$postDelete = _ref2.postDelete, postDelete = _ref2$postDelete === void 0 ? true : _ref2$postDelete, _ref2$beforeCallbacks = _ref2.beforeCallbacks, beforeCallbacks = _ref2$beforeCallbacks === void 0 ? [] : _ref2$beforeCallbacks, _ref2$afterCallbacks = _ref2.afterCallbacks, afterCallbacks = _ref2$afterCallbacks === void 0 ? [] : _ref2$afterCallbacks;

                    if (!preDelete) {
                      _context8.next = 4;
                      break;
                    }

                    _context8.next = 4;
                    return this.preDelete();

                  case 4:
                    // calls the complete set of callbacks that should be called
                    // before the concrete data store delete operation
                    _iterator5 = _createForOfIteratorHelper(beforeCallbacks);
                    _context8.prev = 5;

                    _iterator5.s();

                  case 7:
                    if ((_step5 = _iterator5.n()).done) {
                      _context8.next = 13;
                      break;
                    }

                    callback = _step5.value;
                    _context8.next = 11;
                    return callback(this, this.model);

                  case 11:
                    _context8.next = 7;
                    break;

                  case 13:
                    _context8.next = 18;
                    break;

                  case 15:
                    _context8.prev = 15;
                    _context8.t0 = _context8["catch"](5);

                    _iterator5.e(_context8.t0);

                  case 18:
                    _context8.prev = 18;

                    _iterator5.f();

                    return _context8.finish(18);

                  case 21:
                    conditions = {};
                    conditions[this.constructor.idName] = this.identifier;
                    _context8.next = 25;
                    return this.constructor.collection.findOneAndDelete(conditions);

                  case 25:
                    // calls the complete set of callbacks that should be called
                    // after the concrete data store delete operation
                    _iterator6 = _createForOfIteratorHelper(afterCallbacks);
                    _context8.prev = 26;

                    _iterator6.s();

                  case 28:
                    if ((_step6 = _iterator6.n()).done) {
                      _context8.next = 34;
                      break;
                    }

                    _callback2 = _step6.value;
                    _context8.next = 32;
                    return _callback2(this, this.model);

                  case 32:
                    _context8.next = 28;
                    break;

                  case 34:
                    _context8.next = 39;
                    break;

                  case 36:
                    _context8.prev = 36;
                    _context8.t1 = _context8["catch"](26);

                    _iterator6.e(_context8.t1);

                  case 39:
                    _context8.prev = 39;

                    _iterator6.f();

                    return _context8.finish(39);

                  case 42:
                    if (!postDelete) {
                      _context8.next = 45;
                      break;
                    }

                    _context8.next = 45;
                    return this.postDelete();

                  case 45:
                    return _context8.abrupt("return", this);

                  case 46:
                  case "end":
                    return _context8.stop();
                }
              }
            }, _callee7, this, [[5, 15, 18, 21], [26, 36, 39, 42]]);
          }));

          function _delete() {
            return _delete2.apply(this, arguments);
          }

          return _delete;
        }()
      }, {
        key: "reload",
        value: function () {
          var _reload = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8() {
            var params,
                model,
                _args9 = arguments;
            return regeneratorRuntime.wrap(function _callee8$(_context9) {
              while (1) {
                switch (_context9.prev = _context9.next) {
                  case 0:
                    params = _args9.length > 0 && _args9[0] !== undefined ? _args9[0] : {};

                    if (!this.isNew) {
                      _context9.next = 3;
                      break;
                    }

                    throw new OperationalError("Can't reload a new model entity", 412);

                  case 3:
                    _context9.next = 5;
                    return this.constructor.get(_objectSpread2(_objectSpread2({}, params), {}, {
                      _id: this._id
                    }));

                  case 5:
                    model = _context9.sent;
                    return _context9.abrupt("return", model);

                  case 7:
                  case "end":
                    return _context9.stop();
                }
              }
            }, _callee8, this);
          }));

          function reload() {
            return _reload.apply(this, arguments);
          }

          return reload;
        }()
        /**
         * Runs a series of assertions on the current model
         * definition raising assertion errors in case there
         * are issues with the internal structure of it.
         */

      }, {
        key: "verify",
        value: function () {
          var _verify2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
            var _i4, _Object$entries3, _Object$entries3$_i, name, field;

            return regeneratorRuntime.wrap(function _callee9$(_context10) {
              while (1) {
                switch (_context10.prev = _context10.next) {
                  case 0:
                    verify(this.identifier !== undefined && this.identifier !== null, "The identifier must be defined before saving");

                    for (_i4 = 0, _Object$entries3 = Object.entries(this.constructor.schema); _i4 < _Object$entries3.length; _i4++) {
                      _Object$entries3$_i = _slicedToArray(_Object$entries3[_i4], 2), name = _Object$entries3$_i[0], field = _Object$entries3$_i[1];

                      verify(!field.required || ![undefined, null].includes(this[name]), "No value provided for mandatory field '".concat(name, "'"));
                    }

                  case 2:
                  case "end":
                    return _context10.stop();
                }
              }
            }, _callee9, this);
          }));

          function verify$1() {
            return _verify2.apply(this, arguments);
          }

          return verify$1;
        }()
      }, {
        key: "preSave",
        value: function () {
          var _preSave = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10() {
            return regeneratorRuntime.wrap(function _callee10$(_context11) {
              while (1) {
                switch (_context11.prev = _context11.next) {
                  case 0:
                  case "end":
                    return _context11.stop();
                }
              }
            }, _callee10);
          }));

          function preSave() {
            return _preSave.apply(this, arguments);
          }

          return preSave;
        }()
      }, {
        key: "preCreate",
        value: function () {
          var _preCreate = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
            return regeneratorRuntime.wrap(function _callee11$(_context12) {
              while (1) {
                switch (_context12.prev = _context12.next) {
                  case 0:
                  case "end":
                    return _context12.stop();
                }
              }
            }, _callee11);
          }));

          function preCreate() {
            return _preCreate.apply(this, arguments);
          }

          return preCreate;
        }()
      }, {
        key: "preUpdate",
        value: function () {
          var _preUpdate = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
            return regeneratorRuntime.wrap(function _callee12$(_context13) {
              while (1) {
                switch (_context13.prev = _context13.next) {
                  case 0:
                  case "end":
                    return _context13.stop();
                }
              }
            }, _callee12);
          }));

          function preUpdate() {
            return _preUpdate.apply(this, arguments);
          }

          return preUpdate;
        }()
      }, {
        key: "preDelete",
        value: function () {
          var _preDelete = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13() {
            return regeneratorRuntime.wrap(function _callee13$(_context14) {
              while (1) {
                switch (_context14.prev = _context14.next) {
                  case 0:
                  case "end":
                    return _context14.stop();
                }
              }
            }, _callee13);
          }));

          function preDelete() {
            return _preDelete.apply(this, arguments);
          }

          return preDelete;
        }()
      }, {
        key: "postSave",
        value: function () {
          var _postSave = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14() {
            return regeneratorRuntime.wrap(function _callee14$(_context15) {
              while (1) {
                switch (_context15.prev = _context15.next) {
                  case 0:
                  case "end":
                    return _context15.stop();
                }
              }
            }, _callee14);
          }));

          function postSave() {
            return _postSave.apply(this, arguments);
          }

          return postSave;
        }()
      }, {
        key: "postCreate",
        value: function () {
          var _postCreate = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15() {
            return regeneratorRuntime.wrap(function _callee15$(_context16) {
              while (1) {
                switch (_context16.prev = _context16.next) {
                  case 0:
                  case "end":
                    return _context16.stop();
                }
              }
            }, _callee15);
          }));

          function postCreate() {
            return _postCreate.apply(this, arguments);
          }

          return postCreate;
        }()
      }, {
        key: "postUpdate",
        value: function () {
          var _postUpdate = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee16() {
            return regeneratorRuntime.wrap(function _callee16$(_context17) {
              while (1) {
                switch (_context17.prev = _context17.next) {
                  case 0:
                  case "end":
                    return _context17.stop();
                }
              }
            }, _callee16);
          }));

          function postUpdate() {
            return _postUpdate.apply(this, arguments);
          }

          return postUpdate;
        }()
      }, {
        key: "postDelete",
        value: function () {
          var _postDelete = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee17() {
            return regeneratorRuntime.wrap(function _callee17$(_context18) {
              while (1) {
                switch (_context18.prev = _context18.next) {
                  case 0:
                  case "end":
                    return _context18.stop();
                }
              }
            }, _callee17);
          }));

          function postDelete() {
            return _postDelete.apply(this, arguments);
          }

          return postDelete;
        }()
      }, {
        key: "identifier",
        get: function get() {
          return this[this.constructor.idName];
        }
      }], [{
        key: "_getAttrs",
        value: function _getAttrs(params, attrs) {
          var _attrs = [];
          attrs.forEach(function (_ref3) {
            var _ref4 = _slicedToArray(_ref3, 2),
                attr = _ref4[0],
                value = _ref4[1];

            if (params[attr] === undefined) {
              _attrs.push(value);

              return;
            }

            var _value = params[attr];
            delete params[attr];

            _attrs.push(_value);
          });
          return _attrs;
        }
      }, {
        key: "get",
        value: function () {
          var _get = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee18() {
            var params,
                _this$_getAttrs,
                _this$_getAttrs2,
                skip,
                limit,
                sort,
                raiseE,
                sortObject,
                found,
                message,
                model,
                _args19 = arguments;

            return regeneratorRuntime.wrap(function _callee18$(_context19) {
              while (1) {
                switch (_context19.prev = _context19.next) {
                  case 0:
                    params = _args19.length > 0 && _args19[0] !== undefined ? _args19[0] : {};

                    /* eslint-disable no-unused-vars */
                    _this$_getAttrs = this._getAttrs(params, [["fields", null], ["eager", null], ["eagerL", null], ["map", false], ["rules", true], ["meta", false], ["build", true], ["fill", true], ["resolveA", null], ["skip", 0], ["limit", 0], ["sort", null], ["raiseE", true]]), _this$_getAttrs2 = _slicedToArray(_this$_getAttrs, 13), _this$_getAttrs2[0], _this$_getAttrs2[1], _this$_getAttrs2[2], _this$_getAttrs2[3], _this$_getAttrs2[4], _this$_getAttrs2[5], _this$_getAttrs2[6], _this$_getAttrs2[7], _this$_getAttrs2[8], skip = _this$_getAttrs2[9], limit = _this$_getAttrs2[10], sort = _this$_getAttrs2[11], raiseE = _this$_getAttrs2[12];
                    /* eslint-enable no-unused-vars */

                    sortObject = {};

                    if (sort) {
                      sort.forEach(function (_ref5) {
                        var _ref6 = _slicedToArray(_ref5, 2),
                            key = _ref6[0],
                            value = _ref6[1];

                        return sortObject[key] = value;
                      });
                    }

                    _context19.next = 6;
                    return this.collection.findOne(params, this.fields, {
                      skip: skip,
                      limit: limit,
                      sort: sortObject
                    });

                  case 6:
                    found = _context19.sent;

                    if (!(!found && raiseE)) {
                      _context19.next = 10;
                      break;
                    }

                    if (_isDevel()) {
                      message = "".concat(this.name, " not found for ").concat(JSON.stringify(params));
                    } else {
                      message = "".concat(this.name, " not found");
                    }

                    throw new NotFoundError(message);

                  case 10:
                    if (!found) {
                      _context19.next = 16;
                      break;
                    }

                    _context19.next = 13;
                    return new this().wrap(found);

                  case 13:
                    _context19.t0 = _context19.sent;
                    _context19.next = 17;
                    break;

                  case 16:
                    _context19.t0 = found;

                  case 17:
                    model = _context19.t0;
                    return _context19.abrupt("return", model);

                  case 19:
                  case "end":
                    return _context19.stop();
                }
              }
            }, _callee18, this);
          }));

          function get() {
            return _get.apply(this, arguments);
          }

          return get;
        }()
      }, {
        key: "find",
        value: function () {
          var _find = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee19() {
            var _this = this;

            var params,
                _this$_getAttrs3,
                _this$_getAttrs4,
                skip,
                limit,
                sort,
                raiseE,
                sortObject,
                found,
                message,
                models,
                _args20 = arguments;

            return regeneratorRuntime.wrap(function _callee19$(_context20) {
              while (1) {
                switch (_context20.prev = _context20.next) {
                  case 0:
                    params = _args20.length > 0 && _args20[0] !== undefined ? _args20[0] : {};

                    /* eslint-disable no-unused-vars */
                    _this$_getAttrs3 = this._getAttrs(params, [["fields", null], ["eager", null], ["eagerL", null], ["map", false], ["rules", true], ["meta", false], ["build", true], ["fill", true], ["resolveA", null], ["skip", 0], ["limit", 0], ["sort", null], ["raiseE", false]]), _this$_getAttrs4 = _slicedToArray(_this$_getAttrs3, 13), _this$_getAttrs4[0], _this$_getAttrs4[1], _this$_getAttrs4[2], _this$_getAttrs4[3], _this$_getAttrs4[4], _this$_getAttrs4[5], _this$_getAttrs4[6], _this$_getAttrs4[7], _this$_getAttrs4[8], skip = _this$_getAttrs4[9], limit = _this$_getAttrs4[10], sort = _this$_getAttrs4[11], raiseE = _this$_getAttrs4[12];
                    /* eslint-enable no-unused-vars */

                    this._findS(params);

                    this._findD(params);

                    sortObject = {};

                    if (sort) {
                      sort.forEach(function (_ref7) {
                        var _ref8 = _slicedToArray(_ref7, 2),
                            key = _ref8[0],
                            value = _ref8[1];

                        return sortObject[key] = value;
                      });
                    }

                    _context20.next = 8;
                    return this.collection.find(params, this.fields, {
                      skip: skip,
                      limit: limit,
                      sort: sortObject
                    });

                  case 8:
                    found = _context20.sent;

                    if (!(found.length === 0 && raiseE)) {
                      _context20.next = 12;
                      break;
                    }

                    if (_isDevel()) {
                      message = "".concat(this.name, " not found for ").concat(JSON.stringify(params));
                    } else {
                      message = "".concat(this.name, " not found");
                    }

                    throw new NotFoundError(message);

                  case 12:
                    _context20.next = 14;
                    return Promise.all(found.map(function (v) {
                      return new _this().wrap(v);
                    }));

                  case 14:
                    models = _context20.sent;
                    return _context20.abrupt("return", models);

                  case 16:
                  case "end":
                    return _context20.stop();
                }
              }
            }, _callee19, this);
          }));

          function find() {
            return _find.apply(this, arguments);
          }

          return find;
        }()
      }, {
        key: "_findD",
        value: function _findD(params) {
          // retrieves the find definition into a local variable, then
          // removes the find definition from the named arguments map
          // so that it's not going to be erroneously used by the
          // underlying find infra-structure
          var findD = params.find_d;
          delete params.find_d; // in case the find definition is currently not defined in the
          // named arguments map returns immediately as nothing is
          // meant to be done on this method

          if (!findD) return; // tries to retrieve the value of the operator that is going
          // to be used to "join" the multiple find parts (find values)

          var findO = params.find_o;
          delete params.find_o; // verifies that the data type for the find definition is a
          // valid sequence and in case its not converts it into one
          // so that it may be used in sequence valid logic

          var _findD = Array.isArray(findD) ? findD : [findD]; // iterates over all the filters defined in the filter definition
          // so that they may be used to update the provided arguments with
          // the filter defined in each of their lines


          var _iterator7 = _createForOfIteratorHelper(_findD),
              _step7;

          try {
            for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
              var filter = _step7.value;
              // in case the filter is not valid (unset or invalid) it's going
              // to be ignored as no valid information is present
              if (!filter) continue; // splits the filter string into its three main components
              // the name, operator and value, that are going to be processed
              // as defined by the specification to create the filter

              var result = filter.split(":", 3);
              if (result.length === 2) result.push(null); // unpacks the result into it's thee components name, operator
              // and value to be used in the parsing of the filter

              var _result = _slicedToArray(result, 3),
                  name = _result[0],
                  operator = _result[1],
                  value = _result[2]; // retrieves the definition for the filter attribute and uses
              // it to retrieve it's target data type that is going to be
              // used for the proper conversion, note that in case the base
              // type resolution method exists it's used (recursive resolution)


              var nameDefinition = this.definitionN(name);
              var nameT = nameDefinition._btype || nameDefinition.type || String; // determines if the current filter operation should be performed
              // using a case insensitive based approach to the search, by default
              // all of the operations are considered to be case sensitive

              var insensitive = INSENSITIVE[operator] || false; // retrieves the method that is going to be used for value mapping
              // or conversion based on the current operator and then converts
              // the operator into the domain specific operator

              var valueMethod = VALUE_METHODS[operator];

              var _operator = OPERATORS[operator] === undefined ? operator : OPERATORS[operator]; // in case there's a custom value mapped retrieved uses it to convert
              // the string based value into the target specific value for the query
              // otherwise uses the data type for the search field for value conversion


              var _value = valueMethod ? valueMethod(value, nameT) : nameT(value); // constructs the custom find value using a key and value map value
              // in case the operator is defined otherwise (operator not defined)
              // the value is used directly, then merges this find value into the
              // current set of filters for the provided (keyword) arguments


              var findV = void 0;

              if (_operator) {
                var obj = {};
                obj[_operator] = _value;
                findV = obj;
              } else {
                findV = _value;
              }

              if (insensitive) findV.$options = "-i";

              this._filterMerge(name, findV, params, findO);
            }
          } catch (err) {
            _iterator7.e(err);
          } finally {
            _iterator7.f();
          }
        }
      }, {
        key: "_findS",
        value: function _findS(params) {
          // tries to retrieve the find name value from the provided
          // named arguments defaulting to an unset value otherwise
          var findN = params.find_n;
          delete params.find_n; // retrieves the kind of insensitive strategy that is going
          // to be used for the resolution of regular expressions,
          // this should affect all the filters and so it should be
          // used with some amount of care

          var findI = params.find_i || false;
          delete params.find_i; // retrieves the kind of default operation to be performed
          // this may be either: right, left or both and the default
          // value is both so that the token is matched in case it
          // appears anywhere in the search string

          var findT = params.find_t || "both";
          delete params.find_t; // retrieves the find string into a local variable, then
          // removes the find string from the named arguments map
          // so that it's not going to be erroneously used by the
          // underlying find infra-structure

          var findS = params.find_s;
          delete params.find_s; // in case the find string is currently not defined in the
          // named arguments map returns immediately as nothing is
          // meant to be done on this method

          if (!findS) return; // retrieves the "name" of the attribute that is considered
          // to be the default (representation) for the model in case
          // there's none returns immediately, as it's not possible
          // to proceed with the filter creation

          var defaultName = findN || this["default"]; // TODO DEFAULT WORKS?

          if (!defaultName) return; // constructs the proper right and left parts of the regex
          // that is going to be constructed for the matching of the
          // value, this is achieved by checking the find type

          var right = findT === "right" ? "^" : "";
          var left = findT === "left" ? "$" : ""; // retrieves the definition for the default attribute and uses
          // it to retrieve it's target data type, defaulting to the
          // string type in case none is defined in the schema

          var defaultT = this.definitionN(defaultName).type || String;
          var findV;

          try {
            // in case the target date type for the default field is
            // string the both sides wildcard regex is used for the
            // search
            if (defaultT === String) {
              findV = {
                $regex: right + escapeStringRegexp(findS) + left,
                $options: findI ? "-i" : ""
              };
            } else {
              findV = null;
            }
          } catch (err) {
            // in case there's an error in the conversion for
            // the target type value sets the search value as
            // invalid (not going to be used in filter)
            findV = null;
          }

          if (findV) this._filterMerge(defaultName, findV, params);
        }
      }, {
        key: "fields",
        get: function get() {
          return Object.keys(this.schema);
        }
      }, {
        key: "default",
        get: function get() {
          var defaultEntry = Object.entries(this.schema).find(function (_ref9) {
            var _ref10 = _slicedToArray(_ref9, 2);
                _ref10[0];
                var definition = _ref10[1];

            return definition["default"];
          });
          return defaultEntry ? defaultEntry[0] : null;
        }
      }, {
        key: "definitionN",
        value: function definitionN(name) {
          return this.schema[name] || {};
        }
      }, {
        key: "_filterMerge",
        value: function _filterMerge(name, filter, params) {
          var operator = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
          // retrieves a possible previous filter defined for the
          // provided name in case it does exist must concatenate
          // that previous value in a join statement according to
          // the currently defined operator
          var filterP = params[name];

          if (filterP || operator) {
            // defaults the operator for the join of the names to the
            // value and then ensures that the value of the operator
            // is within a valid range of values
            var _operator = operator || "$and";

            verify(["$and", "$or"].includes(_operator)); // retrieves the and references for the current arguments
            // and appends the two filter values (current and previous)
            // then deletes the current name reference in the arguments
            // and updates the name value to the and value


            var filterA = params[_operator] || []; // builds the filter object assigned to the name of the
            // variable and adds to the list of values

            var _filter = {};
            _filter[name] = filter;
            filterA.push(_filter); // in case there's a previous filter also adds it to the
            // list of filter values

            if (filterP) {
              var _filterP = {};
              _filterP[name] = filterP;
              filterA.push(_filterP);
            } // updates the filter reference and updates the operator
            // name (as expected)


            filter = filterA;
            delete params[name];
            name = _operator;
          } // sets the currently defined filter structures in the keyword
          // based arguments map for the currently defined name


          params[name] = filter;
        }
      }, {
        key: "schema",
        get: function get() {
          throw new NotImplementedError();
        }
        /**
         * Safer version of the schema structure that filters
         * some of the field attributes making it suitable to
         * be used by some of the collection adapters.
         */

      }, {
        key: "schemaSafe",
        get: function get() {
          var schema = {};

          for (var _i5 = 0, _Object$entries4 = Object.entries(this.schema); _i5 < _Object$entries4.length; _i5++) {
            var _Object$entries4$_i = _slicedToArray(_Object$entries4[_i5], 2),
                key = _Object$entries4$_i[0],
                value = _Object$entries4$_i[1];

            schema[key] = {
              type: value.type || String,
              index: value.index || false
            };
          }

          return schema;
        }
      }, {
        key: "collection",
        get: function get() {
          if (this._collectionI) return this._collectionI;
          this._collectionI = this._collection(this.dataOptions);
          return this._collectionI;
        }
      }, {
        key: "idName",
        get: function get() {
          return "id";
        }
      }, {
        key: "dataOptions",
        get: function get() {
          return {
            name: this.name,
            schema: this.schemaSafe
          };
        }
      }, {
        key: "increments",
        get: function get() {
          if (this._increments !== undefined) return this._increments;
          var increments = [];

          for (var _i6 = 0, _Object$entries5 = Object.entries(this.schema); _i6 < _Object$entries5.length; _i6++) {
            var _Object$entries5$_i = _slicedToArray(_Object$entries5[_i6], 2),
                name = _Object$entries5$_i[0],
                value = _Object$entries5$_i[1];

            var isIncrement = value.increment || false;
            if (!isIncrement) continue;
            increments.push(name);
          }

          this._increments = increments;
          return increments;
        }
      }, {
        key: "_collection",
        value: function _collection(options) {
          var adapter = this.adapter[0].toUpperCase() + this.adapter.slice(1);
          return new collection[adapter + "Collection"](options);
        }
      }, {
        key: "_increment",
        value: function () {
          var _increment2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee20(name) {
            var _name, store, result;

            return regeneratorRuntime.wrap(function _callee20$(_context21) {
              while (1) {
                switch (_context21.prev = _context21.next) {
                  case 0:
                    _name = this.name + ":" + name;
                    store = this._collection({
                      name: "counters",
                      schema: {
                        id: {
                          type: String,
                          index: true
                        },
                        seq: {
                          type: Number
                        }
                      }
                    });
                    _context21.next = 4;
                    return store.findOneAndUpdate({
                      id: _name
                    }, {
                      $inc: {
                        seq: 1
                      }
                    }, {
                      "new": true,
                      upsert: true
                    });

                  case 4:
                    result = _context21.sent;
                    _context21.t0 = result;

                    if (_context21.t0) {
                      _context21.next = 10;
                      break;
                    }

                    _context21.next = 9;
                    return store.findOne({
                      id: _name
                    });

                  case 9:
                    _context21.t0 = _context21.sent;

                  case 10:
                    result = _context21.t0;
                    return _context21.abrupt("return", result.seq);

                  case 12:
                  case "end":
                    return _context21.stop();
                }
              }
            }, _callee20, this);
          }));

          function _increment(_x4) {
            return _increment2.apply(this, arguments);
          }

          return _increment;
        }()
      }, {
        key: "_ensureMin",
        value: function () {
          var _ensureMin2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee21(name, value) {
            var _name, store, result;

            return regeneratorRuntime.wrap(function _callee21$(_context22) {
              while (1) {
                switch (_context22.prev = _context22.next) {
                  case 0:
                    _name = this.name + ":" + name;
                    store = this._collection({
                      name: "counters",
                      schema: {
                        id: {
                          type: String
                        },
                        seq: {
                          type: Number
                        }
                      }
                    });
                    _context22.next = 4;
                    return store.findOneAndUpdate({
                      id: _name
                    }, {
                      $max: {
                        seq: value
                      }
                    }, {
                      "new": true,
                      upsert: true
                    });

                  case 4:
                    result = _context22.sent;
                    _context22.t0 = result;

                    if (_context22.t0) {
                      _context22.next = 10;
                      break;
                    }

                    _context22.next = 9;
                    return store.findOne({
                      id: _name
                    });

                  case 9:
                    _context22.t0 = _context22.sent;

                  case 10:
                    result = _context22.t0;
                    return _context22.abrupt("return", result.seq);

                  case 12:
                  case "end":
                    return _context22.stop();
                }
              }
            }, _callee21, this);
          }));

          function _ensureMin(_x5, _x6) {
            return _ensureMin2.apply(this, arguments);
          }

          return _ensureMin;
        }()
      }]);

      return ModelStore;
    }(Model);
    var ModelMemory = /*#__PURE__*/function (_ModelStore) {
      _inherits(ModelMemory, _ModelStore);

      var _super2 = _createSuper(ModelMemory);

      function ModelMemory() {
        _classCallCheck(this, ModelMemory);

        return _super2.apply(this, arguments);
      }

      _createClass(ModelMemory, null, [{
        key: "adapter",
        get: function get() {
          return "memory";
        }
      }, {
        key: "dataOptions",
        get: function get() {
          return Object.assign(_get(_getPrototypeOf(ModelMemory), "dataOptions", this), {
            storage: this.storage
          });
        }
      }, {
        key: "storage",
        get: function get() {
          return MEMORY_STORAGE[this.name];
        }
      }]);

      return ModelMemory;
    }(ModelStore);
    /**
     * Retrieves the default (initial) value for the a certain
     * provided data type falling back to the provided default
     * value in case it's not possible to retrieve a new valid
     *  default for value for the type.
     *
     * The process of retrieval of the default value to a certain
     * type may include the calling of a lambda function to obtain
     * a new instance of the default value, this avoid the usage
     * of global shared structures for the default values, that
     * could cause extremely confusing situations.
     *
     * @param {Type} type The data type object for which to retrieve its
     * default value.
     * @param {Object} _default The default value to be returned in case it's
     * not possible to retrieve a better one.
     * @returns {Object} The "final" default value for the data type according
     * to the best possible strategy.
     */

    var typeD = function typeD(type) {
      var _default = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if (TYPE_DEFAULTS[type] === undefined) return _default;
      _default = TYPE_DEFAULTS[type];
      if (typeof _default !== "function") return _default;
      return _default();
    };

    var ensureExpress = function ensureExpress(token) {
      return function (req, res, next) {
        ensurePermissions(token, req)["catch"](next).then(next);
      };
    };

    var ensureFastify = function ensureFastify(token) {
      return function (req, res, next) {
        ensurePermissions(token, req)["catch"](next).then(next);
      };
    };

    var yoniusRollup = function yoniusRollup() {
      return {
        name: "yonius",
        resolveId: function resolveId(importee) {
          switch (importee) {
            case "fs":
            case "node-fetch":
              return importee;

            default:
              return null;
          }
        },
        load: function load(id) {
          switch (id) {
            case "fs":
              return "export const promises = {};";

            case "node-fetch":
              return "export default fetch;";

            default:
              return null;
          }
        }
      };
    };

    var NAME = name;
    var VERSION = version$1;

    exports.ALIAS = ALIAS;
    exports.API = API;
    exports.Collection = Collection;
    exports.FIND_DEFAULTS = FIND_DEFAULTS;
    exports.FIND_TYPES = FIND_TYPES;
    exports.FileTuple = FileTuple;
    exports.INSENSITIVE = INSENSITIVE;
    exports.MixinBuilder = MixinBuilder;
    exports.Model = Model;
    exports.ModelMemory = ModelMemory;
    exports.ModelStore = ModelStore;
    exports.MongoCollection = MongoCollection;
    exports.NAME = NAME;
    exports.NotFoundError = NotFoundError;
    exports.NotImplementedError = NotImplementedError;
    exports.OAuth1API = OAuth1API;
    exports.OAuth2API = OAuth2API;
    exports.OAuthAPI = OAuthAPI;
    exports.OPERATORS = OPERATORS;
    exports.Observable = Observable;
    exports.OperationalError = OperationalError;
    exports.SORT_MAP = SORT_MAP;
    exports.VALUE_METHODS = VALUE_METHODS;
    exports.VERSION = VERSION;
    exports.ValidationError = ValidationError;
    exports.YoniusError = YoniusError;
    exports._castR = _castR;
    exports._isDevel = _isDevel;
    exports._isSecure = _isSecure;
    exports._isValid = _isValid;
    exports.absoluteUrl = absoluteUrl;
    exports.camelToUnderscore = camelToUnderscore;
    exports.conf = conf;
    exports.confP = confP;
    exports.confS = confS;
    exports.destroyMongo = destroyMongo;
    exports.ensureExpress = ensureExpress;
    exports.ensureFastify = ensureFastify;
    exports.ensurePermissions = ensurePermissions;
    exports.eq = eq;
    exports.equal = equal;
    exports.escapeStringRegexp = escapeStringRegexp;
    exports.expandUser = expandUser;
    exports.getEnv = getEnv;
    exports.getEnvObject = getEnvObject;
    exports.getObject = getObject;
    exports.globals = globals;
    exports.gt = gt;
    exports.gte = gte;
    exports.initMongo = initMongo;
    exports.isEmail = isEmail;
    exports.isIn = isIn;
    exports.isLower = isLower;
    exports.isPrimitive = isPrimitive;
    exports.isRegex = isRegex;
    exports.isSimple = isSimple;
    exports.isUpper = isUpper;
    exports.isUrl = isUrl;
    exports.load = load;
    exports.loadConf = load$1;
    exports.mix = mix;
    exports.notEmpty = notEmpty;
    exports.pathExists = pathExists;
    exports.register = register;
    exports.request = request;
    exports.sizeRoundUnit = sizeRoundUnit;
    exports.stringEq = stringEq;
    exports.stringGt = stringGt;
    exports.stringLt = stringLt;
    exports.toTokensM = toTokensM;
    exports.typeD = typeD;
    exports.typeof_ = typeof_;
    exports.unload = unload;
    exports.unregister = unregister;
    exports.urlEncode = urlEncode;
    exports.verify = verify;
    exports.verifyEqual = verifyEqual;
    exports.verifyMany = verifyMany;
    exports.verifyNotEqual = verifyNotEqual;
    exports.yoniusRollup = yoniusRollup;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yonius.umd.js.map
